<?php


class Google_Map_Widget extends WP_Widget {

	public function __construct() {
		
		parent::__construct(	'google_map_widget', 
								'Google Map Widget', 
								array('description' => __('Display location on Google Map.','text_domain'),)
							);
	}

 	public function form( $instance ) {
		
		if (isset($instance['title'])) { $title = $instance[ 'title' ]; }
			else { $title = __( 'Directions', 'text_domain' ); }
		
		if (isset($instance['map_code'])) { $map_code = $instance[ 'map_code' ]; }
			else { $map_code = ''; }
		?>
        
		<p>
        <label for="<?php echo $this->get_field_id( 'title' ); ?>"><?php _e( 'Title:', 'ns_theme' ); ?></label> 
		<input class="widefat" id="<?php echo $this->get_field_id( 'title' ); ?>" name="<?php echo $this->get_field_name( 'title' ); ?>" type="text" value="<?php echo esc_attr( $title ); ?>" />
		<label for="<?php echo $this->get_field_id('map_code');?>"><?php _e('Google Map Code:', 'ns_theme');?></label>
        <textarea id="<?php echo $this->get_field_id( 'map_code' ); ?>" class="widefat" style="width:100%;" rows="10" cols="20" name="<?php echo $this->get_field_name( 'map_code' ); ?>" ><?php echo esc_attr( $map_code ); ?></textarea>
		</p>
		<?php 
	}

	public function update( $new_instance, $old_instance ) {
		
		$instance = array();
		$instance['title'] = strip_tags( $new_instance['title'] );
		$instance['map_code'] = stripslashes( $new_instance['map_code'] );//$new_instance['map_code'];//

		return $instance;
	}
	
	public function widget( $args, $instance ) {

		extract( $args );
		$title = apply_filters( 'widget_title', $instance['map_code'] );
		
		echo $before_widget = '<h1 class="as-main">'.$instance['title'].'</h1><div class="contactus-map with-shadow">';
		echo $map_code = $instance['map_code'];
		echo $after_widget = '</div>';
	}

}


class WP_479AM_Side_Widget extends WP_Widget {
	
	public function __construct() {
	
		parent::__construct(	'479_am_side_widget', 
								'Novus Side', 
								array( 'description' => __( 'Display the Sub pages.', 'text_domain' ), )
							);
		
	}

	
 	public function form( $instance ) {
		
		if (isset($instance['title'])) { $title = $instance['title']; }
		else { $title = __( 'Sub pages', 'text_domain' ); }
			
		/*if (isset($instance['num_of_cat'])) { $num_of_cat = $instance['num_of_cat']; }
		else { $num_of_cat = '5'; }*/
		?>
		<p>
		<label for="<?php echo $this->get_field_id( 'title' ); ?>"><?php _e( 'Title :', 'ns_theme' ); ?></label><br />
        <input class="widefat" id="<?php echo $this->get_field_id( 'title' ); ?>" name="<?php echo $this->get_field_name( 'title' ); ?>" type="text" value="<?php echo esc_attr( $title ); ?>" />
        <?php /* ?><!--<label for="<?php echo $this->get_field_id( 'num_of_cat' ); ?>"><?php _e( 'Categories :', "cavus_theme" ); ?></label>
		<input class="widefat" id="<?php echo $this->get_field_id( 'num_of_cat' ); ?>" name="<?php echo $this->get_field_name( 'num_of_cat' ); ?>" type="text" value="<?php echo esc_attr( $num_of_cat ); ?>" />--><?php */?>
		</p>
		<?php 
	}

	public function update( $new_instance, $old_instance ) {
		
		$instance = array();
		$instance['title'] = strip_tags( $new_instance['title'] );
		//$instance['num_of_cat'] = strip_tags( $new_instance['num_of_cat'] );

		return $instance;
	}
	
	public function widget( $args, $instance ) {

		extract( $args );
		$title = apply_filters( 'widget_title', $instance['title'] );
		
		global $ns_options_frnt;
		$portfolio_cat = $ns_options_frnt['ns_pf_cat_slug'];
		$cat_id = get_category_by_slug($portfolio_cat); 
		$id = $cat_id->term_id;
		
		$args = array(
						'show_option_all'    => '',
						'orderby'            => 'name',
						'order'              => 'ASC',
						'show_last_update'   => 0,
						'style'              => 'list',
						'show_count'         => 1,
						'hide_empty'         => 1,
						'use_desc_for_title' => 1,
						'child_of'           => 0,
						'feed'               => '',
						'feed_type'          => '',
						'feed_image'         => '',
						'exclude'            => $id,
						'exclude_tree'       => '',
						'include'            => '',
						'hierarchical'       => true,
						'title_li'           => __( '', 'ns_theme' ),
						'show_option_none'   => __('No categories', 'ns_theme'),
						'number'             => NULL,
						'echo'               => 1,
						'depth'              => 0,
						'current_category'   => 0,
						'pad_counts'         => 0,
						'taxonomy'           => 'category'
					); 
		echo $before_widget = '<nav class="categories">
									<h2 class="blue">'.$title.'</h2>
									<ul>';
										wp_list_categories( $args );
									
		echo $after_widget = '		</ul>
					          </nav>';
		
	}

}



class WP_479AM_Category_Widget extends WP_Widget {
	
	public function __construct() {
	
		parent::__construct(	'479_am_category_widget', 
								'Novus Category', 
								array( 'description' => __( 'Display the Categories.', 'text_domain' ), )
							);
		
	}

 	public function form( $instance ) {
		
		if (isset($instance['title'])) { $title = $instance['title']; }
		else { $title = __( 'Categories', 'text_domain' ); }
			
		/*if (isset($instance['num_of_cat'])) { $num_of_cat = $instance['num_of_cat']; }
		else { $num_of_cat = '5'; }*/
		?>
		<p>
		<label for="<?php echo $this->get_field_id( 'title' ); ?>"><?php _e( 'Title :', 'ns_theme' ); ?></label><br />
        <input class="widefat" id="<?php echo $this->get_field_id( 'title' ); ?>" name="<?php echo $this->get_field_name( 'title' ); ?>" type="text" value="<?php echo esc_attr( $title ); ?>" />
        <?php /* ?><!--<label for="<?php echo $this->get_field_id( 'num_of_cat' ); ?>"><?php _e( 'Categories :', "cavus_theme" ); ?></label>
		<input class="widefat" id="<?php echo $this->get_field_id( 'num_of_cat' ); ?>" name="<?php echo $this->get_field_name( 'num_of_cat' ); ?>" type="text" value="<?php echo esc_attr( $num_of_cat ); ?>" />--><?php */?>
		</p>
		<?php 
	}

	public function update( $new_instance, $old_instance ) {
		
		$instance = array();
		$instance['title'] = strip_tags( $new_instance['title'] );
		//$instance['num_of_cat'] = strip_tags( $new_instance['num_of_cat'] );

		return $instance;
	}
	
	public function widget( $args, $instance ) {

		extract( $args );
		$title = apply_filters( 'widget_title', $instance['title'] );
		
		global $ns_options_frnt;
		$portfolio_cat = $ns_options_frnt['ns_pf_cat_slug'];
		$cat_id = get_category_by_slug($portfolio_cat); 
		$id = $cat_id->term_id;
		
		$args = array(
						'show_option_all'    => '',
						'orderby'            => 'name',
						'order'              => 'ASC',
						'show_last_update'   => 0,
						'style'              => 'list',
						'show_count'         => 1,
						'hide_empty'         => 1,
						'use_desc_for_title' => 1,
						'child_of'           => 0,
						'feed'               => '',
						'feed_type'          => '',
						'feed_image'         => '',
						'exclude'            => $id,
						'exclude_tree'       => '',
						'include'            => '',
						'hierarchical'       => true,
						'title_li'           => __( '', 'ns_theme' ),
						'show_option_none'   => __('No categories', 'ns_theme'),
						'number'             => NULL,
						'echo'               => 1,
						'depth'              => 0,
						'current_category'   => 0,
						'pad_counts'         => 0,
						'taxonomy'           => 'category'
					); 
		echo $before_widget = '<nav class="categories">
									<h2 class="blue">'.$title.'</h2>
									<ul>';
										wp_list_categories( $args );
									
		echo $after_widget = '		</ul>
					          </nav>';
		
	}

}


class WP_Cavus_Archives_Widget extends WP_Widget {

	public function __construct() {
		
		parent::__construct(	'cavus_archives_widget', 
								'Novus Archives', 
								array( 'description' => __( 'Display the Archive.', 'text_domain' ), )
							);
	}

 	public function form( $instance ) {
		
		if (isset($instance['title'])) { $title = $instance['title']; }
		else { $title = __( 'Categories', 'text_domain' ); }
		?>
		<p>
		<label for="<?php echo $this->get_field_id( 'title' ); ?>"><?php _e( 'Title :', 'ns_theme' ); ?></label><br />
        <input class="widefat" id="<?php echo $this->get_field_id( 'title' ); ?>" name="<?php echo $this->get_field_name( 'title' ); ?>" type="text" value="<?php echo esc_attr( $title ); ?>" />
		</p>
		<?php 
	}

	public function update( $new_instance, $old_instance ) {
		
		$instance = array();
		$instance['title'] = strip_tags( $new_instance['title'] );

		return $instance;
	}
	
	public function widget( $args, $instance ) {
		
		extract( $args );
		$title = apply_filters( 'widget_title', $instance['title'] );
		
		global $ns_options_frnt;
		$portfolio_cat = $ns_options_frnt['ns_pf_cat_slug'];
		$cat_id = get_category_by_slug($portfolio_cat); 
		$id = $cat_id->term_id;
		
		$args = array(
						'type'            => 'monthly',
						'limit'           => '',
						'format'          => 'html', 
						'before'          => '',
						'after'           => '',
						'show_post_count' => false,
						'echo'            => 1
					);
	
					
		echo $before_widget = '		<nav><h2 class="blue">'.__('Archives', 'ns_theme').'</h2>
            						<ul>';
										wp_get_archives( $args );
		echo $after_widget = '		</ul>
								</nav>';
		
	}

}


///------------------------- START Tweets Widget ---------------------------------////



class ns_latest_twitter_widget extends WP_Widget {

	function ns_latest_twitter_widget() {
		// widget actual processes
		parent::WP_Widget( /* Base ID */'ns_latest_twitter_widget', /* Name */'Novus Latest Twitter Widget', array( 'description' => 'For Footer' ) );
	}

	function form($instance) {
		// outputs the options form on admin
		if ( !function_exists('quot') ){
			function quot($txt){
				return str_replace( "\"", "&quot;", $txt );
			}
		}

		// format some of the options as valid html
		$username = htmlspecialchars($instance['user'], ENT_QUOTES);
		$updateCount = htmlspecialchars($instance['count'], ENT_QUOTES);
		$showTwitterIconTF = $instance['showTwitterIconTF'];
		$showProfilePicTF = $instance['showProfilePicTF'];
		$showTweetTimeTF = $instance['showTweetTimeTF'];
		$widgetTitle = stripslashes(quot($instance['widgetTitle']));
		$includeRepliesTF = $instance['includeRepliesTF'];
	?>
		<p>
		
			<label for="<?php echo $this->get_field_id('user'); ?>" style="line-height:35px;display:block;">Twitter user: @<input type="text" size="12" id="<?php echo $this->get_field_id('user'); ?>" name="<?php echo $this->get_field_name('user'); ?>" value="<?php echo $username; ?>" /></label>
			<label for="<?php echo $this->get_field_id('count'); ?>" style="line-height:35px;display:block;">Show <input type="text" id="<?php echo $this->get_field_id('count'); ?>" size="2" name="<?php echo $this->get_field_name('count'); ?>" value="<?php echo $updateCount; ?>" /> twitter updates</label>
			<label for="<?php echo $this->get_field_id('widgetTitle'); ?>" style="line-height:35px;display:block;">Widget title: <input type="text" id="<?php echo $this->get_field_id('widgetTitle'); ?>" size="16" name="<?php echo $this->get_field_name('widgetTitle'); ?>" value="<?php echo $widgetTitle; ?>" /></label>
			 
             <!--
            <p>&nbsp;</p>
			<p><input type="radio" id="<?php echo $this->get_field_id('showTwitterIconTF'); ?>" value="icon" name="<?php echo $this->get_field_name('showIconOrPic'); ?>"<?php if($showTwitterIconTF){ ?> checked="checked"<?php } ?>><label for="<?php echo $this->get_field_id('showTwitterIconTF'); ?>"> Show twitter icon</label></p>
				 
                	<p><input type="radio" id="<?php echo $this->get_field_id('showProfilePicTF'); ?>" value="pic" name="<?php echo $this->get_field_name('showIconOrPic'); ?>"<?php if($showProfilePicTF){ ?> checked="checked"<?php } ?>><label for="<?php echo $this->get_field_id('showProfilePicTF'); ?>"> Show profile picture</label></p>
                 
		 	<p><input type="radio" id="latest-twitter-showNeitherImageTF" value="none" name="<?php echo $this->get_field_name('showIconOrPic'); ?>"<?php if((!$showProfilePicTF) && (!$showTwitterIconTF)){ ?> checked="checked"<?php } ?>><label for="latest-twitter-showNeitherImageTF"> Show no image</label></p> 
			
            
            <p>&nbsp;</p> -->
			<p><input type="checkbox" id="<?php echo $this->get_field_id('showTweetTimeTF'); ?>" value="1" name="<?php echo $this->get_field_name('showTweetTimeTF'); ?>"<?php if($showTweetTimeTF){ ?> checked="checked"<?php } ?>> <label for="<?php echo $this->get_field_id('showTweetTimeTF'); ?>">Show tweeted "time ago"</label></p>  
			<!-- 
            <p><input type="checkbox" id="<?php echo $this->get_field_id('includeRepliesTF'); ?>" value="1" name="<?php echo $this->get_field_name('includeRepliesTF'); ?>"<?php if($includeRepliesTF){ ?> checked="checked"<?php } ?>> <label for="<?php echo $this->get_field_id('includeRepliesTF'); ?>">Include replies</label></p> 
           
			<p>&nbsp;</p>
            -->
			
		</p>
<?php
	}

	function update($new_instance, $old_instance) {
		// processes widget options to be saved
		$instance = $old_instance;
		$instance['user'] = esc_html($new_instance['user']);
		$instance['count'] = esc_html($new_instance['count']);
		$instance['widgetTitle'] = esc_html( $new_instance['widgetTitle']);
		$instance['showTwitterIconTF'] = false;
		$instance['showProfilePicTF'] = false;
		switch( $new_instance['showIconOrPic'] ){
			case "icon":
				$instance['showTwitterIconTF'] = true;
				break;
			case "pic":
				$instance['showProfilePicTF'] = true;
				break;
			case "none":
				break;
		}
		if( $new_instance['showTweetTimeTF']=="1"){
			$instance['showTweetTimeTF'] = true;
		} else{
			$instance['showTweetTimeTF'] = false;
		}
		if( $new_instance['includeRepliesTF']=="1"){
			$instance['includeRepliesTF'] = true;
		} else{
			$instance['includeRepliesTF'] = false;
		}
		return $instance;
	}

	function widget($args, $instance) {
		// outputs the content of the widget
		extract($args, EXTR_SKIP);
		//default to my twitter name
		$profilePicFileName = '' ;
		$username = empty($instance['user']) ? "salzano" : $instance['user'];
		$updateCount = empty($instance['count']) ? 3 : $instance['count'];
		$showProfilePicTF = $instance['showProfilePicTF'];
		$showTwitterIconTF = $instance['showTwitterIconTF'];
		$showTweetTimeTF = $instance['showTweetTimeTF'];
		$title = $instance['widgetTitle'];
		$includeRepliesTF = $instance['includeRepliesTF'];

		$jsonFileName = "$username.json";
		$jsonTempFileName = "$username.json.tmp";
		$jsonURL = "http://api.twitter.com/1/statuses/user_timeline.json?screen_name=$username&include_entities=true";

		//have we fetched twitter data in the last half hour?
		if( $this->file_missing_or_old( $jsonFileName, .5 )){
			//get new data from twitter
			$jsonData = $this->save_remote_file( $jsonURL, $jsonFileName );
		} else{
			//already have file, get the data out of it
			$jsonData = $this->get_json_data_from_file( $jsonFileName );
		}

		// check for errors--rate limit or curl not installed
		// data returned will be: {"error":"Rate limit exceeded. Clients may not make more than 150 requests per hour.","request":"\/1\/statuses\/user_timeline.json?screen_name=salzano&include_entities=true"}

		if( $jsonData == "" || iconv_strlen( @$tweets->error, "UTF-8" )){
			//delete the json file so it will surely be downloaded on next page view
			if( @file_exists( dirname(__FILE__) ."/". $jsonFileName )){
				@unlink( dirname(__FILE__) ."/". $jsonFileName );
			}
			//get the backup data
			$jsonData = $this->get_json_data_from_file( $jsonTempFileName );
		} else{
			//good file, create a backup
			if( @file_exists( dirname(__FILE__) . "/" . $jsonFileName )){
				@copy( dirname(__FILE__) . "/" . $jsonFileName, dirname(__FILE__) . "/" . $jsonTempFileName );
			}
		}

		if( $tweets = json_decode( $jsonData )){
			$haveTwitterData = true;
		} else{
			//tweets is null
			$haveTwitterData = false;
		}

		//  $tweets has been json_decoded

		if( $haveTwitterData && $showProfilePicTF ){
			//make sure we have the profile picture saved locally
			$twitterUserData = $tweets[0]->user;
			$profilePicURL = $twitterUserData->profile_image_url;
			$profilePicPieces = explode( ".", $profilePicURL );
			$profilePicExt = end( $profilePicPieces );
			$profilePicFileName = $username . "." . $profilePicExt;
			if( $this->file_missing_or_old( $profilePicFileName, .5 )){
				$this->save_remote_file( $profilePicURL, $profilePicFileName );
			}
		}

		// output the widget
		$title = empty($title) ? '&nbsp;' : apply_filters('widget_title', $title);
		echo $before_widget;
		if( !empty( $title ) && $title != "&nbsp;" ) { echo $before_title . $title . '<a id="twit" title="" href="https://twitter.com/'.$username.'">follow</a>' . $after_title; };
		if( $haveTwitterData ){
			$linkHTML = "<a href=\"http://twitter.com/".$username."\">";
			$pluginURL = home_url()."/wp-content/plugins/latest-twitter-sidebar-widget/";
			$icon = $pluginURL . "twitter.png";
			$pic = $pluginURL . $profilePicFileName;
			if( $showTwitterIconTF ){
				//echo $linkHTML . "<img id=\"latest-twitter-widget-icon\" src=\"".$icon."\" alt=\"t\"></a>";
			} else{
				if( $showProfilePicTF ){
					//echo $linkHTML . "<img id=\"latest-twitter-widget-pic\" src=\"".$pic."\" alt=\"\"></a>";
				}
			}
			$i=1;
			echo '<div class="twitter-list">  	<ul class="tweet_list"> ';
			foreach( $tweets as $tweet ){
				//exit this loop if we have reached updateCount
				if( $i > $updateCount ){ break; }
				//skip this iteration of the loop if this is a reply and we are not showing replies
				if( !$includeRepliesTF && strlen( $tweet->in_reply_to_screen_name )){ 		continue;	}
				echo "<li class=\"latest-twitter-tweet tweet_first\">" ;
				
				// echo "<span class=\"latest-twitter-tweet-time tweet_text\" /> &quot;" . $this->fix_twitter_update( $tweet->text, $tweet->entities ) . "&quot;</span> </li>";
				echo "<span class=\"latest-twitter-tweet-time tweet_text\" >" . $this->fix_twitter_update( $tweet->text, $tweet->entities ) . "</span> ";
				if($i < $updateCount){
					echo '<div class="hr"></div>';
				}
				
				
				if( $showTweetTimeTF ){
					// echo '<span class="tweet_time">'.$linkHTML.$this->twitter_time_ltw( $tweet->created_at ).'</a></span>';
					echo '<span class="tweet_time">'.$this->twitter_time_ltw( $tweet->created_at ).'</span>';
					//echo $linkHTML ."<span class=\"latest-twitter-tweet-time tweet_time\" id=\"latest-twitter-tweet-time-" . $i . "\">" .$this->twitter_time_ltw( $tweet->created_at ) . " </span> </a>";
				}
				echo "</li>";
				
				
				$i++;
			}
			
			echo "</ul></div>";
			
			
			
		} else{
			echo "have data = false $jsonData";
		}
		//show this no matter what, tweets or no tweets
		//echo "<div id=\"latest-twitter-follow-link\"><a href=\"http://twitter.com/$username\">follow @$username on twitter</a></div>";
		echo $after_widget;
	}

	function fix_twitter_update($origTweet,$entities) {
		$index = array();
		if( $entities == null ){ return $origTweet; }
		foreach( $entities->urls as $url ){
			$index[$url->indices[0]] = "<a href=\"".$url->url."\">".$url->url."</a>";
			$endEntity[(int)$url->indices[0]] = (int)$url->indices[1];
		}
		foreach( $entities->hashtags as $hashtag ){
			$index[$hashtag->indices[0]] = "<a href=\"http://twitter.com/#!/search?q=%23".$hashtag->text."\">#".$hashtag->text."</a>";
			$endEntity[$hashtag->indices[0]] = $hashtag->indices[1];
		}
		foreach( $entities->user_mentions as $user_mention ){
			$index[$user_mention->indices[0]] = "<a href=\"http://twitter.com/".$user_mention->screen_name."\">@".$user_mention->screen_name."</a>";
			$endEntity[$user_mention->indices[0]] = $user_mention->indices[1];
		}
		$fixedTweet="";
		for($i=0;$i<iconv_strlen($origTweet, "UTF-8" );$i++){
			if(iconv_strlen(@$index[(int)$i], "UTF-8" )>0){
				$fixedTweet .= $index[(int)$i];
				$i = $endEntity[(int)$i]-1;
			} else{
				$fixedTweet .= iconv_substr( $origTweet,$i,1, "UTF-8" );
			}
		}
		return $fixedTweet;
	}

	function twitter_time_ltw($a) {
		//get current timestamp
		$b = strtotime("now");
		//get timestamp when tweet created
		$c = strtotime($a);
		//get difference
		$d = $b - $c;
		//calculate different time values
		$minute = 60;
		$hour = $minute * 60;
		$day = $hour * 24;
		$week = $day * 7;

		if(is_numeric($d) && $d > 0) {
			//if less then 3 seconds
			if($d < 3) return "right now";
			//if less then minute
			if($d < $minute) return floor($d) . " seconds ago";
			//if less then 2 minutes
			if($d < $minute * 2) return "about 1 minute ago";
			//if less then hour
			if($d < $hour) return floor($d / $minute) . " minutes ago";
			//if less then 2 hours
			if($d < $hour * 2) return "about 1 hour ago";
			//if less then day
			if($d < $day) return floor($d / $hour) . " hours ago";
			//if more then day, but less then 2 days
			if($d > $day && $d < $day * 2) return "yesterday";
			//if less then year
			if($d < $day * 365) return floor($d / $day) . " days ago";
			//else return more than a year
			return "over a year ago";
		}
	}

	function save_remote_file( $url, $fileName ){
		$response = wp_remote_get( $url );
		if( is_wp_error( $response ) || $response['response']['code'] != "200" ){
			//GET failed
			return false;
		} else{
			//save the body of the response in $fileName
			$filePath = dirname(__FILE__) ."/". $fileName;
			$fp = @fopen( $filePath, "w");
			@fwrite( $fp, $response['body'] );
			@fclose( $fp );
			//that worked out well
			return $response['body'];
		}
	}

	function file_missing_or_old( $fileName, $ageInHours ){
		$fileName = dirname(__FILE__) ."/". $fileName;
		if( !file_exists( $fileName )){
			return true;
		} else{
			$fileModified = filemtime( $fileName );
			$today = time( );
			$hoursSince = round(($today - $fileModified)/3600, 3);
			if( $hoursSince > $ageInHours ){
				return true;
			} else{
				return false;
			}
		}
	}

	function get_json_data_from_file( $jsonFileName ){
		$fileName = dirname(__FILE__) ."/". $jsonFileName;
		$jsonData = "";
		if( @file_exists( $fileName )){
			$theFile = @fopen( $fileName, "r" );
			$jsonData = @fread( $theFile, @filesize( $fileName ));
			@fclose( $theFile );
		}
		return $jsonData;
	}
}

if( !function_exists('register_ns_latest_twitter_widget')){
	add_action('widgets_init', 'register_ns_latest_twitter_widget');
	function register_ns_latest_twitter_widget() {
	    register_widget('ns_latest_twitter_widget');
	}
}

/*if( !function_exists('ns_latest_twitter_widget_css')){
	function latest_twitter_widget_css( ){
		echo "<link type=\"text/css\" rel=\"stylesheet\" href=\"" . get_bloginfo('wpurl') ."/wp-content/plugins/latest-twitter-sidebar-widget/latest_twitter_widget.css\" />" . "\n";
	}
	add_action('wp_head', 'latest_twitter_widget_css');
}
*/



///------------------------- END Tweets Widget ----------------------------------////



///------------------------- START Tweets Widget Left Sidebar ---------------------------------////



class ns_latest_twitter_left_widget extends WP_Widget {

	function ns_latest_twitter_left_widget() {
		// widget actual processes
		parent::WP_Widget( /* Base ID */'ns_latest_twitter_left_widget', /* Name */'Novus Latest Twitter Widget', array( 'description' => 'For Content' ) );
	}

	function form($instance) {
		// outputs the options form on admin
		if ( !function_exists('quot') ){
			function quot($txt){
				return str_replace( "\"", "&quot;", $txt );
			}
		}

		// format some of the options as valid html
		$username = htmlspecialchars($instance['user'], ENT_QUOTES);
		$updateCount = htmlspecialchars($instance['count'], ENT_QUOTES);
		$showTwitterIconTF = $instance['showTwitterIconTF'];
		$showProfilePicTF = $instance['showProfilePicTF'];
		$showTweetTimeTF = $instance['showTweetTimeTF'];
		$widgetTitle = stripslashes(quot($instance['widgetTitle']));
		$includeRepliesTF = $instance['includeRepliesTF'];
	?>
		<p>
		
			<label for="<?php echo $this->get_field_id('user'); ?>" style="line-height:35px;display:block;">Twitter user: @<input type="text" size="12" id="<?php echo $this->get_field_id('user'); ?>" name="<?php echo $this->get_field_name('user'); ?>" value="<?php echo $username; ?>" /></label>
			<label for="<?php echo $this->get_field_id('count'); ?>" style="line-height:35px;display:block;">Show <input type="text" id="<?php echo $this->get_field_id('count'); ?>" size="2" name="<?php echo $this->get_field_name('count'); ?>" value="<?php echo $updateCount; ?>" /> twitter updates</label>
			<label for="<?php echo $this->get_field_id('widgetTitle'); ?>" style="line-height:35px;display:block;">Widget title: <input type="text" id="<?php echo $this->get_field_id('widgetTitle'); ?>" size="16" name="<?php echo $this->get_field_name('widgetTitle'); ?>" value="<?php echo $widgetTitle; ?>" /></label>
			 
             <!--
            <p>&nbsp;</p>
			<p><input type="radio" id="<?php echo $this->get_field_id('showTwitterIconTF'); ?>" value="icon" name="<?php echo $this->get_field_name('showIconOrPic'); ?>"<?php if($showTwitterIconTF){ ?> checked="checked"<?php } ?>><label for="<?php echo $this->get_field_id('showTwitterIconTF'); ?>"> Show twitter icon</label></p>
				 
                	<p><input type="radio" id="<?php echo $this->get_field_id('showProfilePicTF'); ?>" value="pic" name="<?php echo $this->get_field_name('showIconOrPic'); ?>"<?php if($showProfilePicTF){ ?> checked="checked"<?php } ?>><label for="<?php echo $this->get_field_id('showProfilePicTF'); ?>"> Show profile picture</label></p>
                 
		 	<p><input type="radio" id="latest-twitter-showNeitherImageTF" value="none" name="<?php echo $this->get_field_name('showIconOrPic'); ?>"<?php if((!$showProfilePicTF) && (!$showTwitterIconTF)){ ?> checked="checked"<?php } ?>><label for="latest-twitter-showNeitherImageTF"> Show no image</label></p> 
			
            
            <p>&nbsp;</p> -->
			<p><input type="checkbox" id="<?php echo $this->get_field_id('showTweetTimeTF'); ?>" value="1" name="<?php echo $this->get_field_name('showTweetTimeTF'); ?>"<?php if($showTweetTimeTF){ ?> checked="checked"<?php } ?>> <label for="<?php echo $this->get_field_id('showTweetTimeTF'); ?>">Show tweeted "time ago"</label></p>  
			<!-- 
            <p><input type="checkbox" id="<?php echo $this->get_field_id('includeRepliesTF'); ?>" value="1" name="<?php echo $this->get_field_name('includeRepliesTF'); ?>"<?php if($includeRepliesTF){ ?> checked="checked"<?php } ?>> <label for="<?php echo $this->get_field_id('includeRepliesTF'); ?>">Include replies</label></p> 
           
			<p>&nbsp;</p>
            -->
			
		</p>
<?php
	}

	function update($new_instance, $old_instance) {
		// processes widget options to be saved
		$instance = $old_instance;
		$instance['user'] = esc_html($new_instance['user']);
		$instance['count'] = esc_html($new_instance['count']);
		$instance['widgetTitle'] = esc_html( $new_instance['widgetTitle']);
		$instance['showTwitterIconTF'] = false;
		$instance['showProfilePicTF'] = false;
		switch( $new_instance['showIconOrPic'] ){
			case "icon":
				$instance['showTwitterIconTF'] = true;
				break;
			case "pic":
				$instance['showProfilePicTF'] = true;
				break;
			case "none":
				break;
		}
		if( $new_instance['showTweetTimeTF']=="1"){
			$instance['showTweetTimeTF'] = true;
		} else{
			$instance['showTweetTimeTF'] = false;
		}
		if( $new_instance['includeRepliesTF']=="1"){
			$instance['includeRepliesTF'] = true;
		} else{
			$instance['includeRepliesTF'] = false;
		}
		return $instance;
	}

	function widget($args, $instance) {
		// outputs the content of the widget
		extract($args, EXTR_SKIP);
		//default to my twitter name
		$profilePicFileName = '' ;
		$username = empty($instance['user']) ? "salzano" : $instance['user'];
		$updateCount = empty($instance['count']) ? 3 : $instance['count'];
		$showProfilePicTF = $instance['showProfilePicTF'];
		$showTwitterIconTF = $instance['showTwitterIconTF'];
		$showTweetTimeTF = $instance['showTweetTimeTF'];
		$title = $instance['widgetTitle'];
		$includeRepliesTF = $instance['includeRepliesTF'];

		$jsonFileName = "$username.json";
		$jsonTempFileName = "$username.json.tmp";
		$jsonURL = "http://api.twitter.com/1/statuses/user_timeline.json?screen_name=$username&include_entities=true";

		//have we fetched twitter data in the last half hour?
		if( $this->file_missing_or_old( $jsonFileName, .5 )){
			//get new data from twitter
			$jsonData = $this->save_remote_file( $jsonURL, $jsonFileName );
		} else{
			//already have file, get the data out of it
			$jsonData = $this->get_json_data_from_file( $jsonFileName );
		}

		// check for errors--rate limit or curl not installed
		// data returned will be: {"error":"Rate limit exceeded. Clients may not make more than 150 requests per hour.","request":"\/1\/statuses\/user_timeline.json?screen_name=salzano&include_entities=true"}

		if( $jsonData == "" || iconv_strlen( @$tweets->error, "UTF-8" )){
			//delete the json file so it will surely be downloaded on next page view
			if( @file_exists( dirname(__FILE__) ."/". $jsonFileName )){
				@unlink( dirname(__FILE__) ."/". $jsonFileName );
			}
			//get the backup data
			$jsonData = $this->get_json_data_from_file( $jsonTempFileName );
		} else{
			//good file, create a backup
			if( @file_exists( dirname(__FILE__) . "/" . $jsonFileName )){
				@copy( dirname(__FILE__) . "/" . $jsonFileName, dirname(__FILE__) . "/" . $jsonTempFileName );
			}
		}

		if( $tweets = json_decode( $jsonData )){
			$haveTwitterData = true;
		} else{
			//tweets is null
			$haveTwitterData = false;
		}

		//  $tweets has been json_decoded

		if( $haveTwitterData && $showProfilePicTF ){
			//make sure we have the profile picture saved locally
			$twitterUserData = $tweets[0]->user;
			$profilePicURL = $twitterUserData->profile_image_url;
			$profilePicPieces = explode( ".", $profilePicURL );
			$profilePicExt = end( $profilePicPieces );
			$profilePicFileName = $username . "." . $profilePicExt;
			if( $this->file_missing_or_old( $profilePicFileName, .5 )){
				$this->save_remote_file( $profilePicURL, $profilePicFileName );
			}
		}
		
		$before_widget = '<nav class="popularposts twitter">';
		$after_widget = '</nav>';
		$before_title = '<h2 class="blue"><span>';
		$after_title = '</span></h2>';
		
		
		/*
		<nav class="popularposts twitter">
			<h2 class="blue"><span>twitter</span></h2>
			<ul>
				<li><span>Ut sem lacus, porttitor et aliquam eget, iaculis id lacus ipsum. </span><a href="http://is.gd/UuSBXf">http://is.gd/UuSBXf</a><div>8 minutes ago</div><div class="clear"></div></li>
				<li><span>Sem lacus, porttitor et aliquam eget, iaculis id lacus eros.</span><a href="http://is.gd/UuSBXferwetw">http://is.gd/UuSBXferwetw</a><div>8 minutes ago</div><div class="clear"></div></li>
			</ul>
		</nav>
		*/
		
		
		
		// output the widget
		$title = empty($title) ? '&nbsp;' : apply_filters('widget_title', $title);
		echo $before_widget;
		if( !empty( $title ) && $title != "&nbsp;" ) { echo $before_title . $title . '<a id="twit" title="" href="https://twitter.com/'.$username.'">follow</a>' . $after_title; };
		if( $haveTwitterData ){
			$linkHTML = "<a href=\"http://twitter.com/".$username."\">";
			$pluginURL = home_url()."/wp-content/plugins/latest-twitter-sidebar-widget/";
			$icon = $pluginURL . "twitter.png";
			$pic = $pluginURL . $profilePicFileName;
			if( $showTwitterIconTF ){
				//echo $linkHTML . "<img id=\"latest-twitter-widget-icon\" src=\"".$icon."\" alt=\"t\"></a>";
			} else{
				if( $showProfilePicTF ){
					//echo $linkHTML . "<img id=\"latest-twitter-widget-pic\" src=\"".$pic."\" alt=\"\"></a>";
				}
			}
			$i=1;
			echo '<ul> ';
			foreach( $tweets as $tweet ){
				//exit this loop if we have reached updateCount
				if( $i > $updateCount ){ break; }
				//skip this iteration of the loop if this is a reply and we are not showing replies
				if( !$includeRepliesTF && strlen( $tweet->in_reply_to_screen_name )){ 		continue;	}
				echo "<li>" ;
				
				// echo "<span class=\"latest-twitter-tweet-time tweet_text\" /> &quot;" . $this->fix_twitter_update( $tweet->text, $tweet->entities ) . "&quot;</span> </li>";
				echo "<span>" . $this->fix_twitter_update( $tweet->text, $tweet->entities ) . "</span>";
				
				if( $showTweetTimeTF ){
					// echo '<span class="tweet_time">'.$linkHTML.$this->twitter_time_ltw( $tweet->created_at ).'</a></span>';
					echo '<div>'.$this->twitter_time_ltw( $tweet->created_at ).'</div>';
					//echo $linkHTML ."<span class=\"latest-twitter-tweet-time tweet_time\" id=\"latest-twitter-tweet-time-" . $i . "\">" .$this->twitter_time_ltw( $tweet->created_at ) . " </span> </a>";
				}
				
				echo '<div class="clear"></div>';
				echo '</li>';
				
				
				$i++;
			}
			
			echo "</ul>";
			
			
			
		} else{
			echo "have data = false $jsonData";
		}
		//show this no matter what, tweets or no tweets
		//echo "<div id=\"latest-twitter-follow-link\"><a href=\"http://twitter.com/$username\">follow @$username on twitter</a></div>";
		echo $after_widget;
	}

	function fix_twitter_update($origTweet,$entities) {
		$index = array();
		if( $entities == null ){ return $origTweet; }
		foreach( $entities->urls as $url ){
			$index[$url->indices[0]] = "<a href=\"".$url->url."\">".$url->url."</a>";
			$endEntity[(int)$url->indices[0]] = (int)$url->indices[1];
		}
		foreach( $entities->hashtags as $hashtag ){
			$index[$hashtag->indices[0]] = "<a href=\"http://twitter.com/#!/search?q=%23".$hashtag->text."\">#".$hashtag->text."</a>";
			$endEntity[$hashtag->indices[0]] = $hashtag->indices[1];
		}
		foreach( $entities->user_mentions as $user_mention ){
			$index[$user_mention->indices[0]] = "<a href=\"http://twitter.com/".$user_mention->screen_name."\">@".$user_mention->screen_name."</a>";
			$endEntity[$user_mention->indices[0]] = $user_mention->indices[1];
		}
		$fixedTweet="";
		for($i=0;$i<iconv_strlen($origTweet, "UTF-8" );$i++){
			if(iconv_strlen(@$index[(int)$i], "UTF-8" )>0){
				$fixedTweet .= $index[(int)$i];
				$i = $endEntity[(int)$i]-1;
			} else{
				$fixedTweet .= iconv_substr( $origTweet,$i,1, "UTF-8" );
			}
		}
		return $fixedTweet;
	}

	function twitter_time_ltw($a) {
		//get current timestamp
		$b = strtotime("now");
		//get timestamp when tweet created
		$c = strtotime($a);
		//get difference
		$d = $b - $c;
		//calculate different time values
		$minute = 60;
		$hour = $minute * 60;
		$day = $hour * 24;
		$week = $day * 7;

		if(is_numeric($d) && $d > 0) {
			//if less then 3 seconds
			if($d < 3) return "right now";
			//if less then minute
			if($d < $minute) return floor($d) . " seconds ago";
			//if less then 2 minutes
			if($d < $minute * 2) return "about 1 minute ago";
			//if less then hour
			if($d < $hour) return floor($d / $minute) . " minutes ago";
			//if less then 2 hours
			if($d < $hour * 2) return "about 1 hour ago";
			//if less then day
			if($d < $day) return floor($d / $hour) . " hours ago";
			//if more then day, but less then 2 days
			if($d > $day && $d < $day * 2) return "yesterday";
			//if less then year
			if($d < $day * 365) return floor($d / $day) . " days ago";
			//else return more than a year
			return "over a year ago";
		}
	}

	function save_remote_file( $url, $fileName ){
		$response = wp_remote_get( $url );
		if( is_wp_error( $response ) || $response['response']['code'] != "200" ){
			//GET failed
			return false;
		} else{
			//save the body of the response in $fileName
			$filePath = dirname(__FILE__) ."/". $fileName;
			$fp = @fopen( $filePath, "w");
			@fwrite( $fp, $response['body'] );
			@fclose( $fp );
			//that worked out well
			return $response['body'];
		}
	}

	function file_missing_or_old( $fileName, $ageInHours ){
		$fileName = dirname(__FILE__) ."/". $fileName;
		if( !file_exists( $fileName )){
			return true;
		} else{
			$fileModified = filemtime( $fileName );
			$today = time( );
			$hoursSince = round(($today - $fileModified)/3600, 3);
			if( $hoursSince > $ageInHours ){
				return true;
			} else{
				return false;
			}
		}
	}

	function get_json_data_from_file( $jsonFileName ){
		$fileName = dirname(__FILE__) ."/". $jsonFileName;
		$jsonData = "";
		if( @file_exists( $fileName )){
			$theFile = @fopen( $fileName, "r" );
			$jsonData = @fread( $theFile, @filesize( $fileName ));
			@fclose( $theFile );
		}
		return $jsonData;
	}
}

if( !function_exists('register_ns_latest_twitter_left_widget')){
	add_action('widgets_init', 'register_ns_latest_twitter_left_widget');
	function register_ns_latest_twitter_left_widget() {
	    register_widget('ns_latest_twitter_left_widget');
	}
}

/*if( !function_exists('ns_latest_twitter_widget_css')){
	function latest_twitter_widget_css( ){
		echo "<link type=\"text/css\" rel=\"stylesheet\" href=\"" . get_bloginfo('wpurl') ."/wp-content/plugins/latest-twitter-sidebar-widget/latest_twitter_widget.css\" />" . "\n";
	}
	add_action('wp_head', 'latest_twitter_widget_css');
}
*/



///------------------------- END Tweets Widget Left Sidebar ----------------------------------////


class WP_Cavus_Recent_Posts_Widget extends WP_Widget {

 function __construct() {
  // ini_set('display_errors',1);
  // error_reporting(E_ALL);
	$widget_ops = array('classname' => 'widget_cavus_recent_entries', 'description' => __( "The recent posts for Footer", "cavus_theme" ) );
	parent::__construct('calvus-recent-posts', __( 'Novus Recent Posts', "cavus_theme" ), $widget_ops);
	
	$this->alt_option_name = 'widget_cavus_recent_entries';

	add_action( 'save_post', array(&$this, 'flush_widget_cache') );
	add_action( 'deleted_post', array(&$this, 'flush_widget_cache') );
	add_action( 'switch_theme', array(&$this, 'flush_widget_cache') );
 }

 function widget($args, $instance) {
  $cache = wp_cache_get('widget_recent_posts', 'widget');

  if ( !is_array($cache) )
   $cache = array();

  if ( ! isset( $args['widget_id'] ) )
   $args['widget_id'] = $this->id;

  if ( isset( $cache[ $args['widget_id'] ] ) ) {
   echo $cache[ $args['widget_id'] ];
   return;
  }

  ob_start();
  extract($args);
global $ns_options_frnt;
  $title = apply_filters('widget_title', empty($instance['title']) ? __( 'Recent Posts', "cavus_theme" ) : $instance['title'], $instance, $this->id_base);
  if ( empty( $instance['number'] ) || ! $number = absint( $instance['number'] ) )
    $number = 10;

  // $r = new WP_Query( apply_filters( 'widget_posts_args', array( 'posts_per_page' => $number, 'no_found_rows' => true, 'post_status' => 'publish', 'ignore_sticky_posts' => true, 'cat' => '-4' ) ) );
  // $r = new WP_Query( apply_filters( 'widget_posts_args', array('orderby' => 'post_date ASC', 'posts_per_page' => $number, 'no_found_rows' => true, 'post_status' => 'publish', 'ignore_sticky_posts' => true, 'cat' => '-4' ) ) );
  $r = new WP_Query( apply_filters( 'widget_posts_args', array( 'posts_per_page' => $number, 'no_found_rows' => true, 'post_status' => 'publish', 'ignore_sticky_posts' => true, 'cat' => '-4' ) ) );
  if ($r->have_posts()) :
?>
  <?php echo $before_widget; ?>
  <?php if ( $title ) echo $before_title . $title . $after_title; ?>
  <?php $posts_sz = count($r->posts);?>
  <?php $i = 1;?>
  <?php  while ($r->have_posts()) : $r->the_post(); ?>
  <?php /* <li><a href="<?php the_permalink() ?>" title="<?php echo esc_attr(get_the_title() ? get_the_title() : get_the_ID()); ?>"><?php if ( get_the_title() ) the_title(); else the_ID(); ?></a></li><?php echo the_author('', false);?> */?>
  <?php //echo '<pre>';print_r($r);?>
  <p><b><a href="<?php the_permalink() ?>" title="<?php echo esc_attr(get_the_title() ? get_the_title() : get_the_ID()); ?>"><?php if ( get_the_title() ) the_title(); else the_ID(); ?></a></b></p> 
  <p><b><?php the_time('F d, Y') ?>  |  <?php echo the_author('', false);?></b></p>
  <?php $excerpt = get_the_excerpt(); ?>
  <p><?php echo string_limit_words( $excerpt, 10);?></p>
  <?php if($i < $posts_sz){?>
	<div class="hr"></div>
  <?php }?>
  <?php $i++;?>
  <?php endwhile; ?>
  <?php echo $after_widget; ?>
<?php
  // Reset the global $the_post as this query will have stomped on it
  wp_reset_postdata();

  endif;

  $cache[$args['widget_id']] = ob_get_flush();
  wp_cache_set('widget_recent_posts', $cache, 'widget');
 }

 function update( $new_instance, $old_instance ) {
  $instance = $old_instance;
  $instance['title'] = strip_tags($new_instance['title']);
  $instance['number'] = (int) $new_instance['number'];
  $this->flush_widget_cache();

  $alloptions = wp_cache_get( 'alloptions', 'options' );
  if ( isset($alloptions['widget_recent_entries']) )
   delete_option('widget_recent_entries');

  return $instance;
 }

 function flush_widget_cache() {
  wp_cache_delete('widget_recent_posts', 'widget');
 }

 function form( $instance ) {
  $title = isset($instance['title']) ? esc_attr($instance['title']) : '';
  $number = isset($instance['number']) ? absint($instance['number']) : 5;
?>
  <p><label for="<?php echo $this->get_field_id('title'); ?>"><?php _e( 'Title:', "cavus_theme" ); ?></label>
  <input class="widefat" id="<?php echo $this->get_field_id('title'); ?>" name="<?php echo $this->get_field_name('title'); ?>" type="text" value="<?php echo $title; ?>" /></p>

  <p><label for="<?php echo $this->get_field_id('number'); ?>"><?php _e( 'Number of posts to show:', "cavus_theme" ); ?></label>
  <input id="<?php echo $this->get_field_id('number'); ?>" name="<?php echo $this->get_field_name('number'); ?>" type="text" value="<?php echo $number; ?>" size="3" /></p>
<?php
 }
}


class WP_Cavus_Recent_Posts_Left_Widget extends WP_Widget {

 function __construct() {
  // ini_set('display_errors',1);
  // error_reporting(E_ALL);
	$widget_ops = array('classname' => 'widget_cavus_recent_left_entries', 'description' => __( "Displays the most popular posts", "cavus_theme" ) );
	parent::__construct('calvus-recent-left-posts', __( 'Novus Popular Posts', "cavus_theme" ), $widget_ops);
	
	$this->alt_option_name = 'widget_cavus_recent_left_entries';

	add_action( 'save_post', array(&$this, 'flush_widget_cache') );
	add_action( 'deleted_post', array(&$this, 'flush_widget_cache') );
	add_action( 'switch_theme', array(&$this, 'flush_widget_cache') );
 }

 function widget($args, $instance) {
  $cache = wp_cache_get('widget_recent_posts', 'widget');

  if ( !is_array($cache) )
   $cache = array();

  if ( ! isset( $args['widget_id'] ) )
   $args['widget_id'] = $this->id;

  if ( isset( $cache[ $args['widget_id'] ] ) ) {
   echo $cache[ $args['widget_id'] ];
   return;
  }

  ob_start();
  extract($args);

  $title = apply_filters('widget_title', empty($instance['title']) ? __( 'Recent Posts', "cavus_theme" ) : $instance['title'], $instance, $this->id_base);
  if ( empty( $instance['number'] ) || ! $number = absint( $instance['number'] ) )
    $number = 10;

  $r = new WP_Query( apply_filters( 'widget_posts_args', array('orderby' => 'comment_count DESC', 'posts_per_page' => $number, 'no_found_rows' => true, 'post_status' => 'publish', 'ignore_sticky_posts' => true, 'cat' => '-4' ) ) );
  if ($r->have_posts()) :
?>
<nav class="popularposts">
					
  <h2 class="blue">  <?php echo $title  ?>  </h2>
  <?php $posts_sz = count($r->posts);?>
  <?php $i = 1;?>
  <ul>
  <?php  while ($r->have_posts()) : $r->the_post(); ?>
	<li>
		<?php echo get_post_image_fn(get_the_ID(), 50, 50);?>
		<a title="<?php echo esc_attr(get_the_title() ? get_the_title() : get_the_ID()); ?>" href="<?php the_permalink() ?>"><?php if ( get_the_title() ) the_title(); else the_ID(); ?></a>
		<div>Date: <?php the_time('d.m.Y') ?></div>
	</li>
   </li>
  <?php $i++;?>
  <?php endwhile; ?>
  </ul>
		</nav>
<?php
  // Reset the global $the_post as this query will have stomped on it
  wp_reset_postdata();

  endif;

  $cache[$args['widget_id']] = ob_get_flush();
  wp_cache_set('widget_recent_posts', $cache, 'widget');
 }

 function update( $new_instance, $old_instance ) {
  $instance = $old_instance;
  $instance['title'] = strip_tags($new_instance['title']);
  $instance['number'] = (int) $new_instance['number'];
  $this->flush_widget_cache();

  $alloptions = wp_cache_get( 'alloptions', 'options' );
  if ( isset($alloptions['widget_recent_entries']) )
   delete_option('widget_recent_entries');

  return $instance;
 }

 function flush_widget_cache() {
  wp_cache_delete('widget_recent_posts', 'widget');
 }

 function form( $instance ) {
  $title = isset($instance['title']) ? esc_attr($instance['title']) : '';
  $number = isset($instance['number']) ? absint($instance['number']) : 5;
?>
  <p><label for="<?php echo $this->get_field_id('title'); ?>"><?php _e( 'Title:', "cavus_theme" ); ?></label>
  <input class="widefat" id="<?php echo $this->get_field_id('title'); ?>" name="<?php echo $this->get_field_name('title'); ?>" type="text" value="<?php echo $title; ?>" /></p>

  <p><label for="<?php echo $this->get_field_id('number'); ?>"><?php _e( 'Number of posts to show:', "cavus_theme" ); ?></label>
  <input id="<?php echo $this->get_field_id('number'); ?>" name="<?php echo $this->get_field_name('number'); ?>" type="text" value="<?php echo $number; ?>" size="3" /></p>
<?php
 }
}



class WP_Cavus_Last_Posts_Left_Widget extends WP_Widget {

 function __construct() {
  // ini_set('display_errors',1);
  // error_reporting(E_ALL);
	$widget_ops = array('classname' => 'widget_cavus_recent_left_entries', 'description' => __( "Lates posts on sidebar", "cavus_theme" ) );
	parent::__construct('calvus-last-left-posts', __( 'Novus Latest Posts', "cavus_theme" ), $widget_ops);
	
	$this->alt_option_name = 'widget_cavus_recent_left_entries';

	add_action( 'save_post', array(&$this, 'flush_widget_cache') );
	add_action( 'deleted_post', array(&$this, 'flush_widget_cache') );
	add_action( 'switch_theme', array(&$this, 'flush_widget_cache') );
 }

 function widget($args, $instance) {
  $cache = wp_cache_get('widget_recent_posts', 'widget');

  if ( !is_array($cache) )
   $cache = array();

  if ( ! isset( $args['widget_id'] ) )
   $args['widget_id'] = $this->id;

  if ( isset( $cache[ $args['widget_id'] ] ) ) {
   echo $cache[ $args['widget_id'] ];
   return;
  }

  ob_start();
  extract($args);

  $title = apply_filters('widget_title', empty($instance['title']) ? __( 'Recent Posts', "cavus_theme" ) : $instance['title'], $instance, $this->id_base);
  if ( empty( $instance['number'] ) || ! $number = absint( $instance['number'] ) )
    $number = 10;

  $r = new WP_Query( apply_filters( 'widget_posts_args', array('posts_per_page' => $number, 'no_found_rows' => true, 'post_status' => 'publish', 'ignore_sticky_posts' => true, 'cat' => '-4' ) ) );
  if ($r->have_posts()) :
?>
<nav class="popularposts">
					
  <h2 class="blue">  <?php echo $title  ?>  </h2>
  <?php $posts_sz = count($r->posts);?>
  <?php $i = 1;?>
  <ul>
  <?php  while ($r->have_posts()) : $r->the_post(); ?>
	<li>
	<?php echo get_post_image_fn(get_the_ID(), 50, 50);?>
	<a title="<?php echo esc_attr(get_the_title() ? get_the_title() : get_the_ID()); ?>" href="<?php the_permalink() ?>"><?php if ( get_the_title() ) the_title(); else the_ID(); ?></a>
	<div>Date: <?php the_time('d.m.Y') ?></div><div class="clear"></div></li>
   </li>
  <?php $i++;?>
  <?php endwhile; ?>
  </ul>
		</nav>
<?php
  // Reset the global $the_post as this query will have stomped on it
  wp_reset_postdata();

  endif;

  $cache[$args['widget_id']] = ob_get_flush();
  wp_cache_set('widget_recent_posts', $cache, 'widget');
 }

 function update( $new_instance, $old_instance ) {
  $instance = $old_instance;
  $instance['title'] = strip_tags($new_instance['title']);
  $instance['number'] = (int) $new_instance['number'];
  $this->flush_widget_cache();

  $alloptions = wp_cache_get( 'alloptions', 'options' );
  if ( isset($alloptions['widget_recent_entries']) )
   delete_option('widget_recent_entries');

  return $instance;
 }

 function flush_widget_cache() {
  wp_cache_delete('widget_recent_posts', 'widget');
 }

 function form( $instance ) {
  $title = isset($instance['title']) ? esc_attr($instance['title']) : '';
  $number = isset($instance['number']) ? absint($instance['number']) : 5;
?>
  <p><label for="<?php echo $this->get_field_id('title'); ?>"><?php _e( 'Title:', "cavus_theme" ); ?></label>
  <input class="widefat" id="<?php echo $this->get_field_id('title'); ?>" name="<?php echo $this->get_field_name('title'); ?>" type="text" value="<?php echo $title; ?>" /></p>

  <p><label for="<?php echo $this->get_field_id('number'); ?>"><?php _e( 'Number of posts to show:', "cavus_theme" ); ?></label>
  <input id="<?php echo $this->get_field_id('number'); ?>" name="<?php echo $this->get_field_name('number'); ?>" type="text" value="<?php echo $number; ?>" size="3" /></p>
<?php
 }
}



///------------------------- END Recent Posts Widget ----------------------------------////



///------------------------- Projects Widget ----------------------------------////

class WP_Cavus_Projects_Widget extends WP_Widget {

 function __construct() {
	$widget_ops = array('classname' => 'cavus_services_widget', 'description' => __( "Display latest portfolio items", "cavus_theme" ) );
	parent::__construct('calvus-projects', __( 'Novus Projects', "cavus_theme" ), $widget_ops);
	
	$this->alt_option_name = 'cavus_services_widget';

	add_action( 'save_post', array(&$this, 'flush_widget_cache') );
	add_action( 'deleted_post', array(&$this, 'flush_widget_cache') );
	add_action( 'switch_theme', array(&$this, 'flush_widget_cache') );
 }

 function widget($args, $instance) {
  $cache = wp_cache_get('widget_recent_posts', 'widget');

  if ( !is_array($cache) )
   $cache = array();

  if ( ! isset( $args['widget_id'] ) )
   $args['widget_id'] = $this->id;

  if ( isset( $cache[ $args['widget_id'] ] ) ) {
   echo $cache[ $args['widget_id'] ];
   return;
  }

  ob_start();
  extract($args);

  $title = apply_filters('widget_title', empty($instance['title']) ? __( 'Recent Posts', "cavus_theme" ) : $instance['title'], $instance, $this->id_base);
  if ( empty( $instance['number'] ) || ! $number = absint( $instance['number'] ) )
    $number = 10;
  if($instance['category_id']){
    $category_id = $instance['category_id'];
	$r = new WP_Query( apply_filters( 'widget_posts_args', array('cat' => $category_id, 'posts_per_page' => $number, 'no_found_rows' => true, 'post_status' => 'publish', 'ignore_sticky_posts' => true ) ) );
  }
  if ($r->have_posts()) :
?>
	<div id="secondary">
	<div class="slider-nav-secondary">
			<div class="camera_prev"><span></span></div>
			<div class="camera_next"><span></span></div>
	</div>
	<div id="secondary-thumbs">
	
  <?php $posts_sz = count($r->posts);?>
  <?php $i = 1;?>
  <ul>
  <?php  while ($r->have_posts()) : $r->the_post(); ?>
  <?php //echo '<pre>';print_r($r->posts);?>
  <?php //echo '<pre>';print_r($post);?>
	<li>
	<?php //= display_post_image_fn(get_the_ID(), false);?>
	<?php /* <img alt="" src="images/pictures/secondary.jpg"> */?>
	<?php $portfolio_item_thumb = get_post_meta(get_the_ID(), 'portfolio_item_thumb', true);?>
	<?php $description = get_post_custom_values('portfolio_item_description');?>
	<img alt="" src="<?php echo get_template_directory_uri(); ?>/scripts/timthumb.php?src=<?php echo $portfolio_item_thumb;?>&amp;w=350&amp;h=205&amp;zc=0&amp;q=90">
	<?php /* <img alt="" src="<?php echo $portfolio_item_thumb?>"> */?>
	
	
	<div class="secondary-description">
		<h2><?php echo esc_attr(get_the_title() ? get_the_title() : get_the_ID()); ?></h2>
		<p><?php string_limit_words( $description[0], 20); ?></p>
		<div class="secondary-info">
			<span class="viewers"><?php if(function_exists('the_views')) { the_views(); } ?></span>
			<a title="" href="<?php the_permalink() ?>" class="view">view</a>
		</div>
	</div>
	
	<?php /* <a title="<?php echo esc_attr(get_the_title() ? get_the_title() : get_the_ID()); ?>" href="<?php the_permalink() ?>"><?php if ( get_the_title() ) the_title(); else the_ID(); ?></a>
	<div>Date: <?php the_time('d.m.Y') ?></div><div class="clear"></div></li> */?>
   </li>
  <?php $i++;?>
  <?php endwhile; ?>
  </ul>
  </div>
  </div>
  
<?php
  // Reset the global $the_post as this query will have stomped on it
  wp_reset_postdata();

  endif;

  $cache[$args['widget_id']] = ob_get_flush();
  wp_cache_set('widget_recent_posts', $cache, 'widget');
 }

 function update( $new_instance, $old_instance ) {
  $instance = $old_instance;
  $instance['title'] = strip_tags($new_instance['title']);
  $instance['category_id'] = (int) $new_instance['category_id'];
  $instance['number'] = (int) $new_instance['number'];
  $this->flush_widget_cache();

  $alloptions = wp_cache_get( 'alloptions', 'options' );
  if ( isset($alloptions['widget_recent_entries']) )
   delete_option('widget_recent_entries');

  return $instance;
 }

 function flush_widget_cache() {
  wp_cache_delete('widget_recent_posts', 'widget');
 }

 function form( $instance ) {
  $title = isset($instance['title']) ? esc_attr($instance['title']) : '';
  $category_id = isset($instance['category_id']) ? absint($instance['category_id']) : 4;
  $number = isset($instance['number']) ? absint($instance['number']) : 5;
?>
  <p><label for="<?php echo $this->get_field_id('title'); ?>"><?php _e( 'Title:', "cavus_theme" ); ?></label>
  <input class="widefat" id="<?php echo $this->get_field_id('title'); ?>" name="<?php echo $this->get_field_name('title'); ?>" type="text" value="<?php echo $title; ?>" /></p>

  <p><label for="<?php echo $this->get_field_id('category_id'); ?>"><?php _e( 'Category ID:', "cavus_theme" ); ?></label>
  <input id="<?php echo $this->get_field_id('category_id'); ?>" name="<?php echo $this->get_field_name('category_id'); ?>" type="text" value="<?php echo $category_id; ?>" size="3" /></p>
  
  <p><label for="<?php echo $this->get_field_id('number'); ?>"><?php _e( 'Number of posts to show:', "cavus_theme" ); ?></label>
  <input id="<?php echo $this->get_field_id('number'); ?>" name="<?php echo $this->get_field_name('number'); ?>" type="text" value="<?php echo $number; ?>" size="3" /></p>
<?php
 }
}



///------------------------- END Projects Widget ----------------------------------////



///------------------------- Team Widget ----------------------------------////

class WP_Cavus_Team_Widget extends WP_Widget {

 function __construct() {
	$widget_ops = array('classname' => 'cavus_services_widget', 'description' => __( "Display Team in Slider", "cavus_theme" ) );
	parent::__construct('calvus-team', __( 'Novus Team', "cavus_theme" ), $widget_ops);
	
	$this->alt_option_name = 'cavus_services_widget';

	add_action( 'save_post', array(&$this, 'flush_widget_cache') );
	add_action( 'deleted_post', array(&$this, 'flush_widget_cache') );
	add_action( 'switch_theme', array(&$this, 'flush_widget_cache') );
 }

 function widget($args, $instance) {
  $cache = wp_cache_get('widget_recent_posts', 'widget');

  if ( !is_array($cache) )
   $cache = array();

  if ( ! isset( $args['widget_id'] ) )
   $args['widget_id'] = $this->id;

  if ( isset( $cache[ $args['widget_id'] ] ) ) {
   echo $cache[ $args['widget_id'] ];
   return;
  }

  ob_start();
  extract($args);

  $title = apply_filters('widget_title', empty($instance['title']) ? __( 'Recent Posts', "cavus_theme" ) : $instance['title'], $instance, $this->id_base);
  if ( empty( $instance['number'] ) || ! $number = absint( $instance['number'] ) )
    $number = 10;
  if($instance['category_id']){
    $category_id = $instance['category_id'];
	$r = new WP_Query( apply_filters( 'widget_posts_args', array('cat' => $category_id, 'posts_per_page' => $number, 'no_found_rows' => true, 'post_status' => 'publish', 'ignore_sticky_posts' => true ) ) );
  }
  if ($r->have_posts()) :
?>
					
  <?php $posts_sz = count($r->posts);?>
  <?php $i = 1;?>
  <ul>
  <?php  while ($r->have_posts()) : $r->the_post(); ?>
  <?php //echo '<pre>'; print_r($r->posts); exit;?>
	<li>
	<?php //= display_post_image_fn(get_the_ID(), false);?>
	<?php /* <img alt="" src="images/pictures/secondary.jpg"> */?>
	<?php //$portfolio_item_thumb = get_post_meta(get_the_ID(), 'portfolio_item_thumb', true);?>
	<?php $description = get_post_custom_values('portfolio_item_description');?>
	<div class="team-img">
		<?php the_post_thumbnail( array(350,206) ); ?>
	</div>
	<?php /* <img alt="" src="<?php echo get_template_directory_uri(); ?>/scripts/timthumb.php?src=<?php echo $portfolio_item_thumb;?>&amp;w=350&amp;h=205&amp;zc=0&amp;q=90"> */?>
	<?php /* <img alt="" src="<?php echo $portfolio_item_thumb?>"> */?>
	
	
	<div class="secondary-description">
		<h2><?php echo esc_attr(get_the_title() ? get_the_title() : get_the_ID()); ?></h2>
		<?php /* <p><?php echo $description[0]?></p> */?>
		<?php the_content()?>
		<div class="secondary-info">
			<span class="viewers"><?php if(function_exists('the_views')) { the_views(); } ?></span>
			<a title="" href="<?php the_permalink() ?>" class="view">view</a>
		</div>
	</div>
	
	<?php /* <a title="<?php echo esc_attr(get_the_title() ? get_the_title() : get_the_ID()); ?>" href="<?php the_permalink() ?>"><?php if ( get_the_title() ) the_title(); else the_ID(); ?></a>
	<div>Date: <?php the_time('d.m.Y') ?></div><div class="clear"></div></li> */?>
   </li>
  <?php $i++;?>
  <?php endwhile; ?>
  </ul>
  
<?php
  // Reset the global $the_post as this query will have stomped on it
  wp_reset_postdata();

  endif;

  $cache[$args['widget_id']] = ob_get_flush();
  wp_cache_set('widget_recent_posts', $cache, 'widget');
 }

 function update( $new_instance, $old_instance ) {
  $instance = $old_instance;
  $instance['title'] = strip_tags($new_instance['title']);
  $instance['category_id'] = (int) $new_instance['category_id'];
  $instance['number'] = (int) $new_instance['number'];
  $this->flush_widget_cache();

  $alloptions = wp_cache_get( 'alloptions', 'options' );
  if ( isset($alloptions['widget_recent_entries']) )
   delete_option('widget_recent_entries');

  return $instance;
 }

 function flush_widget_cache() {
  wp_cache_delete('widget_recent_posts', 'widget');
 }

 function form( $instance ) {
  $title = isset($instance['title']) ? esc_attr($instance['title']) : '';
  $category_id = isset($instance['category_id']) ? absint($instance['category_id']) : 4;
  $number = isset($instance['number']) ? absint($instance['number']) : 5;
?>
  <p><label for="<?php echo $this->get_field_id('title'); ?>"><?php _e( 'Title:', "cavus_theme" ); ?></label>
  <input class="widefat" id="<?php echo $this->get_field_id('title'); ?>" name="<?php echo $this->get_field_name('title'); ?>" type="text" value="<?php echo $title; ?>" /></p>

  <p><label for="<?php echo $this->get_field_id('category_id'); ?>"><?php _e( 'Category ID:', "cavus_theme" ); ?></label>
  <input id="<?php echo $this->get_field_id('category_id'); ?>" name="<?php echo $this->get_field_name('category_id'); ?>" type="text" value="<?php echo $category_id; ?>" size="3" /></p>
  
  <p><label for="<?php echo $this->get_field_id('number'); ?>"><?php _e( 'Number of posts to show:', "cavus_theme" ); ?></label>
  <input id="<?php echo $this->get_field_id('number'); ?>" name="<?php echo $this->get_field_name('number'); ?>" type="text" value="<?php echo $number; ?>" size="3" /></p>
<?php
 }
}



///------------------------- END Team Widget ----------------------------------////



///------------------------- Our Clients START ----------------------------------////
class WP_Widget_Our_Clients extends WP_Widget {

	function __construct() {
		$widget_ops = array('classname' => 'widget_our_clients', 'description' => __( "Display clients for your site", "cavus_theme" ) );
		parent::__construct('our_clients', __( 'Novus Clients', "cavus_theme" ), $widget_ops);
	}

	function widget( $args, $instance ) {
		global $slider_type, $ns_options_frnt;
		
		extract($args);
		$title = apply_filters( 'widget_title', empty( $instance['title'] ) ? '' : $instance['title'], $instance, $this->id_base );

		echo $before_widget;
		/*if ( $title )
			echo $before_title . $title . $after_title;*/

		// Use current theme search form if it exists
		// get_search_form();
	?>
		<script type="text/javascript">
			jQuery(document).ready(function(jQuery){
				jQuery.fn.FlyUpSlider({
					id: '.vendors-cell',
					left: '#vendors div.camera_prev',
					right: '#vendors div.camera_next',
					time: <?php echo $ns_options_frnt['ns_client_slider']['timeout']?$ns_options_frnt['ns_client_slider']['timeout']:1000?>,
					round: true,
					delta: 165,
					deltaerror:0 
				});
			});
		</script>
		<section>
			<aside class="vendors">
				<nav>
					<?php echo $title ? $before_title . $title . $after_title :''?>
					<div class="hr"></div>				
					<a class="more" href="close"  title="view all">view all</a>
				</nav>
			</aside>
			<?php /*
				
				//nivo, jfancytile, c1, c3, no_slider
				if(true)
				{
			*/?>
			
			<div id="vendors">
				<!-- <h2 class="blue">our cliens</h2> -->
				<div class="wrap-cell-wide">		
					<div class="wrap-cell">		
						<div class="vendors-cell">
							<ul class="vendors-table camera_effected">
								<?php for ( $i=0; $i<sizeof($ns_options_frnt['css1_addSlide_field']); $i++){ ?> 
								
								<li>
									<?php if($ns_options_frnt['css1_slideImage_link'][$i]){?>
								<a href="<?php echo $ns_options_frnt['css1_slideImage_link'][$i]; ?>" title="<?php echo $ns_options_frnt['css1_slideTextArea'][$i]; ?>" target="<?php echo $ns_options_frnt['css1_slideLinkType'][$i]; ?>">
								<?php }?>
								<?php if($ns_options_frnt['css1_addSlide_field'][$i]){?>						
								<img  src="<?php echo $ns_options_frnt['css1_addSlide_field'][$i]; ?>" alt="<?php echo $ns_options_frnt['css1_slideTextArea'][$i]; ?>">
								<?php }else{?>
								<?php echo $ns_options_frnt['css1_slideTextArea'][$i]; ?>
								<?php }?>
								<?php if($ns_options_frnt['css1_slideImage_link'][$i]){?>
								</a>
								<?php }?>
								</li>
								<?php }?>
								
							</ul>

						</div>
					</div>
				</div><!-- .wrap-cell-wide -->
				
				<div class="slider-nav-secondary clients">
						<div class="camera_prev"><span></span></div>
						<div class="camera_next"><span></span></div>
				</div>
					
			</div>
			<div class="clear"></div>
		</section>
	<?php

		echo $after_widget;
	}

	function form( $instance ) {
		$instance = wp_parse_args( (array) $instance, array( 'title' => '') );
		$title = $instance['title'];
?>
		<p><label for="<?php echo $this->get_field_id('title'); ?>"><?php _e( 'Title:', "cavus_theme" ); ?> <input class="widefat" id="<?php echo $this->get_field_id('title'); ?>" name="<?php echo $this->get_field_name('title'); ?>" type="text" value="<?php echo esc_attr($title); ?>" /></label></p>
<?php
	}

	function update( $new_instance, $old_instance ) {
		$instance = $old_instance;
		$new_instance = wp_parse_args((array) $new_instance, array( 'title' => ''));
		$instance['title'] = strip_tags($new_instance['title']);
		return $instance;
	}

}
///------------------------- Our Clients END ----------------------------------////



// register_widget('WP_Cavus_Multiple_Posts_Widget');
register_widget('Google_Map_Widget');
register_widget('WP_479AM_Category_Widget');
register_widget('WP_Cavus_Archives_Widget');
register_widget('ns_latest_twitter_widget');
// register_widget('ns_latest_twitter_left_widget');
register_widget('WP_Cavus_Recent_Posts_Widget');
register_widget('WP_Cavus_Recent_Posts_Left_Widget');
register_widget('WP_Cavus_Last_Posts_Left_Widget');
register_widget('WP_Cavus_Projects_Widget');
register_widget('WP_Cavus_Team_Widget');
register_widget('WP_Widget_Our_Clients');

?>