<?php
/*
* Template Name: Blog Template 2
*/
// get_header();
get_template_part( 'header_inner', '' );
?>

<?php

global $ns_options_frnt;

$exclude_portfolio_from_blog = $ns_options_frnt['ns_csExcludePortfoliosFromBlog'];
$exclude_our_team_from_blog = $ns_options_frnt['ns_csExcludeOurTeamFromBlog'];

//adhere to paging rules
if ( get_query_var('paged') ) {
    $paged = get_query_var('paged');
} elseif ( get_query_var('page') ) { // applies when this page template is used as a static homepage in WP3+
    $paged = get_query_var('page');
} else {
    $paged = 1;
}

 	if( $exclude_portfolio_from_blog == 'exclude' || $exclude_our_team_from_blog == 'exclude' )
	{
		function add_minus_prefix( $var ) {
			return( '-' . $var);
		}
		
		$excluded_cats_array = array();
		
		if( $exclude_portfolio_from_blog == 'exclude' ){
			// get the portfolio categories to be excluded from the Blog section
			$portfolio_categories = $ns_options_frnt['ns_pf_cat_slug'];
			$cat_id = get_category_by_slug($portfolio_categories);
			$id = $cat_id->term_id;
				
			$args = array(
							'type'			=> 'post',
							'child_of'      => $id,
							'parent'        => '',
							'orderby'       => 'name',
							'order'         => 'ASC',
							'hide_empty'    => 0,
							'hierarchical'  => 1,
							'exclude'       => '',
							'include'       => '',
							'number'        => '',
							'taxonomy'      => 'category',
							'pad_counts'    => false
						);
			$portfolio_categories =  get_categories($args); 
			//print_r($portfolio_categories);
			$portfolio_cats_array = array();
			$portfolio_cats_array[] = $id;
			foreach($portfolio_categories as $category)
			{
				$portfolio_cats_array[] = $category->term_id;
			}
			//$portfolio_cats_array = explode(',', $portfolio_categories);
			
			$portfolio_cats_array_with_minus = array_map( "add_minus_prefix", $portfolio_cats_array );
			$excluded_cats_array[] = implode(',', $portfolio_cats_array_with_minus);
		}
		
		if( $exclude_our_team_from_blog == 'exclude' ){
			// get the our team categories to be excluded from the Blog section
			$our_team_categories = $ns_options_frnt['ns_our_team_cat_slug'];
			$cat_id = get_category_by_slug($our_team_categories);
			$id = $cat_id->term_id;
				
			$args = array(
							'type'			=> 'post',
							'child_of'      => $id,
							'parent'        => '',
							'orderby'       => 'name',
							'order'         => 'ASC',
							'hide_empty'    => 0,
							'hierarchical'  => 1,
							'exclude'       => '',
							'include'       => '',
							'number'        => '',
							'taxonomy'      => 'category',
							'pad_counts'    => false
						);
			$our_team_categories =  get_categories($args); 
			$our_team_cats_array = array();
			$our_team_cats_array[] = $id;
			foreach($our_team_categories as $category)
			{
				$our_team_cats_array[] = $category->term_id;
			}
			
			$our_team_cats_array_with_minus = array_map( "add_minus_prefix", $our_team_cats_array );
			$excluded_cats_array[] = implode(',', $our_team_cats_array_with_minus);
		}
		
		$excluded_cats = implode(',', $excluded_cats_array);
		
		// exit($excluded_cats);
		// $query_string = "cat=$portfolio_cats_with_minus&paged=$paged";
		$query_string = "cat=$excluded_cats&paged=$paged";
		
		query_posts( $query_string );
	}
	else
	{
		$id = (intval($_GET['cat_id']) ? $_GET['cat_id'] : $cat_id->term_id);

		global $query_string; 
			$args = array(
						'numberposts'     => '',
						'offset'          => 0,
						'posts_per_page'	=> 5,
						'cat'        =>  '',
						'orderby'         => 'date',
						'order'           => 'DESC', 
						'include'         => '',
						'exclude'         => '',
						'meta_key'        => '',
						'meta_value'      => '',
						'post_type'       => 'post',
						'post_mime_type'  => '',
						'post_parent'     => '',
						'paged'				=> $paged,
						'post_status'     => 'publish'
					);

		// $query_string = "paged=$paged";

		query_posts( $args );
	}
?>


<div role="main">
		<section>
			
				
			<section>
				
				
			<?php $post_id = '';?>	
			<?php $i = 0; ?>
			  <?php   if (have_posts()) : 	while (have_posts()) : the_post(); ?>
						 <?php $format = get_post_format( $post_id ); ?> 
						 <?php switch ($format){
								case 'audio':
									$img = get_template_directory_uri().'/images/audio_post_icon.png';
									$contentup = '';
									
									$content = '<div class="blog-hr hr"></div><div id="audio-object" class="intro-audio">
										'.$post->post_content.'
									</div>';
								break;
								case 'image':
									$item_img = get_post_custom_values('portfolio_item_thumb',$post->ID);
									if (!$item_img)
									{
										$item_img = wp_get_attachment_image_src ( get_post_thumbnail_id ( $post->ID ), 'thumbnail' );
									}
									$arry['src'] = $item_img[0];
									
									$contentup = '<div id="ship-img">
										<a class="view" rel="prettyPhoto" href="'.$arry['src'].'" title="'.get_the_title($post->ID).'">'.
										get_post_image_fn($post->ID, 290, 230).'</a>
										
									</div>';
									$content = '<article class="blog-entry">
											   '.$post->post_content.'
												
												</article>';
								break;
								case 'gallery':
									$img = get_template_directory_uri().'/images/slider_post_icon.png';
									$gallery = get_post_meta($post->ID, 'gallery_image', false);
									
									$contentup = "<div class='blog-gallery'><div id='third' class='small' >";
									foreach($gallery as $el){
									
									
										$contentup .= "
											<div class='slider-cell-small' data-src='".$el."'> 
											<div class='slider-nav-secondary fadeIn'>
														<div class='camera_prev'><span></span></div>
														<div class='camera_next'><span></span></div>
											</div>";
	
										$contentup .= "</div>";
									
									}
									$contentup .= "</div><div class='clear'></div></div><div class='small blog-hr hr'></div>";
									$content = '<article class="blog-entry">
												'.$post->post_content.'
											   
												</article>';
								break;
								
								case 'video':
									$img = get_template_directory_uri().'/images/play.png';
									
									$video_code = get_post_meta($post->ID, 'portfolio_item_video', true);

									$video_code = preg_replace('/width=\"(\\d+)\"/', 'width="290"', $video_code);
									$video_code = preg_replace('/height=\"(\\d+)\"/', 'height="230"', $video_code);
									$contentup = '<div id="video-object"  >
										'.$video_code.'
									</div>';
									$content = '<article class="blog-entry">
											   '.$post->post_content.'
												
												</article>';
								break;
								case 'aside':
									$img = get_template_directory_uri().'/images/aside_post.png';
									$top_img = get_post_image_fn($post->ID, 290, 230);
									
									//echo $top_img;
									$contentup = '<div class="clear"></div><div class="small blog-hr hr"></div>';
									if($top_img){
										$link = '<a class="" href="'. $post->guid.'">'.$top_img.'</a>';
										$contentup = '<div id="ship-img">
										'.$link.'
										</div>';
									}
									//$contentup .= '';
									$content = '<article class="blog-entry">
											   '.$post->post_content.'
												
												<article>';
								break;
								default:
									$contentup = '';
									$img = get_template_directory_uri().'/images/post_icon_.png';
									$top_img = get_post_image_fn($post->ID, 290, 230);
									//echo $top_img;
									//$contentup = '<div class="clear"></div><div class="small blog-hr hr"></div>';
									if($top_img){
										$link = '<a class="" href="'. $post->guid.'">'.$top_img.'</a>';
										$contentup = '<div id="ship-img_">
										'.$link.'
										</div>';
									}
									//$contentup .= '';
									$content = '<article class="blog-entry">
											   '.$post->post_content.'
												
												<article>';
								break;

						 }?>
						<div class="blog-item">
							<?php if($contentup != '<div class="clear"></div><div class="small blog-hr hr"></div>' && $contentup != '' ){ ?>
							<div class="blog2-item-1 <?php echo ($i % 2) ? 'left':'right'?>">	
								<?php echo $contentup?>
								<?php if (is_array($tags) && count($tags) > 0){?>
									<div class="tags">
										<span>Tags:</span> 
										<?php $t=0; $cnt = count($tags); foreach ($tags as $itemz){ $t++;?>
											<a title="<?php echo $itemz->name?>" href="<?php echo $itemz->slug?>"><?php echo $itemz->name?></a> <?php echo $t < $cnt ? ',' : ''?> 
										<?php }?>
									</div>
								<?php }?>
							</div>
							<?php } ?>
							<div class="blog2-item-2 <?php echo ($contentup != '<div class="clear"></div><div class="small blog-hr hr"></div>' && $contentup != '' )?'':'no-width' ?>">
								<div class="item-title">
									<a class="" href="<?php the_permalink(); ?>"><img src="<?php echo $img?>" class="blog-icon" alt="" /></a>
									<a href="<?php the_permalink(); ?>" title="<?php echo $post->post_title; ?>"><h2 class="blue"><?php echo $post->post_title?></h2>
									<div class="blog-info"><span>Date:</span> <span><?php echo date('d.m.Y',strtotime($post->post_modified))?></span> 
									<?php if($ns_options_frnt['ns_cs_showPostAuthor'] == 'show'){?>
										<span class="spacer">|</span> <a title="" href="<?php the_author_link();?>"><?php the_author();?></a> 
									<?php }?>
									<?php if($ns_options_frnt['ns_cs_showPostTags'] == 'show'){?>
										<?php $tags = wp_get_post_tags( $post->ID, $args );?> 
										
									<?php }?>
									<span class="spacer">|</span> 
									<?php the_category(", "); ?>
									<span class="spacer">|</span> 
									<a title="" href="<?php echo $post->guid?>"><?php echo $post->comment_count ? $post->comment_count : 0?>  Comments</a></div>
								</div>
								<?php //=$content?>
								<?php
									if ( $ns_options_frnt['ns_csShowExcerpt'] == 'show' ) 
									{
										if ((int)$ns_options_frnt['ns_cs_excerptLength'])
										{
											$excerpt = get_the_excerpt();
											echo string_limit_words($excerpt, (int) $ns_options_frnt['ns_cs_excerptLength']); //display the excerpt
											// echo string_limit_words(the_content(), (int) $ns_options_frnt['ns_cs_excerptLength']); //display the excerpt
										}else
										{
											// the_excerpt();
										}	
									}else{
										the_content();
									} 
								?>
							</div>
						
						

						
						
					   
					   <div class="clear"></div>
					   
						<?php if ($ns_options_frnt['ns_cs_readMoreLink']!='') : ?>
						<a class="post-link all" href="<?php the_permalink(); ?>"><?php echo $ns_options_frnt['ns_cs_readMoreLink'];?></a>
						<?php endif; ?>
					
						<div class="blog-hr hr"></div>
					
					</div>
					
				<?php $i++;	endwhile;
				
				else:
					echo '<h3>Sorry! No post found.</h3>';
				endif;
			?>
				
			</section>
			<aside>
				
				<?php
					$bottom_row2_active = sidebar_exist_and_active('Blog Sidebar');
					if ( $bottom_row2_active ) {
						echo bottom_row2_get_contents( '', '', 'Blog Sidebar ' ); 
					}
				?>
				
			</aside>
			<div class="clear"></div>
			<section>
					<nav id="blog-nav-bottom">
						<?php	
							
							if(function_exists('wp_custom_corenavi')){
								wp_custom_corenavi();
							} else { ?>
								<?php previous_posts_link('prev&nbsp;&nbsp;&nbsp;&nbsp;<span class="prev"></span>') ?>
								<span>|</span>
								<?php next_posts_link('next&nbsp;&nbsp;&nbsp;&nbsp;<span class="next"></span>') ?>
									
						<?php	} ?>
						
					</nav>
				
			</section>
		</section>
		<?php
			$blog_bottom_row1_active = sidebar_exist_and_active('blog-bottom-row1');
			if ( $blog_bottom_row1_active && sizeof($ns_options_frnt['css_addSlide_field']) > 0 ) {
				echo ns_get_dynamic_sidebar( 'blog-bottom-row1' );
			}
		?>
	</div>



        



<?php 	get_footer(); ?>