<?php

add_theme_support( 'post-thumbnails', array( 'page' ) );
add_theme_support('automatic-feed-links');  // Add it for pages
set_post_thumbnail_size( 50, 50, true ); // 50 pixels wide by 50 pixels tall, hard crop mode

load_theme_textdomain('ns_theme', get_template_directory() . '/languages');
add_theme_support( 'post-formats', array( 'aside', 'gallery', 'image', 'audio', 'video') );
include_once ('framework/init.php');

$ns_options_frnt = get_option('ns_options');	

if ( ! isset( $content_width ) ) 
    $content_width = 900;
 global $cur_template;

add_filter( 'template_include', 'var_template_include', 1000 );
function var_template_include( $t ){
    $GLOBALS['current_theme_template'] = basename($t);
    return $t;
}

function plugin_is_active($plugin_var) {return in_array( $plugin_var. '/' .$plugin_var. '.php', apply_filters( 'active_plugins', get_option( 'active_plugins' ) ) ); }

function get_current_template( $echo = false ) {
    if( !isset( $GLOBALS['current_theme_template'] ) )
        return false;
    if( $echo )
        echo $GLOBALS['current_theme_template'];
    else
        return $GLOBALS['current_theme_template'];
}


add_filter('wp_nav_menu_objects', 'nav_customization' );

function hasSub ($menu_item_id, &$items) {
        foreach ($items as $item) {
            if ($item->menu_item_parent && $item->menu_item_parent==$menu_item_id) {
                return true;
            }
        }
        return false;
    };

function nav_customization ($items)
{
	foreach ($items as &$item) {
        // if ( hasSub($item->ID, &$items)) { // Fatal error: Call-time pass-by-reference has been removed in site_path\site_name\wp-content\themes\cavus\functions.php on line 81
        if ( hasSub($item->ID, $items)) {
            $item->classes[] = 'li_parent'; // all elements of field "classes" of a menu item get join together and render to class attribute of <li> element in HTML
            break;
        }
    }
    return $items;	
}


add_filter('nav_menu_css_class', 'ns_menu_current_item_class', 100, 1);
add_filter('nav_menu_item_id', 'ns_menu_current_item_class', 100, 1);
add_filter('page_css_class', 'ns_menu_current_item_class', 100, 1);
function ns_menu_current_item_class ($var) 
{
 
	$current = '' ;
	if (is_array($var))
	{ 
		if (in_array( 'current-menu-item', $var) || in_array( 'current_page_item', $var) )
		{
			$current = array ('current'); 
			return array_merge($var, $current);
		}
		else
		{
			return $var;
		}
	}
	
}


////----------------------------- START DESIGN CUSTOMIZATION -------------------------------------------------

function translatable_search_form( $form ) {
	$form = '
            <div class="search-form">
              <form role="search" method="get" id="searchform" action="'.home_url().'" >
                <input type="text" placeholder="Looking for something?" value="' . get_search_query() . '" name="s">
                <input type="submit" value="Search">
              </form>
            </div>';
		  return $form;
}
add_filter( 'get_search_form', 'translatable_search_form' );


function translatable_categories( $output )
{
	$categories = get_categories();
	
	$output = '<nav class="categories">
          	<h2 class="blue">Categories</h2>
            <ul>
			
			'. $output.'
            	
            </ul>
          </nav>';

	//$output = str_replace('</a> (','<span> ', $output);
	//$output = str_replace(')','</span></a> ', $output);
	
	return $categories;
}
//add_filter('wp_list_categories', 'translatable_categories');
//wp_dropdown_categories(apply_filters('widget_categories_dropdown_args', $cat_args));
//add_filter( 'WP_Widget_Categories', 'translatable_categories' );

function test_args()
{
	return  $my_args = array(
		'show_option_all'    => '',
		'orderby'            => 'name',
		'order'              => 'ASC',
		'show_last_update'   => 0,
		'style'              => 'list',
		'show_count'         => 0,
		'hide_empty'         => 1,
		'use_desc_for_title' => 1,
		'child_of'           => 0,
		'feed'               => '',
		'feed_type'          => '',
		'feed_image'         => '',
		'exclude'            => '',
		'exclude_tree'       => '',
		'include'            => '',
		'hierarchical'       => true,
		'title_li'           => '<h4>'.__('Categories', 'ns_theme').'</h4>',
		'show_option_none'   => __('No categories','ns_theme'),
		'number'             => NULL,
		'echo'               => 1,
		'depth'              => 0,
		'current_category'   => 0,
		'pad_counts'         => 0,
		'taxonomy'           => 'category'
		//'walker'             => 'Walker_Category' 
	);
}

add_filter( 'widget_categories_args', 'test_args' );

////----------------------------- END DESIGN CUSTOMIZATION -------------------------------------------------


//$theme_style = $ns_options_frnt['cs_skin'];	//	dark or default
//$theme_layout = $ns_options_frnt['cs_layout']; // wide or normal
//$nav_type = $ns_options_frnt['cs_menu_type']; // header or dropdown
//$slider_type = $ns_options_frnt['ns_select_slider'];	// nivo, jfancytile, c1, c3, no_slider
//$portfolio_type = $ns_options_frnt['ns_pf_layout'];	// one or two
$ns_options_frnt['theme_custom_skin'] = 'true' ; //$ns_options_frnt['theme_custom_skin'];
//$path_img = get_bloginfo('template_url').'/stylesheets/images/';



if ( ! function_exists( 'twentyten_posted_on' ) ) :

function twentyten_posted_on() {
	printf( __( '<span class="%1$s">Posted on</span> %2$s <span class="meta-sep">by</span> %3$s', 'ns_theme' ),
		'meta-prep meta-prep-author',
		sprintf( '<a href="%1$s" title="%2$s" rel="bookmark"><span class="entry-date">%3$s</span></a>',
			get_permalink(),
			esc_attr( get_the_time() ),
			get_the_date()
		),
		sprintf( '<span class="author vcard"><a class="url fn n" href="%1$s" title="%2$s">%3$s</a></span>',
			get_author_posts_url( get_the_author_meta( 'ID' ) ),
			esc_attr( sprintf( __( 'View all posts by %s', 'ns_theme' ), get_the_author() ) ),
			get_the_author()
		)
	);
}
endif;


if ( ! function_exists( 'ns_posted_on' ) ) :

function ns_posted_on() {
	printf( __( 'Posted on %1$s  <span class="bywho">by %2$s</span> ', 'ns_theme' ), get_the_date(), get_the_author()	) ;
}
endif;

if ( ! function_exists( 'ns_posted_on_post' ) ) :

function ns_posted_on_post() {
	printf( __( '<span class="lab">'.__('Posted on', 'ns_theme').'</span> %1$s', 'ns_theme' ), get_the_date() );
}
endif;

if ( ! function_exists( 'ns_posted_on_sidebar' ) ) :

function ns_posted_on_sidebar() {
	printf( __( '<span class="%1$s">'.__('Posted on', 'ns_theme').'</span> %2$s <span class="meta-sep">by</span> %3$s', 'ns_theme' ),
		'meta-prep meta-prep-author',
		sprintf( '<a href="%1$s" title="%2$s" rel="bookmark"><span class="entry-date">%3$s</span></a>',
			get_permalink(),
			esc_attr( get_the_time() ),
			get_the_date()
		),
		sprintf( '<span class="author vcard"><a class="url fn n" href="%1$s" title="%2$s">%3$s</a></span>',
			get_author_posts_url( get_the_author_meta( 'ID' ) ),
			esc_attr( sprintf( __( 'View all posts by %s', 'ns_theme' ), get_the_author() ) ),
			get_the_author()
		)
	);
}
endif;
/*----------------------------------------------------------------------------------------------*/
if ( ! function_exists( 'ns_theme_posted_in' ) ) :
/**
 * Prints HTML with meta information for the current post (category, tags and permalink).
 *
 * @since Twenty Ten 1.0
 */
function ns_theme_posted_in() {
	// Retrieves tag list of current post, separated by commas.
	$tag_list = get_the_tag_list( '', ', ' );
	if ( $tag_list ) {
		$posted_in = __( 'This entry was posted in %1$s and tagged %2$s. Bookmark the <a href="%3$s" title="Permalink to %4$s" rel="bookmark">permalink</a>.', 'ns_theme' );
	} elseif ( is_object_in_taxonomy( get_post_type(), 'category' ) ) {
		$posted_in = __( 'This entry was posted in %1$s. Bookmark the <a href="%3$s" title="Permalink to %4$s" rel="bookmark">permalink</a>.', 'ns_theme' );
	} else {
		$posted_in = __( 'Bookmark the <a href="%3$s" title="Permalink to %4$s" rel="bookmark">permalink</a>.', 'ns_theme' );
	}
	// Prints the string, replacing the placeholders.
	printf(
		$posted_in,
		get_the_category_list( ', ' ),
		$tag_list,
		get_permalink(),
		the_title_attribute( 'echo=0' )
	);
}
endif;




if ( ! function_exists( 'ns_theme_comment' ) ) :
/**
 * Template for comments and pingbacks.
 *
 * To override this walker in a child theme without modifying the comments template
 * simply create your own ns_theme_comment(), and that function will be used instead.
 *
 * Used as a callback by wp_list_comments() for displaying the comments.
 *
 * @since Twenty Ten 1.0
 */
 

function ns_theme_comment( $comment, $args, $depth ) {
	$GLOBALS['comment'] = $comment;
	switch ( $comment->comment_type ) :
		case '' :
	?>
    <div class="comment">
		<div class="avatar"><?php echo get_avatar( $comment, 50 ); ?></div>
		<div class="comment-data">
			<h3 class="blue"><?php the_author();?></h3>
			<div class="blog-info">
				<span>Date:</span> <span><?php  get_comment_date();?></span> 
				<span class="spacer">|</span> 
				<?php comment_reply_link( array_merge( $args, array( 'depth' => $depth, 'max_depth' => $args['max_depth'] ) ) ); ?>
			</div>
			<?php comment_text(); ?>
		</div>
		<div class="clear"></div>
	</div>
	<div class="clear"></div>
	<div class="blog-hr hr"></div>

	<?php
			break;
		case 'pingback'  :
		case 'trackback' :
	?>
	<li class="post pingback">
		<p><?php _e( 'Pingback:', 'ns_theme' ); ?> <?php comment_author_link(); ?><?php edit_comment_link( __( '(Edit)', 'ns_theme' ), ' ' ); ?></p>
	<?php
			break;
	endswitch;
}
endif;


/*-------------------------------------------------- START SIDEBARS --------------------*/
// This theme uses post thumbnails
	add_theme_support( 'post-thumbnails' );
	
// This theme uses wp_nav_menu() in one location.
	register_nav_menus( array(
		'primary' => __( 'Primary Navigation', 'my_twentyten' ),
	) );
	

if ( function_exists('register_sidebar') ) {

	//Sidebar for Blog
	register_sidebar( array(
		'name' => 'Blog Sidebar',
		'id' => 'blog-sidebar',
		'description' => __( 'Blog sidebar widget area', 'wordpress' ),
		'before_widget' => '<nav>',
		'after_widget' => '</nav>',
		'before_title' => '<h2 class="blue">',
		'after_title' => '</h2>',
	) );
	
	register_sidebar( array(
		'name' => 'Blog Bottom Row',
		'id' => 'blog-bottom-row1',
		'description' => __( 'Blog Row After Content widget area', 'ns_theme' ),
		'before_widget' => '<div class="clear"></div>',
		'after_widget' => '',
		'before_title' => '<h2 class="blue">',
		'after_title' => '</h2>'
	) );
	
	register_sidebar( array(
		'name' => 'Blog Single Sidebar',
		'id' => 'single-sidebar',
		'description' => __( 'Single page sidebar widget area', 'ns_theme' ),
		'before_widget' => '<nav>',
		'after_widget' => '</nav>',
		'before_title' => '<h2 class="blue">',
		'after_title' => '</h2>',
	) );
	
	
	//Sidebar for Blog
	/*register_sidebar( array(
		'name' => 'Top Header Social Sidebar',
		'id' => 'top-header-social-sidebar',
		'description' => __( 'Header social media links sidebar widget area', 'Calvus Theme' ),
		'before_widget' => '',
		'after_widget' => '',
		'before_title' => '',
		'after_title' => '',
	) );
	*/
	//Sidebar for Portfolio
	register_sidebar( array(
		'id' => 'portfolio-sidebar',
		'name' => 'Portfolio Sidebar 1',
		'description' => __( 'Portfolio Sidebar widget area', 'wordpress' ),
		'before_widget' => '<li id="%1$s" class="widget-container %2$s">',
		'after_widget' => '</li>',
		'before_title' => '<h3 class="widget-title">',
		'after_title' => '</h3>',
	) );
	
	register_sidebar( array(
		'id' => 'portfolio-sidebar2',
		'name' => __( 'Portfolio Sidebar 2', 'ns_theme' ),
		'description' => __( 'Portfolio Sidebar 2 widget area.', 'ns_theme' ),
		'before_widget' => '',
		'after_widget' => '',
		'before_title' => '<h2 class="blue">',
		'after_title' => '</h2>',
	) );
	
	register_sidebar( array(
		'id' => 'portfolio-content-row1',
		'name' => __( 'Portfolio After Content Row', 'ns_theme' ),
		'description' => __( 'Portfolio Row 1 widget area.', 'ns_theme' ),
		'before_widget' => '',
		'after_widget' => '',
		'before_title' => '<h3 class="widget-title">',
		'after_title' => '</h3>',
	) );
	
	register_sidebar( array(
		'name' => 'Portfolio Bottom Row',
		'id' => 'portfolio-bottom-row1',
		'description' => __( 'Portfolio Bottom Row 1 widget area', 'ns_theme' ),
		'before_widget' => '',
		'after_widget' => '',
		'before_title' => '<h2 class="blue">',
		'after_title' => '</h2>'
	) );
	
	// About Us Sidebar Row 1
	/*register_sidebar( array(
		'id' => 'about-us-sidebar-row1',
		'name' => __( 'About Us Sidebar Row 1', 'ns_theme' ),
		'description' => __( 'Sidebar Widget Area for About Us Page.', 'ns_theme' ),
		'before_widget' => '<nav>',
		'after_widget' => '</nav>',
		'before_title' => '<h2 class="blue">',
		'after_title' => '</h2>',
	) );
	*/
	// About Us Content Row 1
	/*register_sidebar( array(
		'id' => 'about-us-content-row1',
		'name' => __( 'About Us Content Row 1', 'ns_theme' ),
		'description' => __( 'Sidebar Widget Area for About Us Page.', 'ns_theme' ),
		'before_widget' => '',
		'after_widget' => '<div class="clear"></div>',
		'before_title' => '',
		'after_title' => '',
	) );
	*/
	// About Us Sidebar Row 2
	/*register_sidebar( array(
		'id' => 'about-us-sidebar-row2',
		'name' => __( 'About Us Sidebar Row 2', 'ns_theme' ),
		'description' => __( 'Sidebar Widget Area for About Us Page.', 'ns_theme' ),
		'before_widget' => '<nav>',
		'after_widget' => '</nav>',
		'before_title' => '<h2 class="blue">',
		'after_title' => '</h2>',
	) );
	*/
	// About Us Content Row 2
	/*register_sidebar( array(
		'id' => 'about-us-content-row2',
		'name' => __( 'About Us Content Row 2', 'ns_theme' ),
		'description' => __( 'Sidebar Widget Area for About Us Page.', 'ns_theme' ),
		'before_widget' => '',
		'after_widget' => '',
		'before_title' => '',
		'after_title' => '',
	) );
	*/
	// About Us Sidebar Row 3
	/*register_sidebar( array(
		'id' => 'about-us-sidebar-row3',
		'name' => __( 'About Us Sidebar Row 3', 'ns_theme' ),
		'description' => __( 'Sidebar Widget Area for About Us Page.', 'ns_theme' ),
		'before_widget' => '<nav>',
		'after_widget' => '</nav>',
		'before_title' => '<h2 class="blue">',
		'after_title' => '</h2>',
	) );
	*/
	// About Us Content Row 3
	/*register_sidebar( array(
		'id' => 'about-us-content-row3',
		'name' => __( 'About Us Content Row 3', 'ns_theme' ),
		'description' => __( 'Sidebar Widget Area for About Us Page.', 'ns_theme' ),
		'before_widget' => '<div id="profile">',
		'after_widget' => '</div>',
		'before_title' => '',
		'after_title' => '',
	) );
	*/
	/*register_sidebar( array(
		'name' => 'About Us Bottom Row 1',
		'id' => 'about-us-bottom-row1',
		'description' => __( 'About Us Bottom Row widget area', 'ns_theme' ),
		'before_widget' => '',
		'after_widget' => '',
		'before_title' => '<h2 class="blue">',
		'after_title' => '</h2>'
	) );
	*/
	// sidebar 1
	register_sidebar( array(
		'id' => 'home-page-above-content-area',
		'name' => __( 'Homepage Before Content Area', 'ns_theme' ),
		'description' => __( 'This side bar displays the content on home page top content area.', 'ns_theme' ),
		'before_widget' => '',
		'after_widget' => '',
		'before_title' => '<h3 class="widget-title">',
		'after_title' => '</h3>',
	) );
	
	//Col 1 Home page
	register_sidebar( array(
		'id' => 'home-page-col1',
		'name' => __( 'Homepage Column 1', 'ns_theme' ),
		'description' => __( 'This side bar displays the content on home page column 1.', 'ns_theme' ),
		'before_widget' => '',
		'after_widget' => '',
		'before_title' => '<h2 class="blue">',
		'after_title' => '</h2>',
	) );
	
	//Col 2 Home page
	register_sidebar( array(
		'id' => 'home-page-col2',
		'name' => __( 'Homepage Column 2 ', 'ns_theme' ),
		'description' => __( 'This side bar displays the content on home page column 2.', 'ns_theme' ),
		'before_widget' => '',
		'after_widget' => '',
		'before_title' => '<h2 class="blue">',
		'after_title' => '</h2>',
	) );
	
	//Col 3 Home page
	register_sidebar( array(
		'id' => 'home-page-col3',
		'name' => __( 'Homepage Column 3 ', 'ns_theme' ),
		'description' => __( 'This side bar displays the content on home page column 3.', 'ns_theme' ),
		'before_widget' => '',
		'after_widget' => '',
		'before_title' => '<h2 class="blue">',
		'after_title' => '</h2>',
	) );
	
	//Col 4 Home page
	register_sidebar( array(
		'id' => 'home-page-col4',
		'name' => __( 'Homepage Column 4 ', 'ns_theme' ),
		'description' => __( 'This side bar displays the content on home page column 4.', 'ns_theme' ),
		'before_widget' => '',
		'after_widget' => '',
		'before_title' => '',
		'after_title' => '',
	) );
	
	
	
	
	// Home page main content row1
	register_sidebar( array(
		'id' => 'home-page-main-content-row1',
		'name' => __( 'Home Page After Content Row 1', 'ns_theme' ),
		'description' => __( 'This side bar displays the main content on home page.', 'ns_theme' ),
		'before_widget' => '',
		'after_widget' => '',
		'before_title' => '',
		'after_title' => '',
	) );
	
	// Home page after content row1
	/*register_sidebar( array(
		'id' => 'home-page-after-content-row1',
		'name' => __( 'Home page after content row1', 'ns_theme' ),
		'description' => __( 'This side bar displays the main content on home page after content row 1.', 'ns_theme' ),
		'before_widget' => '',
		'after_widget' => '',
		'before_title' => '',
		'after_title' => '',
	) );*/
	
	// Home page main contents
	register_sidebar( array(
		'id' => 'home-page-main-contents',
		'name' => __( 'Home Page After Content Row 2', 'ns_theme' ),
		'description' => __( 'This side bar displays the main content on home page.', 'ns_theme' ),
		'before_widget' => '',
		'after_widget' => '',
		'before_title' => '<h3 class="widget-title">',
		'after_title' => '</h3>',
	) );
	
	// sidebar 4
	register_sidebar( array(
		'id' => 'home-page-main-content-bottom',
		'name' => __( 'Homepage  Bottom', 'ns_theme' ),
		'description' => __( 'This side bar displays the bottom contents on home page.', 'ns_theme' ),
		'before_widget' => '',
		'after_widget' => '',
		'before_title' => '<h3 class="widget-title">',
		'after_title' => '</h3>',
	) );
	
	/*// Home page after content bottom
	
	register_sidebar( array(
		'id' => 'home-page-after-content-bottom',
		'name' => __( 'Home page after content bottom', 'ns_theme' ),
		'description' => __( 'This side bar displays the bottom contents on home page after main content bottom.', 'ns_theme' ),
		'before_widget' => '',
		'after_widget' => '',
		'before_title' => '',
		'after_title' => '',
	) );*/
	
	//Bootom 1 Home page
	/*register_sidebar( array(
		'id' => 'home-page-bottom1',
		'name' => __( 'Home page bottom 1 sidebar', 'ns_theme' ),
		'description' => __( 'This side bar displays the content on home page bottom 1.', 'ns_theme' ),
		'before_widget' => '',
		'after_widget' => '',
		'before_title' => '',
		'after_title' => '',
	) );
	*/
	// Bottom 2 Home page
	/*register_sidebar( array(
		'id' => 'home-page-bottom2',
		'name' => __( 'Home page bottom 2 sidebar', 'ns_theme' ),
		'description' => __( 'This side bar displays the content on home page bottom 2.', 'ns_theme' ),
		'before_widget' => '',
		'after_widget' => '',
		'before_title' => '',
		'after_title' => '',
	) );
	*/
	// Bottom 3 Home page
	/*register_sidebar( array(
		'id' => 'home-page-bottom3',
		'name' => __( 'Home page bottom 3 sidebar', 'ns_theme' ),
		'description' => __( 'This side bar displays the content on home page bottom 3.', 'ns_theme' ),
		'before_widget' => '',
		'after_widget' => '',
		'before_title' => '',
		'after_title' => '',
	) );
	*/
	// Bottom 4 Home page
	/*register_sidebar( array(
		'id' => 'home-page-bottom4',
		'name' => __( 'Home page bottom 4 sidebar', 'ns_theme' ),
		'description' => __( 'This side bar displays the content on home page bottom 4.', 'ns_theme' ),
		'before_widget' => '',
		'after_widget' => '',
		'before_title' => '',
		'after_title' => '',
	) );
	*/
	
	
	
	// sidebar 9
	/*register_sidebar( array(
		'id' => 'bottom-row2',
		'name' => __( 'Home Page Bottom Row 2', 'ns_theme' ),
		'description' => __( 'This side bar displays the Bottom Area Row-2.', 'ns_theme' ),
		'before_widget' => '',
		'after_widget' => '',
		'before_title' => '<h3 class="widget-title">',
		'after_title' => '</h3>',
	) );
	*/
	
	
	
	// Services Sidebar
	/*register_sidebar( array(
		'id' => 'services-sidebar',
		'name' => __( 'Services Sidebar', 'ns_theme' ),
		'description' => __( 'This side bar displays the text in Sidebar.', 'ns_theme' ),
		'before_widget' => '',
		'after_widget' => '',
		'before_title' => '<h2 class="blue">',
		'after_title' => '</h2>',
	) );
	*/
	// sidebar 5
	/*register_sidebar( array(
	  'id' => 'services-above-content-area',
	  'name' => __( 'Services Above Content Area', 'ns_theme' ),
	  'description' => __( 'This sidebar display the text above main contents.', 'ns_theme' ),
	  'before_widget' => '',
	  'after_widget' => '',
	  'before_title' => '<h3 class="widget-title">',
	  'after_title' => '</h3>',
 	) );*/
	// sidebar 6
	/*register_sidebar( array(
		'id' => 'services-main-content-row1',
		'name' => __( 'Sercices page main content row1', 'ns_theme' ),
		'description' => __( 'This side bar displays the main contents row 1 on Services page.', 'ns_theme' ),
		'before_widget' => '',
		'after_widget' => '',
		'before_title' => '<h3 class="widget-title">',
		'after_title' => '</h3>',
	) );*/
	// sidebar 7
	/*register_sidebar( array(
		'id' => 'services-main-contents',
		'name' => __( 'Services main contents', 'ns_theme' ),
		'description' => __( 'This side bar displays the main content on services page.', 'ns_theme' ),
		'before_widget' => '',
		'after_widget' => '',
		'before_title' => '<h3 class="widget-title">',
		'after_title' => '</h3>',
	) );
	*/
	// sidebar 8
	register_sidebar( array(
		'id' => 'contact-us-top-contents',
		'name' => __( 'Contact Us Sidebar 1', 'ns_theme' ),
		'description' => __( 'Sidebar Widget Area for Contact Us Top part of Page', 'ns_theme' ),
		'before_widget' => '',
		'after_widget' => '',
		'before_title' => '<h3 class="widget-title">',
		'after_title' => '</h3>',
	) );
	// sidebar 8
	register_sidebar( array(
		'id' => 'contact-us-contents',
		'name' => __( 'Contact Us Sidebar 2', 'ns_theme' ),
		'description' => __( 'Sidebar Widget Area for Contact Us Page', 'ns_theme' ),
		'before_widget' => '',
		'after_widget' => '',
		'before_title' => '<h3 class="widget-title">',
		'after_title' => '</h3>',
	) );
	register_sidebar( array(
		'id' => 'contact-us-bottom-contents',
		'name' => __( 'Contact Us Sidebar 3', 'ns_theme' ),
		'description' => __( 'Sidebar Widget Area for Contact Us Bottom Page', 'ns_theme' ),
		'before_widget' => '',
		'after_widget' => '',
		'before_title' => '<h2 class="blue">',
		'after_title' => '</h2>',
	) );
	register_sidebar( array(
		'name' => 'Contact Us Bottom Row ',
		'id' => 'contact-us-bottom-row1',
		'description' => __( 'Contact Us Bottom Row widget area', 'ns_theme' ),
		'before_widget' => '',
		'after_widget' => '',
		'before_title' => '<h2 class="blue">',
		'after_title' => '</h2>'
	) );
	
	//Page Slider Sidebar
	/*register_sidebar( array(
		'name' => 'Slider Sidebar',
		'id' => 'slider-sidebar',
		'description' => __( 'Slider sidebar widget area', 'ns_theme' ),
		'before_widget' => '<nav>',
		'after_widget' => '</nav>',
		'before_title' => '<h3 class="widget-title">',
		'after_title' => '</h3>'
	) );
	*/
	//Page Slider Sidebar
	register_sidebar( array(
		'name' => 'Slider Page Template 1 ',
		'id' => 'slider-sidebar1',
		'description' => __( 'Slider sidebar 1 widget area', 'ns_theme' ),
		'before_widget' => '<nav>',
		'after_widget' => '</nav>',
		'before_title' => '<h3 class="widget-title">',
		'after_title' => '</h3>'
	) );
	//Page Slider Sidebar
	register_sidebar( array(
		'name' => 'Slider Page Template 2',
		'id' => 'slider-sidebar2',
		'description' => __( 'Slider sidebar 2 widget area', 'ns_theme' ),
		'before_widget' => '<nav>',
		'after_widget' => '</nav>',
		'before_title' => '<h3 class="widget-title">',
		'after_title' => '</h3>'
	) );
	//Page Slider Sidebar
	register_sidebar( array(
		'name' => 'Slider Page Template 3',
		'id' => 'slider-sidebar3',
		'description' => __( 'Slider sidebar 3 widget area', 'ns_theme' ),
		'before_widget' => '<nav>',
		'after_widget' => '</nav>',
		'before_title' => '<h3 class="widget-title">',
		'after_title' => '</h3>'
	) );
	
	
	
	//Page Template 1 Sidebar
	register_sidebar( array(
		'name' => 'Page Template 1 Sidebar',
		'id' => 'page-template-1-sidebar',
		'description' => __( 'Page Template 1 sidebar widget area', 'ns_theme' ),
		'before_widget' => '<nav>',
		'after_widget' => '</nav>',
		'before_title' => '<h3 class="widget-title">',
		'after_title' => '</h3>'
	) );
	
	register_sidebar( array(
		'name' => 'Page Template 1 Bottom Row ',
		'id' => 'page-template-1-row1',
		'description' => __( 'Page Template Row After Content widget area', 'ns_theme' ),
		'before_widget' => '',
		'after_widget' => '',
		'before_title' => '<h2 class="blue">',
		'after_title' => '</h2>'
	) );
	
	//Page Template 2 Sidebar
	register_sidebar( array(
		'name' => 'Page Template 2 Sidebar',
		'id' => 'page-template-2-sidebar',
		'description' => __( 'Page Template 2 sidebar widget area', 'ns_theme' ),
		'before_widget' => '<nav>',
		'after_widget' => '</nav>',
		'before_title' => '<h3 class="widget-title">',
		'after_title' => '</h3>'
	) );
	
	register_sidebar( array(
		'name' => 'Page Template 2 Bottom Row ',
		'id' => 'page-template-2-row1',
		'description' => __( 'Page Template Row After Content widget area', 'ns_theme' ),
		'before_widget' => '',
		'after_widget' => '',
		'before_title' => '<h2 class="blue">',
		'after_title' => '</h2>'
	) );
	
	//Page Template 3 Sidebar
	register_sidebar( array(
		'name' => 'Page Template 3 Sidebar',
		'id' => 'page-template-3-sidebar',
		'description' => __( 'Page Template 3 sidebar widget area', 'ns_theme' ),
		'before_widget' => '<nav>',
		'after_widget' => '</nav>',
		'before_title' => '<h3 class="widget-title">',
		'after_title' => '</h3>'
	) );
	
	register_sidebar( array(
		'name' => 'Page Template 3 Bottom Row ',
		'id' => 'page-template-3-row1',
		'description' => __( 'Page Template Row After Content widget area', 'ns_theme' ),
		'before_widget' => '',
		'after_widget' => '',
		'before_title' => '<h2 class="blue">',
		'after_title' => '</h2>'
	) );
	
	
	/*register_sidebar( array(
		'name' => 'Page Template Sidebar',
		'id' => 'page-template-sidebar',
		'description' => __( 'Page Template sidebar widget area', 'ns_theme' ),
		'before_widget' => '<nav>',
		'after_widget' => '</nav>',
		'before_title' => '<h3 class="widget-title">',
		'after_title' => '</h3>'
	) );
	*/
	/*register_sidebar( array(
		'name' => 'Page Template After Content Row 1',
		'id' => 'page-template-row1',
		'description' => __( 'Page Template Row After Content widget area', 'ns_theme' ),
		'before_widget' => '',
		'after_widget' => '',
		'before_title' => '<h2 class="blue">',
		'after_title' => '</h2>'
	) );
	
	*/
	/*register_sidebar( array(
		'name' => 'Sitemap Sidebar',
		'id' => 'site-map-sidebar',
		'description' => __( 'Sitemap page sidebar widget area', 'ns_theme' ),
		'before_widget' => '<li id="%1$s" class="widget-container %2$s">',
		'after_widget' => '</li>',
		'before_title' => '<h3 class="widget-title">',
		'after_title' => '</h3>',
	) );
	*/
	
	register_sidebar( array(
		'name' => 'Footer Logo Column',
		'id' => 'footer-logo',
		'description' => __( 'Footer Logo column widget area', 'ns_theme' ),
		'before_widget' => '',
		'after_widget' => '',
		'before_title' => '<h2>',
		'after_title' => '</h2>',
	) );
	
	register_sidebar( array(
		'name' => 'Footer Left Column',
		'id' => 'footer-left',
		'description' => __( 'Footer Left column widget area', 'ns_theme' ),
		'before_widget' => '',
		'after_widget' => '',
		'before_title' => '<h2>',
		'after_title' => '</h2>',
	) );
	
	register_sidebar( array(
		'name' => 'Footer Center Column',
		'id' => 'footer-center',
		'description' => __( 'Footer Center column widget area', 'ns_theme' ),
		'before_widget' => '',
		'after_widget' => '',
		'before_title' => '<h2>',
		'after_title' => '</h2>',
	) );
	
	register_sidebar( array(
		'name' => 'Footer Right Column',
		'id' => 'footer-right',
		'description' => __( 'Footer Right column widget area', 'ns_theme' ),
		'before_widget' => '',
		'after_widget' => '',
		'before_title' => '<h2>',
		'after_title' => '</h2>',
	) );	
}


/*-------------------------------------------------- END SIDEBARS --------------------*/

/*-------------------------------------------------- START WIDGETS --------------------*/
 
require('479am_widgets.php');

/*-------------------------------------------------- END WIDGETS --------------------*/


/*---------------------------------------------- START SHORT CODES ------------------*/

add_filter('widget_text', 'do_shortcode');


require('short_codes.php');



/*---------------------------------------------- END SHORT CODES --------------------*/


/*--------------------------------------- START GET SIDEBAR CONTENTS  ---------------*/


// About Us Page Sidebar Contents
function about_us_sidebar_get_contents( $id = '', $class = '', $widget_area = '' ) {
    return ns_get_dynamic_sidebar( $widget_area );
}

// Return the column (widget area) HTML
function home_page_before_main_content_get_contents( $id = '', $class = '', $widget_area = '' ) {
    //return "<div class='before-main-content'><h1 class='$class'>".ns_get_dynamic_sidebar( $widget_area )."</h1></div><!-- end {$id} -->";
	return '<div class="'.$class.'"'.(!sidebar_exist_and_active('home-page-col1') ? 'style="width:100%"' : '').'>'.ns_get_dynamic_sidebar( $widget_area ).' <div class="clear"></div> </div> <div class="clear"></div>';
}

function home_page_main_contents_get_contents( $id = '', $class = '', $widget_area = '' ) {
    return '<div id="profile"'.(!sidebar_exist_and_active('home-page-col3') ? 'style="width:100%"' : '').'>'.ns_get_dynamic_sidebar( $widget_area ).'<div class="clear"></div> </div> <div class="clear"></div>';
}

function home_page_main_content_coloumns_get_contents( $id = '', $class = '', $widget_area = '' ) {
    // return '<div class="'.$class.'">'.ns_get_dynamic_sidebar( $widget_area )."</div>";
    return '<aside><nav>'.ns_get_dynamic_sidebar( $widget_area ).'</nav></aside>';
}

function home_page_main_content_bottom_coloumns_get_contents( $id = '', $class = '', $widget_area = '' ) {
    return '<div class="'.$class.'">'.ns_get_dynamic_sidebar( $widget_area )."</div>";
}



function home_page_main_content_row1_get_contents( $id = '', $class = '', $widget_area = '' ) {
    /*return '<div id="secondary"'.(!sidebar_exist_and_active('home-page-col2') ? 'style="width:100%"' : '').'>
				<div class="slider-nav-secondary">
					<div class="camera_prev"><span></span></div>
					<div class="camera_next"><span></span></div>
				</div>
				<div id="secondary-thumbs">'.ns_get_dynamic_sidebar( $widget_area ).'</div></div><div class="clear"></div>';*/
	return '<div id="profile2"'.(!sidebar_exist_and_active('home-page-col2') ? 'style="width:100%"' : '').'>'.ns_get_dynamic_sidebar( $widget_area ).'</div><div class="clear"></div>';
}

function home_page_main_content_bottom_get_contents( $id = '', $class = '', $widget_area = '' ) {
    return "<div class='$class'>".ns_get_dynamic_sidebar( $widget_area ).' <div class="clear"></div> </div>';
}


// services 
function services_before_main_content_get_contents( $id = '', $class = '', $widget_area = '' ) {
    return "<h1 class='$class'>".ns_get_dynamic_sidebar( $widget_area )."</h1><!-- end {$id} -->";
}

function services_main_content_row1_get_contents( $id = '', $class = '', $widget_area = '' ) {
    return "<div class='$class' >".ns_get_dynamic_sidebar( $widget_area )." </div><!-- end {$id} -->";
}
function services_main_contents_get_contents ( $id = '', $class = '', $widget_area = '' ) {
    return "<div class='$class'>".ns_get_dynamic_sidebar( $widget_area )."</div>";
}

function contact_us_get_contents ( $id = '', $class = '', $widget_area = '' ) {
    return ns_get_dynamic_sidebar( $widget_area );
}

function contact_us_top_get_contents ( $id = '', $class = '', $widget_area = '' ) {
    return ns_get_dynamic_sidebar( $widget_area );
}

function bottom_row2_get_contents( $id = '', $class = '', $widget_area = '' ) {
    return "<div class='$class'>".ns_get_dynamic_sidebar( $widget_area )."</div>";
}

function portfolio_sidebar2_get_contents( $id = '', $class = '', $widget_area = '' ) {
    return '<aside><nav>'.ns_get_dynamic_sidebar( $widget_area ).'</nav></aside>';
}

function portfolio_content_row1_get_contents( $id = '', $class = '', $widget_area = '' ) {
    return '<div id="profile2">'.ns_get_dynamic_sidebar( $widget_area ).'</div><div class="clear"></div>';
}

// Currently there is no available function to return the contents of a dynamic sidebar. Therefore use this one:
function ns_get_dynamic_sidebar($index = '') {
	$sidebar_contents = "";
	ob_start();
        if ( function_exists('dynamic_sidebar') && dynamic_sidebar( $index ) )
	$sidebar_contents = ob_get_clean();
	return $sidebar_contents;
}

function sidebar_exist_and_active( $sidebar_name ) {
    global $wp_registered_sidebars;
    foreach ( (array) $wp_registered_sidebars as $index => $sidebar ) {
		if ( in_array($sidebar_name, $sidebar) ) {
	    	return is_active_sidebar( $sidebar['id'] ); 
		}
    }
    return false;
}

/*--------------------------------------- END GET SIDEBAR CONTENTS  ------------------*/

/*------------------------------------------- START BREADCRUMBS  ---------------------*/
class simple_breadcrumb {
    var $options;
    
    function simple_breadcrumb() {
            $this->options = array(//change this array if you want another output scheme
            /*'before' => '<span class="breadarrow"> ',
            'after' => ' </span>',
            'delimiter' => '&rarr;'*/
			/*'before' => '<ul><li> ',
            'after' => ' </li></ul>',
            'delimiter' => '&rsaquo;'*/
			'before' => ' ',
            'after' => ' ',
            'delimiter' => '<b>></b>'
			
        );
        $markup = $this->options['before'] . $this->options['delimiter'] . $this->options['after'];
        global $post;
        //echo '<p class="breadcrumbs"><a href="' . get_bloginfo('url') . '">';
		echo '<a href="' . home_url() . '">';
        //bloginfo('name');
        esc_html_e('Home', 'ns_theme');
        echo "</a>";
        if (!is_front_page()) {
            echo $markup;
        }
        
        
        $output = $this->simple_breadcrumb_case($post);
        //echo "<span class='current_crumb'>";
        if (is_page() || is_single()) {
            echo '<span class="current" > ';
			the_title();
			echo "</span>";
        } else {
            echo $output;
        }
        //echo " </span></p>";
    }

    function simple_breadcrumb_case($der_post) {
        global $post;
        $markup = $this->options['before'].$this->options['delimiter'].$this->options['after'];
        if (is_page()){
		
            if($der_post->post_parent) {
                $my_query = get_post($der_post->post_parent);			 
                $this->simple_breadcrumb_case($my_query);
                $link = '<a href="';
                $link .= get_permalink($my_query->ID);
                $link .= '">';
                $link .= ''. get_the_title($my_query->ID) . '</a>'. $markup;
                echo $link;
            }
            return;			 	
        }
        if(is_single()){
		
            $category = get_the_category();
            if (is_attachment()){
                $my_query = get_post($der_post->post_parent);			 
                $category = get_the_category($my_query->ID);
                if( $category != null ) {
                $ID = $category[0]->cat_ID;
                echo get_category_parents($ID, TRUE, $markup, FALSE );
                }
                previous_post_link("%link $markup");

            } elseif ( get_post_type( $post ) == 'post' ) {
                $ID = $category[0]->cat_ID;
                //get_category_parents_for_breadcrumbs( $ID, TRUE, $markup, FALSE );

            } else { // custom types
            echo ucwords( get_post_type( $post ) ) . $markup;
            }
            return;
        }
        if(is_category()){
            $category = get_the_category(); 
            $i = $category[0]->cat_ID;
            $parent = $category[0]-> category_parent;

            if($parent > 0 && $category[0]->cat_name == single_cat_title("", false)){
                echo get_category_parents($parent, TRUE, $markup, FALSE);
            }
            return single_cat_title('',FALSE);
        }
        if (is_tax()) { // taxonomy
            $term = get_term_by( 'slug', get_query_var( 'term' ), get_query_var( 'taxonomy' ) );
            echo $term->name;
        }
        if(is_author()){
            $curauth = (get_query_var('author_name')) ? get_user_by('slug', get_query_var('author_name')) : get_userdata(get_query_var('author'));
            return esc_html__('Author: ', 'ns_theme').$curauth->nickname;
        }
        if(is_tag()){ return esc_html__('Tag: ', 'ns_theme').single_tag_title('',FALSE); }
        if(is_404()){ return esc_html__('404 - Page not Found', 'ns_theme'); }
        if(is_search()){ return esc_html__('Search', 'ns_theme'); }
        if(is_year()){ return get_the_time('Y'); }
        if(is_month()){
            $k_year = get_the_time('Y');
            echo "<a href='".get_year_link($k_year)."'>".$k_year."</a>".$markup;
            return get_the_time('F');
        }
        if(is_day() || is_time()){
            $k_year = get_the_time('Y');
            $k_month = get_the_time('m');
            $k_month_display = get_the_time('F');
            echo "<a href='".get_year_link($k_year)."'>".$k_year."</a>".$markup;
            echo "<a href='".get_month_link($k_year, $k_month)."'>".$k_month_display."</a>".$markup;
            return get_the_time('jS (l)'); 
        }
    }
}
/*----------------------------------------- END BREADCRUMBS  -----------------------*/

if ( ! function_exists( 'ns_comment' ) ) :

function ns_comment( $comment, $args, $depth ) {
	global $wpdb;
	$GLOBALS['comment'] = $comment;
	switch ( $comment->comment_type ) :
		case '' :
		//echo $comment->comment_type.'++++'; 
	?>
    
    <?php if($comment->comment_parent == 0): ?>
	<div class="comment">
	<div class="avatar"><?php echo get_avatar( $comment, 50 ); ?></div>
					    <div class="comment-data">
							<h3 class="blue"><?php echo get_comment_author($comment->comment_ID ); ?></h3>
							<div class="blog-info"><span>Date:</span> <span><?php echo get_comment_date();?></span>
							<span class="spacer">|</span> <?php comment_reply_link( array_merge( $args, array( 'depth' => $depth, 'max_depth' => $args['max_depth'] ) ) ); ?>
							</div>
							<?php comment_text(); ?>
						</div>
						<div class="clear"></div>
	</div>
	<div class="clear"></div>
	<div class="blog-hr hr"></div>
   
            <?php
            	
				$sql = "SELECT comment_ID FROM ". $wpdb->prefix ."comments WHERE comment_parent = '".$comment->comment_ID."' and comment_approved = 1 " ;
				$results = $wpdb->get_results($sql);
				//print_r($results);
				foreach ($results as $comment_object)
				{
					display_child_comment ($comment_object->comment_ID);
				}
					
			?>
       		
           <!-- <div class="post-comment comment-reply">
              <img src="http://placehold.it/80x80/" class="comment-avatar" alt="" />
              <p class="comment-author">Althea Massingale</p>
              <p class="comment-date">ON FEBRUARY 26, 2012 12:34 PM</p>
              <p class="comment-text">Pellentesque mollis dapibus metus, vel consequat lacus vulputate sit amet. Nam mollis enim ante, vel pretium nisi. Sed congue sollicitudin sem, eu tristique ante</p>            
            </div>-->

	 <?php endif; ?>

	<?php
			break;
		case 'pingback'  :
		case 'trackback' :
	?>
	<li class="post pingback">
		<p><?php _e( 'Pingback:', 'ns_theme' ); ?> <?php comment_author_link(); ?><?php edit_comment_link( __( '(Edit)', 'ns_theme' ), ' ' ); ?></p>
	<?php
			break;
	endswitch;
}
endif;


function display_child_comment ($ID)
{
	global $wpdb;
	$comment_Object = get_comment( $ID ); 
	$GLOBALS['comment'] = $comment_Object;
?>
	<div class="comment level-2">
		<div class="avatar"><?php echo get_avatar( $comment_Object, 50 ); ?></div>
		 <div class="comment-data">
			<h3 class="blue"><?php echo get_comment_author($comment_Object->comment_ID ); ?></h3>
			<div class="blog-info"><span>Date:</span> <span><?php echo get_comment_date();?></span>
			<span class="spacer">|</span> <?php comment_reply_link( array_merge( isset($args)?$args:array(), array( 'depth' => isset($depth)?$depth:0, 'max_depth' => isset($args['max_depth'])?$args['max_depth']:2 ) ) ); ?>
			</div>
			<?php comment_text(); ?>
		</div>
		<div class="clear"></div>
	</div>
	<div class="clear"></div>
	<div class="blog-hr hr"></div>

<?php 
	$sql = "SELECT comment_ID FROM ". $wpdb->prefix ."comments WHERE comment_parent = '".$comment_Object->comment_ID."' and comment_approved = 1 " ;
	$results = $wpdb->get_results($sql);
	//print_r($results);
	foreach ($results as $comment_object)
	{
		display_child_comment ($comment_object->comment_ID);
	}
}

/*----------------------------------------- START COMMENT FORM -----------------------*/
function translate_comment( $comment_ID )
{
	$comment = '<p class="comment-text">'.$comment->comment_content.'</p>';
	return $comment;
}


function translate_comment_form_defaults( $defaults )
{
	$defaults['comment_notes_before'] = '';
	$defaults['title_reply'] = '<h2 class="section-title">'.__('Leave a Comment', 'ns_theme').'</h2>';
	$defaults['label_submit'] = ''.__('SEND','ns_theme').'';
	$defaults['comment_notes_after'] = '';
	$defaults['title_reply_to'] = '<h2 class="section-title">'.__('Leave a Comment', 'ns_theme').'</h2>';
	$defaults['logged_in_as'] = '';
	$defaults['comment_field'] = '<div class="clear"></div><div class="text-field"><b>'.__('Your Message','ns_theme').'</b>  (required) <textarea name="comment" class="valid"></textarea></div>';
	//$defaults['id_form'] = 'commentform" class="leave-comment custom-form';
	return $defaults;
}
add_filter( 'comment_form_defaults', 'translate_comment_form_defaults' );



function translate_comment_form_default_fields( $fields )
{
	$fields['author'] = '<div  class="name-field"><b>'. __( 'Name', 'ns_theme' ) .'</b>  (required) <input id="author" name="author" type="text" value="" ></div>';
	$fields['email'] = '<div class="email-field" ><b>'. __( 'Email','ns_theme' ) .'</b> (required) <input id="email" name="email" type="text" value="" ></div>';
	$fields['url'] = '<div class="website-field"><b>'. __( 'Website','ns_theme' ) .'</b><input id="url" name="url" type="text" value=""></div>';
	
	return $fields;
}
add_filter( 'comment_form_default_fields', 'translate_comment_form_default_fields' );


/*function translate_comment_form_textarea( $fields )
{
	
	$fields['comment_field'] = '<div><label>'. _x('Your Comment', 'noun') .'</label><textarea id="comment" name="comment" aria-required="true"></textarea></div>';
}
add_filter( 'comment_form_default_fields', 'translate_comment_form_textarea' );*/

/*----------------------------------------- END COMMENT FORM -----------------------*/
$exclude_page = '';
if (isset($ns_options_frnt['exclude_pages_from_manu']) && count($ns_options_frnt['exclude_pages_from_manu']) > 0 ){
foreach($ns_options_frnt['exclude_pages_from_manu'] as $val)
{
	$exclude_page .= $val.',';
}

$exclude_page = substr_replace($exclude_page, '', -1);
}

function ns_theme_nav()
{
	global $exclude_page ;
	if( has_nav_menu('primary'))
	{
		$defaults = array(
							'theme_location'  => 'primary',
							'menu'            => '', 
							'container'       => false, 
							'container_class' => 'drop-down-nav', 
							'container_id'    => 'drop-down-nav',
							'menu_class'      => '', 
							'menu_id'         => '',
							'echo'            => true,
							'fallback_cb'     => 'wp_page_menu',
							'before'          => '',
							'after'           => '',
							'link_before'     => '',
							'link_after'      => '',
							'items_wrap'      => '<ul id=\"%1$s\" class=\"%2$s\">%3$s</ul>',
							'depth'           => 0,
							'walker'          => ''
						);
		wp_nav_menu( $defaults );
	}
	else
	{
		
		$args = array(
		'child_of' => 0,
		'sort_order' => 'ASC',
		'sort_column' => 'menu_order',
		'hierarchical' => 1,
		'exclude' =>$exclude_page,
		'include' =>'' ,
		'meta_key' =>'' ,
		'meta_value' => '',
		'authors' =>'' ,
		'parent' => 0,
		'exclude_tree' => '',
		'number' => '',
		'offset' => 0,
		'post_type' => 'page',
		'post_status' => 'publish'
		); 
			
		$mypages = get_pages( $args );
		$curr_ID =  get_the_ID();
		echo "<ul>"; 
		foreach( $mypages as $page ) 
		{		
			$class = '' ;
			
			if ($curr_ID == $page->ID) 
			{
				$class = 'active';
			}
			
			if ( wp_list_pages("title_li=&child_of=".$page->ID."&echo=0"))
			{
				$class .= ' li_parent';
			}
			
			$sub = create_sub_pages_nav($page->ID);
			echo '<li '.(!$sub?'':'class="has-sub"').'> <a class="sub-parent '.$class.'" href="'.get_page_link( $page->ID ).'">'.$page->post_title.' <span></span></a>'.
			$sub."</li>"; 
		}
		echo "</ul>"; 	
	}
}

function create_sub_pages_nav ($pageID)
{
		global $exclude_page;
		$args = array(
		'child_of' => $pageID ,
		'sort_order' => 'ASC',
		'sort_column' => 'menu_order',
		'hierarchical' => 0,
		'exclude' =>$exclude_page,
		'include' =>'' ,
		'meta_key' =>'' ,
		'meta_value' => '',
		'authors' =>'' ,
		'parent' => $pageID,
		'exclude_tree' => '',
		'number' => '',
		'offset' => 0,
		'post_type' => 'page',
		'post_status' => 'publish'
		); 
			
		$mypages = get_pages( $args );
		//print_r($mypages);
		$i = 0 ;
		$output ='' ;
		foreach( $mypages as $page ) 
		{		
			if ($i==0)
			{
				$output =  "<ul>"; 
				$i = 1 ;	
			}
			$output .= '<li> <a href="'.get_page_link( $page->ID ).'">'.$page->post_title.' </a>'.
			create_sub_pages_nav($page->ID)."</li>"; 
		}
		if ($i==1)
		{
			$output .= "</ul>"; 
		}
		return 	$output ; 
}



/*----------------------------------------- START ADD MATA BOX -----------------------*/

add_action( 'load-post.php', 'smashing_post_meta_boxes_setup' );
add_action( 'load-post-new.php', 'smashing_post_meta_boxes_setup' );

function smashing_post_meta_boxes_setup()
{
	add_action( 'add_meta_boxes', 'smashing_add_post_meta_boxes' );
	add_action( 'save_post', 'smashing_save_post_class_meta', 10, 2 );
}



function smashing_add_post_meta_boxes()
{
	add_meta_box(
				'smashing-post-class',          // Unique ID
				esc_html__( 'Subtitle', 'example' ),      // Title
				'smashing_post_class_meta_box',     // Callback function
				'page'                 // Admin page (or post type)
				//'side',                 // Context
				//'default'                   // Priority
	);
	add_meta_box(
				'smashing-post-class',          // Unique ID
				esc_html__( 'Subtitle', 'example' ),      // Title
				'smashing_post_class_meta_box',     // Callback function
				'post'                 // Admin page (or post type)
				//'side',                 // Context
				//'default'                   // Priority
	);
}


function smashing_post_class_meta_box( $object, $box )
{
	wp_nonce_field( basename( __FILE__ ), 'smashing_post_class_nonce' );
?>
        <p>
        <label for="smashing-post-class"><?php _e( "Add the subtitle to this entry.", 'example' ); ?></label>
        <br />
        <input class="widefat" type="text" name="smashing-post-class" id="smashing-post-class" value="<?php echo esc_attr( get_post_meta( $object->ID, 'smashing_post_class', true ) ); ?>" size="30" />
        </p>
<?php
}


function smashing_save_post_class_meta( $post_id, $post ) {
	if ( !isset( $_POST['smashing_post_class_nonce'] ) || !wp_verify_nonce( $_POST['smashing_post_class_nonce'], basename( __FILE__ ) ) )
		return $post_id;

	$post_type = get_post_type_object( $post->post_type );


	if ( !current_user_can( $post_type->cap->edit_post, $post_id ) )
			return $post_id;

	$new_meta_value = ( isset( $_POST['smashing-post-class'] ) ? $_POST['smashing-post-class']/*sanitize_html_class( $_POST['smashing-post-class'] )*/ : '' );
	$meta_key = 'smashing_post_class';

	$meta_value = get_post_meta( $post_id, $meta_key, true );

	if ( $new_meta_value && '' == $meta_value )
		add_post_meta( $post_id, $meta_key, $new_meta_value, true );
	elseif ( $new_meta_value && $new_meta_value != $meta_value )
		update_post_meta( $post_id, $meta_key, $new_meta_value );
	elseif ( '' == $new_meta_value && $meta_value )
		delete_post_meta( $post_id, $meta_key, $meta_value );
}



//add_filter( 'post_class', 'smashing_post_class' );

function smashing_post_class( $classes ) {
		
		$post_id = get_the_ID();

		if ( !empty( $post_id ) )
		{
			$post_class = get_post_meta( $post_id, 'smashing_post_class', true );

			if ( !empty( $post_class ) )
				$classes[] = sanitize_html_class( $post_class );
		}

		return $classes;
}
/*------------------------------------------ END ADD MATA BOX ------------------------*/

include('get-the-image.php');

//--------------------- Get decendent category to check post ID-------------------

if ( ! function_exists( 'post_is_in_descendant_category' ) ) {
	function post_is_in_descendant_category( $cats, $_post = null ) {
		foreach ( (array) $cats as $cat ) {
			// get_term_children() accepts integer ID only
			$descendants = get_term_children( (int) $cat, 'category' );
			if ( $descendants && in_category( $descendants, $_post ) )
				return true;
		}
		return false;
	}
}

///----------------------- FIX the length of Excerpt-----------------------
function custom_excerpt_length( $length ) {
	global $ns_options_frnt;
	if ((int)$ns_options_frnt['ns_cs_excerptLength'] != 0 )
	{
		return (int)$ns_options_frnt['ns_cs_excerptLength'];
	}else
	{
		return $length;
	}	
}
add_filter( 'excerpt_length', 'custom_excerpt_length', 999 );
///------------------------ Blog Featured Image -------------------

function display_post_video_fn($post_id){
	global $ns_options_frnt;
    $post_image_url = get_post_meta($post_id, 'post_image', true); // Grab the preview image from the custom field 'post_image', if set.
    if ( !$post_image_url && has_post_thumbnail( $post_id ) ) {
        $tmp_image = wp_get_attachment_image_src( get_post_thumbnail_id( $post_id ), 'single-post-thumbnail' );
        $post_image_url = $tmp_image[0];
    }
	echo  $post_image_url;
}

function display_post_image_fn( $post_id, $linked = true) {
    
	///ns_baSectionFeaturedImage, ns_baSectoinImage_width, ns_baSectoinImage_height, ns_blog_forceDimensions=force, ns_baSectionFeaturedImageAlignment=left,right,center
	global $ns_options_frnt;
    $post_image_url = get_post_meta($post_id, 'post_image', true); // Grab the preview image from the custom field 'post_image', if set.
    if ( !$post_image_url && has_post_thumbnail( $post_id ) ) {
        $tmp_image = wp_get_attachment_image_src( get_post_thumbnail_id( $post_id ), 'single-post-thumbnail' );
        $post_image_url = $tmp_image[0];
    }
   
   if ( $post_image_url ) : 
        if ( $ns_options_frnt['ns_baSectionFeaturedImage'] == 'enable' ) : 
            // Customize the dimension and alignment of the 'Featured Image' ...
            if( $ns_options_frnt['ns_blog_forceDimensions'] == 'force' ) : 
                //... by a function defined in 'function.php' specifically for this theme using TimThumb
                echo customized_featured_image( $post_id, $post_image_url, $ns_options_frnt['ns_baSectoinImage_width'], $ns_options_frnt['ns_baSectoinImage_height'], $ns_options_frnt['ns_baSectionFeaturedImageAlignment'], $linked );
            else : 
                //... by the default WP 'the_post_thumbnail()' function which doesn't stretch images if they are smaller
                if ($ns_options_frnt['ns_baSectionFeaturedImageAlignment']=='left') $image_alignment="alignleft";
				else if ($ns_options_frnt['ns_baSectionFeaturedImageAlignment']=='right') $image_alignment="alignright";
				
				echo the_post_thumbnail( array($ns_options_frnt['ns_baSectoinImage_width'], $ns_options_frnt['ns_baSectoinImage_height']), array('class' => $image_alignment." post-image with-shadow", 'style'=>'width:'.$ns_options_frnt['ns_baSectoinImage_width'].'px; height:'.$ns_options_frnt['ns_baSectoinImage_height'].'px;') );
            endif;
        else : ?>
    
<?php         if ( $linked ) : ?>
                        <a class="fancybox" href="<?php echo $post_image_url; ?>"  title="<?php the_title_attribute(); ?>"><img  src="<?php echo get_template_directory_uri(); ?>/scripts/timthumb.php?src=<?php echo $post_image_url; ?>&amp;w=575&amp;h=188&amp;zc=1&amp;q=90" alt="<?php the_title_attribute(); ?>" class="post-image with-shadow" /></a>
<?php               else : ?>
                        <img  src="<?php echo get_template_directory_uri(); ?>/scripts/timthumb.php?src=<?php echo $post_image_url; ?>&amp;w=680&amp;h=230&amp;zc=1&amp;q=90" alt="<?php the_title_attribute(); ?>" class="post-image with-shadow" />
<?php               endif; ?>
               
<?php   endif;
    endif;
}


function get_post_image_fn( $post_id, $w=72, $h=40) {
    
	///ns_baSectionFeaturedImage, ns_baSectoinImage_width, ns_baSectoinImage_height, ns_blog_forceDimensions=force, ns_baSectionFeaturedImageAlignment=left,right,center
	global $ns_options_frnt;
    $post_image_url = get_post_meta($post_id, 'post_image', true); // Grab the preview image from the custom field 'post_image', if set.
    if ( !$post_image_url && has_post_thumbnail( $post_id ) ) {
        $tmp_image = wp_get_attachment_image_src( get_post_thumbnail_id( $post_id ), 'single-post-thumbnail' );
        $post_image_url = $tmp_image[0];
    }
   
	return  $post_image_url?'<img  src="'.get_template_directory_uri().'/scripts/timthumb.php?src='.$post_image_url.'&amp;w='.$w.'&amp;h='.$h.'&amp;zc=1&amp;q=90"   />':'';
					  
}


function customized_featured_image( $post_id, $img_src, $width, $height, $image_alignment = 'left', $linked = true ) {
    if ($image_alignment=='left') $image_alignment="alignleft";
	else if ($image_alignment=='right') $image_alignment="alignright";
	$the_image_html = '<img src="'.get_template_directory_uri().'/scripts/timthumb.php?src='.$img_src.'&amp;w='.$width.'&amp;h='.$height.'&amp;zc=1&amp;q=90" alt="' . esc_attr( get_post_field( 'post_title', $post_id ) ) . ' " class="post-image with-shadow" style="width:'.$width.'px; height:'.$height.'px;" />';
    if ( $linked ) $the_image_html = '<a href="'.get_permalink( $post_id ).'"  title="' . esc_attr( get_post_field( 'post_title', $post_id ) ) . '">'.$the_image_html.'</a>';
    $html = '<span class="custom-frame '.$image_alignment.'">'.$the_image_html.'</span>';
    if( $image_alignment == 'center' ) $html = '<div style="text-align:center;">'.$html.'</div>';
    return $html;
}

///-------------------------------------------------------------------------------------------

function string_limit_words($string, $word_limit)
{
  $words = explode(' ', $string, ($word_limit + 1));
  if(count($words) > $word_limit) {
  array_pop($words);
  //add a ... at last article when more than limit word count
  echo implode(' ', $words)."..."; } else {
  //otherwise
  echo implode(' ', $words); }
}

function return_string_limit_words($string, $word_limit)
{
  $words = explode(' ', $string, ($word_limit + 1));
  if(count($words) > $word_limit) {
  array_pop($words);
  //add a ... at last article when more than limit word count
  return implode(' ', $words)."..."; } else {
  //otherwise
  return implode(' ', $words); }
}



function ns_comment_form( $args = array(), $post_id = null ) {
	global $id;

	if ( null === $post_id )
		$post_id = $id;
	else
		$id = $post_id;

	$commenter = wp_get_current_commenter();
	$user = wp_get_current_user();
	$user_identity = $user->exists() ? $user->display_name : '';

	$req = get_option( 'require_name_email' );
	$aria_req = ( $req ? " aria-required='true'" : '' );
	$fields =  array(
		'author' => '<p class="comment-form-author">' . '<label for="author">' . __( 'Name', "cavus_theme" ) . '</label> ' . ( $req ? '<span class="required">*</span>' : '' ) .
		            '<input id="author" name="author" type="text" value="' . esc_attr( $commenter['comment_author'] ) . '" size="30"' . $aria_req . ' /></p>',
		'email'  => '<p class="comment-form-email"><label for="email">' . __( 'Email', "cavus_theme" ) . '</label> ' . ( $req ? '<span class="required">*</span>' : '' ) .
		            '<input id="email" name="email" type="text" value="' . esc_attr(  $commenter['comment_author_email'] ) . '" size="30"' . $aria_req . ' /></p>',
		'url'    => '<p class="comment-form-url"><label for="url">' . __( 'Website', "cavus_theme" ) . '</label>' .
		            '<input id="url" name="url" type="text" value="' . esc_attr( $commenter['comment_author_url'] ) . '" size="30" /></p>',
	);


	$required_text = sprintf( ' ' . __( 'Required fields are marked %s', "cavus_theme" ), '<span class="required">*</span>' );
	$defaults = array(
		'fields'               => apply_filters( 'comment_form_default_fields', $fields ),
		'comment_field'        => '<div class="text-field"><b>' . _x( 'Comment', 'noun', "cavus_theme" ) . '</b> (required) <textarea id="comment" name="comment" aria-required="true"></textarea></div>',
		'must_log_in'          => '<p class="must-log-in">' . sprintf( __( 'You must be <a href="%s">logged in</a> to post a comment.', "cavus_theme" ), wp_login_url( apply_filters( 'the_permalink', get_permalink( $post_id ) ) ) ) . '</p>',
		'logged_in_as'         => '<p class="logged-in-as">' . sprintf( __( 'Logged in as <a href="%1$s">%2$s</a>. <a href="%3$s" title="Log out of this account">Log out?</a>', "cavus_theme" ), admin_url( 'profile.php' ), $user_identity, wp_logout_url( apply_filters( 'the_permalink', get_permalink( $post_id ) ) ) ) . '</p>',
		'comment_notes_before' => '<p class="comment-notes">' . __( 'Your email address will not be published.', "cavus_theme" ) . ( $req ? $required_text : '' ) . '</p>',
		'comment_notes_after'  => '<p class="form-allowed-tags">' . sprintf( __( 'You may use these <abbr title="HyperText Markup Language">HTML</abbr> tags and attributes: %s', "cavus_theme" ), ' <code>' . allowed_tags() . '</code>' ) . '</p>',
		'id_form'              => 'commentform',
		'id_submit'            => 'submit',
		'title_reply'          => __( 'Leave a Reply', "cavus_theme" ),
		'title_reply_to'       => __( 'Leave a Reply to %s', "cavus_theme" ),
		'cancel_reply_link'    => __( 'Cancel reply', "cavus_theme" ),
		'label_submit'         => __( 'Post Comment', "cavus_theme" ),
	);

	$args = wp_parse_args( $args, apply_filters( 'comment_form_defaults', $defaults ) );

	?>
		<?php if ( comments_open( $post_id ) ) : ?>
			<?php do_action( 'comment_form_before' ); ?>
				<?php comment_form_title( $args['title_reply'], $args['title_reply_to'] ); ?> 	
					<?php cancel_comment_reply_link( $args['cancel_reply_link'] ); ?>				
				<?php if ( get_option( 'comment_registration' ) && !is_user_logged_in() ) : ?>
					<?php echo $args['must_log_in']; ?>
					<?php do_action( 'comment_form_must_log_in_after' ); ?>
				<?php else : ?>
					<div class="post-form">
					<form action="<?php echo site_url( '/wp-comments-post.php' ); ?>" method="post" id="<?php echo esc_attr( $args['id_form'] ); ?>">
						<?php do_action( 'comment_form_top' ); ?>
						<?php /* if ( is_user_logged_in() ) : ?>
							<?php echo apply_filters( 'comment_form_logged_in', $args['logged_in_as'], $commenter, $user_identity ); ?>
							<?php do_action( 'comment_form_logged_in_after', $commenter, $user_identity ); ?>
						<?php else : ?>
							<?php echo $args['comment_notes_before']; ?>
							<?php
							do_action( 'comment_form_before_fields' );
							foreach ( (array) $args['fields'] as $name => $field ) {
								echo apply_filters( "comment_form_field_{$name}", $field ) . "\n";
							}
							do_action( 'comment_form_after_fields' );
							?>
							
						<?php endif; */?>
						<?php
						foreach ( (array) $args['fields'] as $name => $field ) {
								echo apply_filters( "comment_form_field_{$name}", $field ) . "\n";
							}
						?>
						<?php echo apply_filters( 'comment_form_field_comment', $args['comment_field'] ); ?>
						<?php echo $args['comment_notes_after']; ?>
						<div class="buttons">
							<input name="submit" type="submit" id="<?php echo esc_attr( $args['id_submit'] ); ?>" value="<?php echo esc_attr( $args['label_submit'] ); ?>" />
							<input type="reset" value="CLEAR">
							<?php comment_id_fields( $post_id ); ?>
						
						</div>
						
						<?php do_action( 'comment_form', $post_id ); ?>
					</form>
					</div>
				<?php endif; ?>
			<!-- #respond -->
			<?php do_action( 'comment_form_after' ); ?>
		<?php else : ?>
			<?php do_action( 'comment_form_comments_closed' ); ?>
		<?php endif; ?>
	<?php
}


add_shortcode('gallery', 'ns_gallery_shortcode');

function ns_gallery_shortcode($attr) {
	global $post;

	static $instance = 0;
	$instance++;

	// Allow plugins/themes to override the default gallery template.
	$output = apply_filters('post_gallery', '', $attr);
	if ( $output != '' )
		return $output;

	// We're trusting author input, so let's at least make sure it looks like a valid orderby statement
	if ( isset( $attr['orderby'] ) ) {
		$attr['orderby'] = sanitize_sql_orderby( $attr['orderby'] );
		if ( !$attr['orderby'] )
			unset( $attr['orderby'] );
	}

	extract(shortcode_atts(array(
		'order'      => 'ASC',
		'orderby'    => 'menu_order ID',
		'id'         => $post->ID,
		'itemtag'    => 'dl',
		'icontag'    => 'dt',
		'captiontag' => 'dd',
		'columns'    => 3,
		'size'       => 'thumbnail',
		'include'    => '',
		'exclude'    => ''
	), $attr));

	$id = intval($id);
	if ( 'RAND' == $order )
		$orderby = 'none';

	if ( !empty($include) ) {
		$include = preg_replace( '/[^0-9,]+/', '', $include );
		$_attachments = get_posts( array('include' => $include, 'post_status' => 'inherit', 'post_type' => 'attachment', 'post_mime_type' => 'image', 'order' => $order, 'orderby' => $orderby) );

		$attachments = array();
		foreach ( $_attachments as $key => $val ) {
			$attachments[$val->ID] = $_attachments[$key];
		}
	} elseif ( !empty($exclude) ) {
		$exclude = preg_replace( '/[^0-9,]+/', '', $exclude );
		$attachments = get_children( array('post_parent' => $id, 'exclude' => $exclude, 'post_status' => 'inherit', 'post_type' => 'attachment', 'post_mime_type' => 'image', 'order' => $order, 'orderby' => $orderby) );
	} else {
		$attachments = get_children( array('post_parent' => $id, 'post_status' => 'inherit', 'post_type' => 'attachment', 'post_mime_type' => 'image', 'order' => $order, 'orderby' => $orderby) );
	}

	if ( empty($attachments) )
		return '';

	
	$i = 0;
	
	if($attr['size'] != "large")$output .= "<div id='third'>";
	
	foreach ( $attachments as $id => $attachment ) {

		$output .= "";
		$output .= "
			<div class='slider-cell-small' data-src='".$attachment->guid."'> 
			<div class='slider-nav-secondary fadeIn'>
						<div class='camera_prev'><span></span></div>
						<div class='camera_next'><span></span></div>
			</div>";
		if($attr['size'] == "large") {
				$cnt_views = the_views(false);
				$output .= "<div class=\"gall-info\">
						<span class=\"viewers\">".$cnt_views."</span>
						<a class=\"zoom\" href=\"".$attachment->guid."\" title=\"\" rel=\"prettyPhoto\">zoom</a>
					</div>	";	
		}
		$output .= "</div>";
	}

	if($attr['size'] != "large")$output .= "</div>";

	return $output;
}

add_filter('the_content', 'shortcode_empty_paragraph_fix');
    function shortcode_empty_paragraph_fix($content)
    {   
        $array = array (
            '<p>[' => '[', 
            ']</p>' => ']', 
            ']<br />' => ']'
        );

        $content = strtr($content, $array);

		return $content;
    }

add_filter('wp_nav_menu_objects','menu_parent_items');

    function menu_parent($menu_item_id, &$items) {

        foreach ($items as $item) {
            if ($item->menu_item_parent && $item->menu_item_parent==$menu_item_id) {
                return true;
            }
        }
        return false;

    };

 function menu_parent_items ($items) {

    foreach ($items as &$item) {
        if (menu_parent($item->ID, &$items)) {
            $item->classes[] = 'menu-parent-item'; // all elements of field "classes" of a menu item get join together and render to class attribute of <li> element in HTML
        }
    }
    return $items;    
}






### Create Text Domain For Translations
if (function_exists('postviews_textdomain')) {
	add_action('init', 'postviews_textdomain');
}

else{
add_action('init', 'postviews_textdomain');

function postviews_textdomain() {
	load_plugin_textdomain('wp-postviews', false, 'wp-postviews');
}

}

### Function: Post Views Option Menu

if (function_exists('postviews_menu')) {
	add_action('init', 'postviews_menu');
}

else{
add_action('admin_menu', 'postviews_menu');
function postviews_menu() {
	if (function_exists('add_options_page')) {
		add_options_page(__('PostViews', 'wp-postviews'), __('PostViews', 'wp-postviews'), 'manage_options', 'wp-postviews/postviews-options.php') ;
	}
}
}
### Function: Calculate Post Views
add_action('wp_head', 'process_postviews');
function process_postviews() {
	global $user_ID, $post;
	if(is_int($post)) {
		$post = get_post($post);
	}
	if(!wp_is_post_revision($post)) {
		if(is_single() || is_page()) {
			$id = intval($post->ID);
			$views_options = get_option('views_options');
			$post_views = get_post_custom($id);
			$post_views = intval($post_views['views'][0]);
			$should_count = false;
			switch(intval($views_options['count'])) {
				case 0:
					$should_count = true;
					break;
				case 1:
					if(empty($_COOKIE[USER_COOKIE]) && intval($user_ID) == 0) {
						$should_count = true;
					}
					break;
				case 2:
					if(intval($user_ID) > 0) {
						$should_count = true;
					}
					break;
			}
			if(intval($views_options['exclude_bots']) == 1) {
				$bots = array('Google Bot' => 'googlebot', 'Google Bot' => 'google', 'MSN' => 'msnbot', 'Alex' => 'ia_archiver', 'Lycos' => 'lycos', 'Ask Jeeves' => 'jeeves', 'Altavista' => 'scooter', 'AllTheWeb' => 'fast-webcrawler', 'Inktomi' => 'slurp@inktomi', 'Turnitin.com' => 'turnitinbot', 'Technorati' => 'technorati', 'Yahoo' => 'yahoo', 'Findexa' => 'findexa', 'NextLinks' => 'findlinks', 'Gais' => 'gaisbo', 'WiseNut' => 'zyborg', 'WhoisSource' => 'surveybot', 'Bloglines' => 'bloglines', 'BlogSearch' => 'blogsearch', 'PubSub' => 'pubsub', 'Syndic8' => 'syndic8', 'RadioUserland' => 'userland', 'Gigabot' => 'gigabot', 'Become.com' => 'become.com');
				$useragent = $_SERVER['HTTP_USER_AGENT'];
				foreach ($bots as $name => $lookfor) { 
					if (stristr($useragent, $lookfor) !== false) { 
						$should_count = false;
						break;
					} 
				}
			}
			if($should_count) {			
				if(defined('WP_CACHE') && WP_CACHE) {
					echo "\n".'<!-- Start Of Script Generated By WP-PostViews -->'."\n";
					wp_print_scripts('jquery');					
					echo '<script type="text/javascript">'."\n";
					echo '/* <![CDATA[ */'."\n";
					echo "jQuery.ajax({type:'GET',url:'".admin_url('admin-ajax.php', (is_ssl() ? 'https' : 'http'))."',data:'postviews_id=".$id."&action=postviews',cache:false});";
					echo '/* ]]> */'."\n";
					echo '</script>'."\n";						
					echo '<!-- End Of Script Generated By WP-PostViews -->'."\n";
				} else {
					if(!update_post_meta($id, 'views', ($post_views+1))) {
						add_post_meta($id, 'views', 1, true);
					}
				}
			}
		}
	}
}


### Function: Determine If Post Views Should Be Displayed (By: David Potter)
function should_views_be_displayed($views_options = null) {
	if ($views_options == null) {
		$views_options = get_option('views_options');
	}
	$display_option = 0;
	if (is_home()) {
		if (@array_key_exists('display_home', $views_options)) {
			$display_option = $views_options['display_home'];
		}
	} elseif (is_single()) {
		if (@array_key_exists('display_single', $views_options)) {
			$display_option = $views_options['display_single'];
		}
	} elseif (is_page()) {
		if (@array_key_exists('display_page', $views_options)) {
			$display_option = $views_options['display_page'];
		}
	} elseif (is_archive()) {
		if (@array_key_exists('display_archive', $views_options)) {
			$display_option = $views_options['display_archive'];
		}
	} elseif (is_search()) {
		if (@array_key_exists('display_search', $views_options)) {
			$display_option = $views_options['display_search'];
		}
	} else {
		if (@array_key_exists('display_other', $views_options)) {
			$display_option = $views_options['display_other'];
		}
	}
	return (($display_option == 0) || (($display_option == 1) && is_user_logged_in()));
}


### Function: Display The Post Views
function the_views($display = true, $prefix = '', $postfix = '', $always = false) {
	$post_views = intval(post_custom('views'));
//        echo $post_views;
	$views_options = get_option('views_options');
	if ($always || should_views_be_displayed($views_options)) {
		$output = $prefix.str_replace('%VIEW_COUNT%', number_format_i18n($post_views), $views_options['template']).$postfix;
		if($display) {
			echo apply_filters('the_views', $output);
		} else {
			return apply_filters('the_views', $output);
		}
	}
	elseif (!$display) {
		return '';
	}
}


### Function: Display Least Viewed Page/Post
if(!function_exists('get_least_viewed')) {
	function get_least_viewed($mode = '', $limit = 10, $chars = 0, $display = true) {
		global $wpdb;
		$views_options = get_option('views_options');
		$where = '';
		$temp = '';
		$output = '';
		if(!empty($mode) && $mode != 'both') {
			$where = "post_type = '$mode'";
		} else {
			$where = '1=1';
		}
		$most_viewed = $wpdb->get_results("SELECT DISTINCT $wpdb->posts.*, (meta_value+0) AS views FROM $wpdb->posts LEFT JOIN $wpdb->postmeta ON $wpdb->postmeta.post_id = $wpdb->posts.ID WHERE post_date < '".current_time('mysql')."' AND $where AND post_status = 'publish' AND meta_key = 'views' AND post_password = '' ORDER BY views ASC LIMIT $limit");
		if($most_viewed) {
			foreach ($most_viewed as $post) {
				$post_views = intval($post->views);
				$post_title = get_the_title($post);
				if($chars > 0) {
					$post_title = snippet_text($post_title, $chars);
				}
				$post_excerpt = views_post_excerpt($post->post_excerpt, $post->post_content, $post->post_password, $chars);
				$temp = stripslashes($views_options['most_viewed_template']);
				$temp = str_replace("%VIEW_COUNT%", number_format_i18n($post_views), $temp);
				$temp = str_replace("%POST_TITLE%", $post_title, $temp);
				$temp = str_replace("%POST_EXCERPT%", $post_excerpt, $temp);
				$temp = str_replace("%POST_CONTENT%", $post->post_content, $temp);
				$temp = str_replace("%POST_URL%", get_permalink($post), $temp);
				$output .= $temp;
			}			
		} else {
			$output = '<li>'.__('N/A', 'wp-postviews').'</li>'."\n";
		}
		if($display) {
			echo $output;
		} else {
			return $output;
		}
	}
}


### Function: Display Most Viewed Page/Post
if(!function_exists('get_most_viewed')) {
	function get_most_viewed($mode = '', $limit = 10, $chars = 0, $display = true) {
		global $wpdb;
		$views_options = get_option('views_options');
		$where = '';
		$temp = '';
		$output = '';
		if(!empty($mode) && $mode != 'both') {
			$where = "post_type = '$mode'";
		} else {
			$where = '1=1';
		}
		$most_viewed = $wpdb->get_results("SELECT DISTINCT $wpdb->posts.*, (meta_value+0) AS views FROM $wpdb->posts LEFT JOIN $wpdb->postmeta ON $wpdb->postmeta.post_id = $wpdb->posts.ID WHERE post_date < '".current_time('mysql')."' AND $where AND post_status = 'publish' AND meta_key = 'views' AND post_password = '' ORDER BY views DESC LIMIT $limit");
		if($most_viewed) {
			foreach ($most_viewed as $post) {
				$post_views = intval($post->views);
				$post_title = get_the_title($post);
				if($chars > 0) {
					$post_title = snippet_text($post_title, $chars);
				}
				$post_excerpt = views_post_excerpt($post->post_excerpt, $post->post_content, $post->post_password, $chars);
				$temp = stripslashes($views_options['most_viewed_template']);
				$temp = str_replace("%VIEW_COUNT%", number_format_i18n($post_views), $temp);
				$temp = str_replace("%POST_TITLE%", $post_title, $temp);
				$temp = str_replace("%POST_EXCERPT%", $post_excerpt, $temp);
				$temp = str_replace("%POST_CONTENT%", $post->post_content, $temp);
				$temp = str_replace("%POST_URL%", get_permalink($post), $temp);
				$output .= $temp;
			}			
		} else {
			$output = '<li>'.__('N/A', 'wp-postviews').'</li>'."\n";
		}
		if($display) {
			echo $output;
		} else {
			return $output;
		}
	}
}


### Function: Display Leased Viewed Page/Post By Category ID
if(!function_exists('get_least_viewed_category')) {
	function get_least_viewed_category($category_id = 0, $mode = '', $limit = 10, $chars = 0, $display = true) {
		global $wpdb;
		$views_options = get_option('views_options');
		$where = '';
		$temp = '';
		$output = '';
		if(is_array($category_id)) {
			$category_sql = "$wpdb->term_taxonomy.term_id IN (".join(',', $category_id).')';
		} else {
			$category_sql = "$wpdb->term_taxonomy.term_id = $category_id";
		}
		if(!empty($mode) && $mode != 'both') {
			$where = "post_type = '$mode'";
		} else {
			$where = '1=1';
		}
		$most_viewed = $wpdb->get_results("SELECT DISTINCT $wpdb->posts.*, (meta_value+0) AS views FROM $wpdb->posts LEFT JOIN $wpdb->postmeta ON $wpdb->postmeta.post_id = $wpdb->posts.ID INNER JOIN $wpdb->term_relationships ON ($wpdb->posts.ID = $wpdb->term_relationships.object_id) INNER JOIN $wpdb->term_taxonomy ON ($wpdb->term_relationships.term_taxonomy_id = $wpdb->term_taxonomy.term_taxonomy_id) WHERE post_date < '".current_time('mysql')."' AND $wpdb->term_taxonomy.taxonomy = 'category' AND $category_sql AND $where AND post_status = 'publish' AND meta_key = 'views' AND post_password = '' ORDER BY views ASC LIMIT $limit");
		if($most_viewed) {
			foreach ($most_viewed as $post) {
				$post_views = intval($post->views);
				$post_title = get_the_title($post);
				if($chars > 0) {
					$post_title = snippet_text($post_title, $chars);
				}
				$post_excerpt = views_post_excerpt($post->post_excerpt, $post->post_content, $post->post_password, $chars);
				$temp = stripslashes($views_options['most_viewed_template']);
				$temp = str_replace("%VIEW_COUNT%", number_format_i18n($post_views), $temp);
				$temp = str_replace("%POST_TITLE%", $post_title, $temp);
				$temp = str_replace("%POST_EXCERPT%", $post_excerpt, $temp);
				$temp = str_replace("%POST_CONTENT%", $post->post_content, $temp);
				$temp = str_replace("%POST_URL%", get_permalink($post), $temp);
				$output .= $temp;
			}
		} else {
			$output = '<li>'.__('N/A', 'wp-postviews').'</li>'."\n";
		}
		if($display) {
			echo $output;
		} else {
			return $output;
		}
	}
}


### Function: Display Most Viewed Page/Post By Category ID
if(!function_exists('get_most_viewed_category')) {
	function get_most_viewed_category($category_id = 0, $mode = '', $limit = 10, $chars = 0, $display = true) {
		global $wpdb;
		$views_options = get_option('views_options');
		$where = '';
		$temp = '';
		$output = '';
		if(is_array($category_id)) {
			$category_sql = "$wpdb->term_taxonomy.term_id IN (".join(',', $category_id).')';
		} else {
			$category_sql = "$wpdb->term_taxonomy.term_id = $category_id";
		}
		if(!empty($mode) && $mode != 'both') {
			$where = "post_type = '$mode'";
		} else {
			$where = '1=1';
		}
		$most_viewed = $wpdb->get_results("SELECT DISTINCT $wpdb->posts.*, (meta_value+0) AS views FROM $wpdb->posts LEFT JOIN $wpdb->postmeta ON $wpdb->postmeta.post_id = $wpdb->posts.ID INNER JOIN $wpdb->term_relationships ON ($wpdb->posts.ID = $wpdb->term_relationships.object_id) INNER JOIN $wpdb->term_taxonomy ON ($wpdb->term_relationships.term_taxonomy_id = $wpdb->term_taxonomy.term_taxonomy_id) WHERE post_date < '".current_time('mysql')."' AND $wpdb->term_taxonomy.taxonomy = 'category' AND $category_sql AND $where AND post_status = 'publish' AND meta_key = 'views' AND post_password = '' ORDER BY views DESC LIMIT $limit");
		if($most_viewed) {
			foreach ($most_viewed as $post) {
				$post_views = intval($post->views);
				$post_title = get_the_title($post);
				if($chars > 0) {
					$post_title = snippet_text($post_title, $chars);
				}
				$post_excerpt = views_post_excerpt($post->post_excerpt, $post->post_content, $post->post_password, $chars);
				$temp = stripslashes($views_options['most_viewed_template']);
				$temp = str_replace("%VIEW_COUNT%", number_format_i18n($post_views), $temp);
				$temp = str_replace("%POST_TITLE%", $post_title, $temp);
				$temp = str_replace("%POST_EXCERPT%", $post_excerpt, $temp);
				$temp = str_replace("%POST_CONTENT%", $post->post_content, $temp);
				$temp = str_replace("%POST_URL%", get_permalink($post), $temp);
				$output .= $temp;
			}
		} else {
			$output = '<li>'.__('N/A', 'wp-postviews').'</li>'."\n";
		}
		if($display) {
			echo $output;
		} else {
			return $output;
		}
	}
}


### Function: Display Most Viewed Page/Post By Tag ID
if(!function_exists('get_most_viewed_tag')) {
	function get_most_viewed_tag($tag_id = 0, $mode = '', $limit = 10, $chars = 0, $display = true) {
		global $wpdb;
		$views_options = get_option('views_options');
		$where = '';
		$temp = '';
		$output = '';
		if(is_array($tag_id)) {
			$tag_sql = "$wpdb->term_taxonomy.term_id IN (".join(',', $tag_id).')';
		} else {
			$tag_sql = "$wpdb->term_taxonomy.term_id = $tag_id";
		}
		if(!empty($mode) && $mode != 'both') {
			$where = "post_type = '$mode'";
		} else {
			$where = '1=1';
		}
		$most_viewed = $wpdb->get_results("SELECT DISTINCT $wpdb->posts.*, (meta_value+0) AS views FROM $wpdb->posts LEFT JOIN $wpdb->postmeta ON $wpdb->postmeta.post_id = $wpdb->posts.ID INNER JOIN $wpdb->term_relationships ON ($wpdb->posts.ID = $wpdb->term_relationships.object_id) INNER JOIN $wpdb->term_taxonomy ON ($wpdb->term_relationships.term_taxonomy_id = $wpdb->term_taxonomy.term_taxonomy_id) WHERE post_date < '".current_time('mysql')."' AND $wpdb->term_taxonomy.taxonomy = 'post_tag' AND $tag_sql AND $where AND post_status = 'publish' AND meta_key = 'views' AND post_password = '' ORDER BY views DESC LIMIT $limit");
		if($most_viewed) {
			foreach ($most_viewed as $post) {
				$post_views = intval($post->views);
				$post_title = get_the_title($post);
				if($chars > 0) {
					$post_title = snippet_text($post_title, $chars);
				}
				$post_excerpt = views_post_excerpt($post->post_excerpt, $post->post_content, $post->post_password, $chars);
				$temp = stripslashes($views_options['most_viewed_template']);
				$temp = str_replace("%VIEW_COUNT%", number_format_i18n($post_views), $temp);
				$temp = str_replace("%POST_TITLE%", $post_title, $temp);
				$temp = str_replace("%POST_EXCERPT%", $post_excerpt, $temp);
				$temp = str_replace("%POST_CONTENT%", $post->post_content, $temp);
				$temp = str_replace("%POST_URL%", get_permalink($post), $temp);
				$output .= $temp;
			}
		} else {
			$output = '<li>'.__('N/A', 'wp-postviews').'</li>'."\n";
		}
		if($display) {
			echo $output;
		} else {
			return $output;
		}
	}
}


### Function: Display Least Viewed Page/Post By Tag ID
if(!function_exists('get_least_viewed_tag')) {
	function get_least_viewed_tag($tag_id = 0, $mode = '', $limit = 10, $chars = 0, $display = true) {
		global $wpdb;
		$views_options = get_option('views_options');
		$where = '';
		$temp = '';
		$output = '';
		if(is_array($tag_id)) {
			$tag_sql = "$wpdb->term_taxonomy.term_id IN (".join(',', $tag_id).')';
		} else {
			$tag_sql = "$wpdb->term_taxonomy.term_id = $tag_id";
		}
		if(!empty($mode) && $mode != 'both') {
			$where = "post_type = '$mode'";
		} else {
			$where = '1=1';
		}
		$most_viewed = $wpdb->get_results("SELECT DISTINCT $wpdb->posts.*, (meta_value+0) AS views FROM $wpdb->posts LEFT JOIN $wpdb->postmeta ON $wpdb->postmeta.post_id = $wpdb->posts.ID INNER JOIN $wpdb->term_relationships ON ($wpdb->posts.ID = $wpdb->term_relationships.object_id) INNER JOIN $wpdb->term_taxonomy ON ($wpdb->term_relationships.term_taxonomy_id = $wpdb->term_taxonomy.term_taxonomy_id) WHERE post_date < '".current_time('mysql')."' AND $wpdb->term_taxonomy.taxonomy = 'post_tag' AND $tag_sql AND $where AND post_status = 'publish' AND meta_key = 'views' AND post_password = '' ORDER BY views ASC LIMIT $limit");
		if($most_viewed) {
			foreach ($most_viewed as $post) {
				$post_views = intval($post->views);
				$post_title = get_the_title($post);
				if($chars > 0) {
					$post_title = snippet_text($post_title, $chars);
				}
				$post_excerpt = views_post_excerpt($post->post_excerpt, $post->post_content, $post->post_password, $chars);
				$temp = stripslashes($views_options['most_viewed_template']);
				$temp = str_replace("%VIEW_COUNT%", number_format_i18n($post_views), $temp);
				$temp = str_replace("%POST_TITLE%", $post_title, $temp);
				$temp = str_replace("%POST_EXCERPT%", $post_excerpt, $temp);
				$temp = str_replace("%POST_CONTENT%", $post->post_content, $temp);
				$temp = str_replace("%POST_URL%", get_permalink($post), $temp);
				$output .= $temp;
			}
		} else {
			$output = '<li>'.__('N/A', 'wp-postviews').'</li>'."\n";
		}
		if($display) {
			echo $output;
		} else {
			return $output;
		}
	}
}


### Function: Display Total Views
if(!function_exists('get_totalviews')) {
	function get_totalviews($display = true) {
		global $wpdb;
		$total_views = intval($wpdb->get_var("SELECT SUM(meta_value+0) FROM $wpdb->postmeta WHERE meta_key = 'views'"));
		if($display) {
			echo number_format_i18n($total_views);
		} else {
			return $total_views;
		}
	}
}


### Function: Snippet Text
if(!function_exists('snippet_text')) {
	function snippet_text($text, $length = 0) {
		if (defined('MB_OVERLOAD_STRING')) {
		  $text = @html_entity_decode($text, ENT_QUOTES, get_option('blog_charset'));
		 	if (mb_strlen($text) > $length) {
				return htmlentities(mb_substr($text,0,$length), ENT_COMPAT, get_option('blog_charset')).'...';
		 	} else {
				return htmlentities($text, ENT_COMPAT, get_option('blog_charset'));
		 	}
		} else {
			$text = @html_entity_decode($text, ENT_QUOTES, get_option('blog_charset'));
		 	if (strlen($text) > $length) {
				return htmlentities(substr($text,0,$length), ENT_COMPAT, get_option('blog_charset')).'...';
		 	} else {
				return htmlentities($text, ENT_COMPAT, get_option('blog_charset'));
		 	}
		}
	}
}


### Function: Process Post Excerpt, For Some Reasons, The Default get_post_excerpt() Does Not Work As Expected
function views_post_excerpt($post_excerpt, $post_content, $post_password, $chars = 200) {
	if(!empty($post_password)) {
		if(!isset($_COOKIE['wp-postpass_'.COOKIEHASH]) || $_COOKIE['wp-postpass_'.COOKIEHASH] != $post_password) {
			return __('There is no excerpt because this is a protected post.', 'wp-postviews');
		}
	}
	if(empty($post_excerpt)) {
		return snippet_text(strip_tags($post_content), $chars);
	} else {
		return $post_excerpt;
	}
}


### Function: Modify Default WordPress Listing To Make It Sorted By Post Views
function views_fields($content) {
	global $wpdb;
	$content .= ", ($wpdb->postmeta.meta_value+0) AS views";
	return $content;
}
function views_join($content) {
	global $wpdb;
	$content .= " LEFT JOIN $wpdb->postmeta ON $wpdb->postmeta.post_id = $wpdb->posts.ID";
	return $content;
}
function views_where($content) {
	global $wpdb;
	$content .= " AND $wpdb->postmeta.meta_key = 'views'";
	return $content;
}
function views_orderby($content) {
	$orderby = trim(addslashes(get_query_var('v_orderby')));
	if(empty($orderby) || ($orderby != 'asc' && $orderby != 'desc')) {
		$orderby = 'desc';
	}
	$content = " views $orderby";
	return $content;
}


### Function: Add Views Custom Fields
add_action('publish_post', 'add_views_fields');
add_action('publish_page', 'add_views_fields');
function add_views_fields($post_ID) {
	global $wpdb;
	if(!wp_is_post_revision($post_ID)) {
		add_post_meta($post_ID, 'views', 0, true);
	}
}


### Function: Delete Views Custom Fields
add_action('delete_post', 'delete_views_fields');
function delete_views_fields($post_ID) {
	global $wpdb;
	if(!wp_is_post_revision($post_ID)) {
		delete_post_meta($post_ID, 'views');
	}
}


### Function: Views Public Variables
add_filter('query_vars', 'views_variables');
function views_variables($public_query_vars) {
	$public_query_vars[] = 'v_sortby';
	$public_query_vars[] = 'v_orderby';
	return $public_query_vars;
}


### Function: Sort Views Posts
add_action('pre_get_posts', 'views_sorting');
function views_sorting($local_wp_query) {
	if($local_wp_query->get('v_sortby') == 'views') {
		add_filter('posts_fields', 'views_fields');
		add_filter('posts_join', 'views_join');
		add_filter('posts_where', 'views_where');
		add_filter('posts_orderby', 'views_orderby');
	} else {
		remove_filter('posts_fields', 'views_fields');
		remove_filter('posts_join', 'views_join');
		remove_filter('posts_where', 'views_where');
		remove_filter('posts_orderby', 'views_orderby');
	}
}


### Function: Plug Into WP-Stats
add_action('wp','postviews_wp_stats');
function postviews_wp_stats() {
	if(function_exists('stats_page')) {
		if(strpos(get_option('stats_url'), $_SERVER['REQUEST_URI']) || strpos($_SERVER['REQUEST_URI'], 'stats-options.php') || strpos($_SERVER['REQUEST_URI'], 'wp-stats/wp-stats.php')) {
			add_filter('wp_stats_page_admin_plugins', 'postviews_page_admin_general_stats');
			add_filter('wp_stats_page_admin_most', 'postviews_page_admin_most_stats');
			add_filter('wp_stats_page_plugins', 'postviews_page_general_stats');
			add_filter('wp_stats_page_most', 'postviews_page_most_stats');
		}
	}
}


### Function: Add WP-PostViews General Stats To WP-Stats Page Options
function postviews_page_admin_general_stats($content) {
	$stats_display = get_option('stats_display');
	if($stats_display['views'] == 1) {
		$content .= '<input type="checkbox" name="stats_display[]" id="wpstats_views" value="views" checked="checked" />&nbsp;&nbsp;<label for="wpstats_views">'.__('WP-PostViews', 'wp-postviews').'</label><br />'."\n";
	} else {
		$content .= '<input type="checkbox" name="stats_display[]" id="wpstats_views" value="views" />&nbsp;&nbsp;<label for="wpstats_views">'.__('WP-PostViews', 'wp-postviews').'</label><br />'."\n";
	}
	return $content;
}


### Function: Add WP-PostViews Top Most/Highest Stats To WP-Stats Page Options
function postviews_page_admin_most_stats($content) {
	$stats_display = get_option('stats_display');
	$stats_mostlimit = intval(get_option('stats_mostlimit'));
	if($stats_display['viewed_most_post'] == 1) {
		$content .= '<input type="checkbox" name="stats_display[]" id="wpstats_viewed_most_post" value="viewed_most_post" checked="checked" />&nbsp;&nbsp;<label for="wpstats_viewed_most_post">'.sprintf(_n('%s Most Viewed Post', '%s Most Viewed Posts', $stats_mostlimit, 'wp-postviews'), number_format_i18n($stats_mostlimit)).'</label><br />'."\n";
	} else {
		$content .= '<input type="checkbox" name="stats_display[]" id="wpstats_viewed_most_post" value="viewed_most_post" />&nbsp;&nbsp;<label for="wpstats_viewed_most_post">'.sprintf(_n('%s Most Viewed Post', '%s Most Viewed Posts', $stats_mostlimit, 'wp-postviews'), number_format_i18n($stats_mostlimit)).'</label><br />'."\n";
	}
	if($stats_display['viewed_most_page'] == 1) {
		$content .= '<input type="checkbox" name="stats_display[]" id="wpstats_viewed_most_page" value="viewed_most_page" checked="checked" />&nbsp;&nbsp;<label for="wpstats_viewed_most_page">'.sprintf(_n('%s Most Viewed Page', '%s Most Viewed Pages', $stats_mostlimit, 'wp-postviews'), number_format_i18n($stats_mostlimit)).'</label><br />'."\n";
	} else {
		$content .= '<input type="checkbox" name="stats_display[]" id="wpstats_viewed_most_page" value="viewed_most_page" />&nbsp;&nbsp;<label for="wpstats_viewed_most_page">'.sprintf(_n('%s Most Viewed Page', '%s Most Viewed Pages', $stats_mostlimit, 'wp-postviews'), number_format_i18n($stats_mostlimit)).'</label><br />'."\n";
	}
	return $content;
}


### Function: Add WP-PostViews General Stats To WP-Stats Page
function postviews_page_general_stats($content) {
	$stats_display = get_option('stats_display');
	if($stats_display['views'] == 1) {
		$content .= '<p><strong>'.__('WP-PostViews', 'wp-postviews').'</strong></p>'."\n";
		$content .= '<ul>'."\n";
		$content .= '<li>'.sprintf(_n('<strong>%s</strong> view was generated.', '<strong>%s</strong> views were generated.', get_totalviews(false), 'wp-postviews'), number_format_i18n(get_totalviews(false))).'</li>'."\n";
		$content .= '</ul>'."\n";
	}
	return $content;
}


### Function: Add WP-PostViews Top Most/Highest Stats To WP-Stats Page
function postviews_page_most_stats($content) {
	$stats_display = get_option('stats_display');
	$stats_mostlimit = intval(get_option('stats_mostlimit'));
	if($stats_display['viewed_most_post'] == 1) {
		$content .= '<p><strong>'.sprintf(_n('%s Most Viewed Post', '%s Most Viewed Posts', $stats_mostlimit, 'wp-postviews'), number_format_i18n($stats_mostlimit)).'</strong></p>'."\n";
		$content .= '<ul>'."\n";
		$content .= get_most_viewed('post', $stats_mostlimit, 0, false);
		$content .= '</ul>'."\n";
	}
	if($stats_display['viewed_most_page'] == 1) {
		$content .= '<p><strong>'.sprintf(_n('%s Most Viewed Page', '%s Most Viewed Pages', $stats_mostlimit, 'wp-postviews'), number_format_i18n($stats_mostlimit)).'</strong></p>'."\n";
		$content .= '<ul>'."\n";
		$content .= get_most_viewed('page', $stats_mostlimit, 0, false);
		$content .= '</ul>'."\n";
	}
	return $content;
}


### Function: Increment Post Views
add_action('wp_ajax_postviews', 'increment_views');
add_action('wp_ajax_nopriv_postviews', 'increment_views');
function increment_views() {
	global $wpdb;
	if(!empty($_GET['postviews_id']))
	{
		$post_id = intval($_GET['postviews_id']);
		if($post_id > 0 && defined('WP_CACHE') && WP_CACHE) {
			$post_views = get_post_custom($post_id);
			$post_views = intval($post_views['views'][0]);
			if(!update_post_meta($post_id, 'views', ($post_views + 1))) {
				add_post_meta($post_id, 'views', 1, true);
			}
			echo ($post_views + 1);
		}
	}
	exit();
}

### Function Show Post Views Column in WP-Admin
add_action('manage_posts_custom_column', 'add_postviews_column_content', 5, 2);
add_filter('manage_posts_columns', 'add_postviews_column', 5, 2);
function add_postviews_column( $defaults ) {
    $defaults['viewscolumn'] = 'Views';
    return $defaults;
}


### Functions Fill In The Views Count
function add_postviews_column_content($column_name) {
    if( $column_name == 'viewscolumn' ) {
        if(function_exists('the_views')) { the_views(); }
    }
}


### Class: WP-PostViews Widget
 class WP_Widget_PostViews extends WP_Widget {
	// Constructor
	function WP_Widget_PostViews() {
		$widget_ops = array('description' => __('WP-PostViews views statistics', 'wp-postviews'));
		$this->WP_Widget('views', __('Views', 'wp-postviews'), $widget_ops);
	}

	// Display Widget
	function widget($args, $instance) {
		extract($args);
		$title = apply_filters('widget_title', esc_attr($instance['title']));
		$type = esc_attr($instance['type']);
		$mode = esc_attr($instance['mode']);
		$limit = intval($instance['limit']);
		$chars = intval($instance['chars']);
		$cat_ids = explode(',', esc_attr($instance['cat_ids']));
		echo $before_widget.$before_title.$title.$after_title;
		echo '<ul>'."\n";
		switch($type) {
			case 'least_viewed':
				get_least_viewed($mode, $limit, $chars);
				break;
			case 'most_viewed':
				get_most_viewed($mode, $limit, $chars);
				break;
			case 'most_viewed_category':
				get_most_viewed_category($cat_ids, $mode, $limit, $chars);
				break;
			case 'least_viewed_category':
				get_least_viewed_category($cat_ids, $mode, $limit, $chars);
				break;
		}
		echo '</ul>'."\n";
		echo $after_widget;
	}

	// When Widget Control Form Is Posted
	function update($new_instance, $old_instance) {
		if (!isset($new_instance['submit'])) {
			return false;
		}
		$instance = $old_instance;
		$instance['title'] = strip_tags($new_instance['title']);
		$instance['type'] = strip_tags($new_instance['type']);
		$instance['mode'] = strip_tags($new_instance['mode']);
		$instance['limit'] = intval($new_instance['limit']);
		$instance['chars'] = intval($new_instance['chars']);
		$instance['cat_ids'] = strip_tags($new_instance['cat_ids']);
		return $instance;
	}

	// DIsplay Widget Control Form
	function form($instance) {
		global $wpdb;
		$instance = wp_parse_args((array) $instance, array('title' => __('Views', 'wp-postviews'), 'type' => 'most_viewed', 'mode' => 'both', 'limit' => 10, 'chars' => 200, 'cat_ids' => '0'));
		$title = esc_attr($instance['title']);
		$type = esc_attr($instance['type']);
		$mode = esc_attr($instance['mode']);
		$limit = intval($instance['limit']);
		$chars = intval($instance['chars']);
		$cat_ids = esc_attr($instance['cat_ids']);
?>
		<p>
			<label for="<?php echo $this->get_field_id('title'); ?>"><?php _e('Title:', 'wp-postviews'); ?> <input class="widefat" id="<?php echo $this->get_field_id('title'); ?>" name="<?php echo $this->get_field_name('title'); ?>" type="text" value="<?php echo $title; ?>" /></label>
		</p>
		<p>
			<label for="<?php echo $this->get_field_id('type'); ?>"><?php _e('Statistics Type:', 'wp-postviews'); ?>
				<select name="<?php echo $this->get_field_name('type'); ?>" id="<?php echo $this->get_field_id('type'); ?>" class="widefat">
					<option value="least_viewed"<?php selected('least_viewed', $type); ?>><?php _e('Least Viewed', 'wp-postviews'); ?></option>
					<option value="least_viewed_category"<?php selected('least_viewed_category', $type); ?>><?php _e('Least Viewed By Category', 'wp-postviews'); ?></option>
					<optgroup>&nbsp;</optgroup>
					<option value="most_viewed"<?php selected('most_viewed', $type); ?>><?php _e('Most Viewed', 'wp-postviews'); ?></option>
					<option value="most_viewed_category"<?php selected('most_viewed_category', $type); ?>><?php _e('Most Viewed By Category', 'wp-postviews'); ?></option>
				</select>
			</label>
		</p>
		<p>
			<label for="<?php echo $this->get_field_id('mode'); ?>"><?php _e('Include Views From:', 'wp-postviews'); ?>
				<select name="<?php echo $this->get_field_name('mode'); ?>" id="<?php echo $this->get_field_id('mode'); ?>" class="widefat">
					<option value="both"<?php selected('both', $mode); ?>><?php _e('Posts &amp; Pages', 'wp-postviews'); ?></option>
					<option value="post"<?php selected('post', $mode); ?>><?php _e('Posts Only', 'wp-postviews'); ?></option>
					<option value="page"<?php selected('page', $mode); ?>><?php _e('Pages Only', 'wp-postviews'); ?></option>
				</select>
			</label>
		</p>
		<p>
			<label for="<?php echo $this->get_field_id('limit'); ?>"><?php _e('No. Of Records To Show:', 'wp-postviews'); ?> <input class="widefat" id="<?php echo $this->get_field_id('limit'); ?>" name="<?php echo $this->get_field_name('limit'); ?>" type="text" value="<?php echo $limit; ?>" /></label>
		</p>
		<p>
			<label for="<?php echo $this->get_field_id('chars'); ?>"><?php _e('Maximum Post Title Length (Characters):', 'wp-postviews'); ?> <input class="widefat" id="<?php echo $this->get_field_id('chars'); ?>" name="<?php echo $this->get_field_name('chars'); ?>" type="text" value="<?php echo $chars; ?>" /></label><br />
			<small><?php _e('<strong>0</strong> to disable.', 'wp-postviews'); ?></small>
		</p>
		<p>
			<label for="<?php echo $this->get_field_id('cat_ids'); ?>"><?php _e('Category IDs:', 'wp-postviews'); ?> <span style="color: red;">*</span> <input class="widefat" id="<?php echo $this->get_field_id('cat_ids'); ?>" name="<?php echo $this->get_field_name('cat_ids'); ?>" type="text" value="<?php echo $cat_ids; ?>" /></label><br />
			<small><?php _e('Seperate mutiple categories with commas.', 'wp-postviews'); ?></small>
		</p>
		<p style="color: red;">
			<small><?php _e('* If you are not using any category statistics, you can ignore it.', 'wp-postviews'); ?></small>
		<p>
		<input type="hidden" id="<?php echo $this->get_field_id('submit'); ?>" name="<?php echo $this->get_field_name('submit'); ?>" value="1" />
<?php
	}
}


### Function: Init WP-PostViews Widget
add_action('widgets_init', 'widget_views_init');
function widget_views_init() {
	register_widget('WP_Widget_PostViews');
}


### Function: Post Views Options
add_action('activate_wp-postviews/wp-postviews.php', 'views_init');
function views_init() {
	postviews_textdomain();
	// Add Options
	$views_options = array();
	$views_options['count'] = 1;
	$views_options['exclude_bots'] = 0;	
	$views_options['display_home'] = 0;
	$views_options['display_single'] = 0;
	$views_options['display_page'] = 0;
	$views_options['display_archive'] = 0;
	$views_options['display_search'] = 0;
	$views_options['display_other'] = 0;
	$views_options['template'] = __('%VIEW_COUNT% views', 'wp-postviews');
	$views_options['most_viewed_template'] = '<li><a href="%POST_URL%"  title="%POST_TITLE%">%POST_TITLE%</a> - %VIEW_COUNT% '.__('views', 'wp-postviews').'</li>';
	add_option('views_options', $views_options, 'Post Views Options');
	// Veersion 1.50 Upgrade
	delete_option('widget_views_most_viewed');
}

/**
 * Retrieve paginated link for archive post pages.
 *
 * Technically, the function can be used to create paginated link list for any
 * area. The 'base' argument is used to reference the url, which will be used to
 * create the paginated links. The 'format' argument is then used for replacing
 * the page number. It is however, most likely and by default, to be used on the
 * archive post pages.
 *
 * The 'type' argument controls format of the returned value. The default is
 * 'plain', which is just a string with the links separated by a newline
 * character. The other possible values are either 'array' or 'list'. The
 * 'array' value will return an array of the paginated link list to offer full
 * control of display. The 'list' value will place all of the paginated links in
 * an unordered HTML list.
 *
 * The 'total' argument is the total amount of pages and is an integer. The
 * 'current' argument is the current page number and is also an integer.
 *
 * An example of the 'base' argument is "http://example.com/all_posts.php%_%"
 * and the '%_%' is required. The '%_%' will be replaced by the contents of in
 * the 'format' argument. An example for the 'format' argument is "?page=%#%"
 * and the '%#%' is also required. The '%#%' will be replaced with the page
 * number.
 *
 * You can include the previous and next links in the list by setting the
 * 'prev_next' argument to true, which it is by default. You can set the
 * previous text, by using the 'prev_text' argument. You can set the next text
 * by setting the 'next_text' argument.
 *
 * If the 'show_all' argument is set to true, then it will show all of the pages
 * instead of a short list of the pages near the current page. By default, the
 * 'show_all' is set to false and controlled by the 'end_size' and 'mid_size'
 * arguments. The 'end_size' argument is how many numbers on either the start
 * and the end list edges, by default is 1. The 'mid_size' argument is how many
 * numbers to either side of current page, but not including current page.
 *
 * It is possible to add query vars to the link by using the 'add_args' argument
 * and see {@link add_query_arg()} for more information.
 *
 * @since 2.1.0
 *
 * @param string|array $args Optional. Override defaults.
 * @return array|string String of page links or array of page links.
 */
function wp_custom_paginate_links( $args = '' ) {
	$defaults = array(
		'base' => '%_%', // http://example.com/all_posts.php%_% : %_% is replaced by format (below)
		'format' => '?page=%#%', // ?page=%#% : %#% is replaced by the page number
		'total' => 1,
		'current' => 0,
		'show_all' => false,
		'prev_next' => true,
		'prev_text' => __('&laquo; Previous'),
		'next_text' => __('Next &raquo;'),
		'end_size' => 1,
		'mid_size' => 2,
		'type' => 'plain',
		'add_args' => false, // array of query args to add
		'add_fragment' => ''
	);

	$args = wp_parse_args( $args, $defaults );
	extract($args, EXTR_SKIP);

	// Who knows what else people pass in $args
	$total = (int) $total;
	if ( $total < 2 )
		return;
	$current  = (int) $current;
	$end_size = 0  < (int) $end_size ? (int) $end_size : 1; // Out of bounds?  Make it the default.
	$mid_size = 0 <= (int) $mid_size ? (int) $mid_size : 2;
	$add_args = is_array($add_args) ? $add_args : false;
	$r = '';
	$page_links = array();
	$n = 0;
	$dots = false;

	if ( $prev_next && $current && 1 < $current ) :
		$link = str_replace('%_%', 2 == $current ? '' : $format, $base);
		$link = str_replace('%#%', $current - 1, $link);
		if ( $add_args )
			$link = add_query_arg( $add_args, $link );
		$link .= $add_fragment;
		$page_links[] = '<a class="prev page-numbers" href="' . esc_url( $link ) . '">' . $prev_text . '</a>';
	else:
		$page_links[] = '<a class="prev page-numbers" href="javascript:;">' . $prev_text . '</a>';
	endif; 
	for ( $n = 1; $n <= $total; $n++ ) :
		$n_display = sprintf("%02s", $n);
		if ( $n == $current ) :
			$page_links[] = "<span class='page-numbers current'>$n_display</span>";
			$dots = true;
		else :
			if ( $show_all || ( $n <= $end_size || ( $current && $n >= $current - $mid_size && $n <= $current + $mid_size ) || $n > $total - $end_size ) ) :
				$link = str_replace('%_%', 1 == $n ? '' : $format, $base);
				$link = str_replace('%#%', $n, $link);
				if ( $add_args )
					$link = add_query_arg( $add_args, $link );
				$link .= $add_fragment;
				$page_links[] = "<a class='page-numbers' href='" . esc_url( apply_filters( 'paginate_links', $link ) ) . "'>$n_display</a>";
				$dots = true;
			elseif ( $dots && !$show_all ) :
				$page_links[] = '<span class="page-numbers dots">' . __( '&hellip;' ) . '</span>';
				$dots = false;
			endif;
		endif;
	endfor;
	if ( $prev_next && $current && ( $current < $total || -1 == $total ) ) :
		$link = str_replace('%_%', $format, $base);
		$link = str_replace('%#%', $current + 1, $link);
		if ( $add_args )
			$link = add_query_arg( $add_args, $link );
		$link .= $add_fragment;
		$page_links[] = '<a class="next page-numbers" href="' . esc_url( apply_filters( 'paginate_links', $link ) ) . '">' . $next_text . '</a>';
	else:
		$page_links[] = '<a class="next page-numbers" href="javascript:;">' . $next_text . '</a>';
	endif;
	switch ( $type ) :
		case 'array' :
			return $page_links;
			break;
		case 'list' :
			$r .= "<ul class='page-numbers'>\n\t<li>";
			$r .= join("</li>\n\t<li>", $page_links);
			$r .= "</li>\n</ul>\n";
			break;
		default :
			$r = join("\n", $page_links);
			break;
	endswitch;
	return $r;
}

function wp_custom_corenavi() {
    global $wp_query, $wp_rewrite;
    $pages = '';
    $max = $wp_query->max_num_pages;
    if (!$current = get_query_var('paged')) $current = 1;
    $a['base'] = str_replace(999999999, '%#%', get_pagenum_link(999999999));
    $a['total'] = $max;
    $a['current'] = $current;

    $total = 1; //1 - display the text "Page N of N", 0 - not display
    $a['mid_size'] = 1; //how many links to show on the left and right of the current
    if ($current <= 4) {
    	$a['mid_size'] += 6-$current;
    }
    $a['end_size'] = 3; //how many links to show in the beginning and end
    if ($max-$current <= 4) {
    	$a['mid_size'] += 5-($max-$current);
	}
    $a['prev_text'] = '<span class="prev">&nbsp;</span>'; //text of the "Previous page" link
    $a['next_text'] = '<span class="next">&nbsp;</span>'; //text of the "Next page" link

    if ($max > 1) echo '<div class="navigation">';
    //if ($total == 1 && $max > 1) $pages = '<span class="pages">Page ' . $current . ' of ' . $max . '</span>'."\r\n";
    echo $pages . wp_custom_paginate_links($a);
    if ($max > 1) echo '</div>';
}


/*class WPBakeryShortCode_vtblock extends WPBakeryShortCode {

  

    protected function content($atts, $content = null) {

        extract(shortcode_atts(array(
            'text_block' => '',
            'object_block' => ''
        ), $atts));


	$vtblock = '<div id="thumbs">
			<section>
				<div id="theme">'.$text_block.'</div>
				<div id="video-main">'.$object_block.'
				</div>
			</section>
			<div class="clear"></div>
			</div><div class="vblock_divider"></div>';	
        
        
        $vtblock = $this->startRow($el_position) . $vtblock . $this->endRow($el_position);
        return $vtblock;
    }
}*/
