<?php 

/**
 * The Header for our theme.
 *
 * Displays all of the <head> section and everything up till <div id="main">
 *
 * @package WordPress
 * @subpackage Twenty_Ten
 * @since Twenty Ten 1.0
 */
 
?><!DOCTYPE html>
<html <?php language_attributes(); ?>>
<head>
<meta name="viewport" content="width=device-width, initial-scale=1, maximum-scale=1">
<meta charset="<?php bloginfo( 'charset' ); ?>" />
<title><?php
	/*
	 * Print the <title> tag based on what is being viewed.
	 */
	global $page, $paged, $path_img, $theme_style, $theme_layout, $slider_type, $nav_type, $ns_options_frnt;
	$template_path = get_template_directory_uri();

	wp_title( '|', true, 'right' );

	// Add the blog name.
	bloginfo( 'name' );

	// Add the blog description for the home/front page.
	$site_description = get_bloginfo( 'description', 'display' );
	if ( $site_description && ( is_home() || is_front_page() ) )
		echo " | $site_description";

	// Add a page number if necessary:
	if ( $paged >= 2 || $page >= 2 )
		echo ' | ' . sprintf( __( 'Page %s', 'ns_theme' ), max( $paged, $page ) );

	?></title>
<link rel="profile" href="http://gmpg.org/xfn/11" />
<link rel="stylesheet" type="text/css" media="all" href="<?php bloginfo( 'stylesheet_url' ); ?>" />
<link rel="pingback" href="<?php bloginfo( 'pingback_url' ); ?>" />

<?php /* <link rel="stylesheet" href="<?php echo $template_path?>/stylesheets/960_16_col.css" type="text/css" media="screen, projection" />  */ ?>
<link rel="stylesheet" href="<?php echo get_template_directory_uri()?>/stylesheets/ch.css">

<?php 
	$cur_template = get_current_template();
include('common_header.php');
	echo '<!-- 111 -->';
			// get_template_part('common_header');
	echo '<!-- 111 -->';
			wp_enqueue_script("jquery"); 
			wp_enqueue_script("jquery.mobile.customized.min", $template_path."/javascripts/jquery.mobile.customized.min.js");
			wp_enqueue_script("jquery.easing.1.3", $template_path."/javascripts/jquery.easing.1.3.js");
			
			if($ns_options_frnt['ns_select_slider'] == 'default'){
				wp_enqueue_script("camera.min", $template_path."/javascripts/camera.min.js");
			}elseif($ns_options_frnt['ns_select_slider'] == 'onebyone'){				
				wp_enqueue_script("jquery.onebyone.min", $template_path."/javascripts/jquery.onebyone.min.js");
				wp_enqueue_script("jquery.touchwipe.min", $template_path."/javascripts/jquery.touchwipe.min.js");
			}
			
			wp_enqueue_script("jquery.backgroundpos", $template_path."/javascripts/jquery.backgroundpos.js");
			wp_enqueue_script("jFlyup", $template_path."/javascripts/jFlyup.js");
			wp_enqueue_script("main", $template_path."/javascripts/main.js");
			wp_enqueue_script("jquery.scrollTo-min", $template_path."/javascripts/jquery.scrollTo-min.js");
			
			wp_head();
?>

<!-- JAVASCRIPT -->
<script type="text/javascript">
  	jQuery(document).ready(function($){
		jQuery('a.content-top-button').click(function(e){
			e.preventDefault();
			jQuery.scrollTo('#top',{duration:500});
		});	
	});
	
</script>




<?php
	/* We add some JavaScript to pages with the comment form
	 * to support sites with threaded comments (when in use).
	 */
	if ( is_singular() && get_option( 'thread_comments' ) )
		wp_enqueue_script( 'comment-reply' );

	/* Always have wp_head() just before the closing </head>
	 * tag of your theme, or you will break many plugins, which
	 * generally use this hook to add elements to <head> such
	 * as styles, scripts, and meta tags.
	 */
	//wp_head();
?>

<?php include ("style-admin.php"); ?>
<?php if(isset($feature)){?>
<?php add_theme_support( $feature ); ?>
<?php } ?>

<?php if(isset($ns_options_frnt['cs_fullWidth']) && $ns_options_frnt['cs_fullWidth'] == 'enable'){ ?>
	<link rel="stylesheet" href="<?php echo get_template_directory_uri()?>/stylesheets/wide.css">
<?php } ?>
	<link rel="stylesheet" href="<?php echo get_template_directory_uri()?>/stylesheets/styles.php?<?php echo time(); ?>&amp;cur=<?php echo $cur_template; ?>">
</head>
<?php  
$class1 = ''; 

if(isset($class)){?>
<?php  $class1 = $class; ?>

<?php } ?>
<?php
	$page_bg = get_post_meta($post->ID, 'boxed_bg', true);
	
?>
<body <?php body_class( $class1 ); ?><?php if(isset($theme_style) && $theme_style == 'dark') { echo 'id="dark"'; }?> style="<?php if((isset($ns_options_frnt['cs_boxed_bg']) && $ns_options_frnt['cs_boxed_bg'] != '') || $page_bg) { echo 'background-repeat: '.($ns_options_frnt['tbi_bgProperties']?$ns_options_frnt['tbi_bgProperties']:'no-repeat').';background-position:'.($ns_options_frnt['tbi_horitontal']?$ns_options_frnt['tbi_horitontal']:'left').' '.($ns_options_frnt['tbi_vertical']?$ns_options_frnt['tbi_vertical']:'top').';background-attachment:'.($ns_options_frnt['tbi_bgattachment']?$ns_options_frnt['tbi_bgattachment']:'fixed').';background-image:url('.($page_bg?$page_bg:$ns_options_frnt['cs_boxed_bg']).');';}?><?php if(isset($ns_options_frnt['ns_bodyBgColor']) && $ns_options_frnt['ns_bodyBgColor'] != '') { echo 'background-color:#'.$ns_options_frnt['ns_bodyBgColor'].'';}?>">
	<?php if(isset($ns_options_frnt['cs_fullWidth']) && $ns_options_frnt['cs_fullWidth'] == 'enable'){ ?>
		<div id="full-width">
	<?php }else{ ?>
	<div class="pageContainer  <?php if(((isset($ns_options_frnt['cs_boxed_bg']) && $ns_options_frnt['cs_boxed_bg'] != '') || $page_bg) || isset($ns_options_frnt['ns_bodyBgColor']) && $ns_options_frnt['ns_bodyBgColor'] != '') { echo 'shadow';}?>">
	<?php } ?>
			<header>
				<div id="header">
					
					<div id="logo"><a  href="<?php echo home_url(); ?>"><?php echo $ns_options_frnt['logo_customLogo_field']?'<img src="'.$ns_options_frnt['logo_customLogo_field'].'" />':''?><h2><?php if(isset($ns_options_frnt['logo_salogan_field']) && $ns_options_frnt['logo_salogan_field'] != '') { echo $ns_options_frnt['logo_salogan_field'];}?></h2></a></div>
					<nav id="main-nav">
					
						
							<div id="drop-down-nav">
								<?php ns_theme_nav(); ?>
								
							</div>
						
						
					</nav>
					<div class="clear"></div>
					
					
					
					
				</div>
			</header>
