<?php

/**
 * The Header for our theme.
 *
 * Displays all of the <head> section and everything up till <div id="main">
 *
 * @package WordPress
 * @subpackage Twenty_Ten
 * @since Twenty Ten 1.0
 */

?><!DOCTYPE html>
<html <?php language_attributes(); ?>>
<head>
<meta name="viewport" content="width=device-width, initial-scale=1, maximum-scale=1">
<meta charset="<?php bloginfo( 'charset' ); ?>" />
<title><?php
	/*
	 * Print the <title> tag based on what is being viewed.
	 */
	
	global $page, $paged, $theme_style, $theme_layout, $slider_type, $nav_type, $ns_options_frnt,$add_onebyone;
	//$add_onebyone = false;
	$template_path = get_template_directory_uri();
	wp_title( '|', true, 'right' );

	// Add the blog name.
	bloginfo( 'name' );

	// Add the blog description for the home/front page.
	$site_description = get_bloginfo( 'description', 'display' );
	if ( $site_description && ( is_home() || is_front_page() ) )
		echo " | $site_description";

	// Add a page number if necessary:
	if ( $paged >= 2 || $page >= 2 )
		echo ' | ' . sprintf( __( 'Page %s', 'ns_theme' ), max( $paged, $page ) );

	?></title>
<link rel="profile" href="http://gmpg.org/xfn/11" />
<link rel="stylesheet" type="text/css" media="all" href="<?php bloginfo( 'stylesheet_url' ); ?>" />
<link rel="pingback" href="<?php bloginfo( 'pingback_url' ); ?>" />


<?php /* <link rel="stylesheet" href="<?php echo get_template_directory_uri()?>/stylesheets/960_16_col.css" type="text/css" media="screen, projection" />  */ ?>
<link rel="stylesheet" href="<?php echo get_template_directory_uri()?>/stylesheets/ch.css">
<link rel="stylesheet" href="<?php echo get_template_directory_uri()?>/css/prettyPhoto.css" type="text/css" media="screen, projection" />


<?php /* <link rel="stylesheet" href="<?php echo get_template_directory_uri()?>/stylesheets/css/camera.css"> */ ?>
<link rel="stylesheet" href="<?php echo get_template_directory_uri()?>/stylesheets/css/ig.css">

<?php
	$cur_template = get_current_template();
	get_template_part('common_header');
	
	
		wp_enqueue_script("jquery"); 
			wp_enqueue_script("jquery.mobile.customized.min", $template_path."/javascripts/jquery.mobile.customized.min.js");
			wp_enqueue_script("jquery.easing.1.3", $template_path."/javascripts/jquery.easing.1.3.js");
			wp_enqueue_script("camera.min", $template_path."/javascripts/camera.min.js");
			wp_enqueue_script("jquery.backgroundpos", $template_path."/javascripts/jquery.backgroundpos.js");
			wp_enqueue_script("jFlyup", $template_path."/javascripts/jFlyup.js");
			wp_enqueue_script("main", $template_path."/javascripts/main.js");
			wp_enqueue_script("jquery.scrollTo-min", $template_path."/javascripts/jquery.scrollTo-min.js");
			wp_enqueue_script("jquery.prettyPhoto", $template_path."/javascripts/jquery.prettyPhoto.js");
			if ($cur_template=='portfolio.php'){
				//wp_enqueue_script("jquery.quicksand", $template_path."/javascripts/jquery.quicksand.js");	
				
				//wp_enqueue_script("application", $template_path."/javascripts/old/application.js");
				wp_enqueue_script("jquery.isotope.min", $template_path."/javascripts/jquery.isotope.min.js");
			}
			wp_head();

?>

<!-- JAVASCRIPT -->

<?php
	/* We add some JavaScript to pages with the comment form
	 * to support sites with threaded comments (when in use).
	 */
	if ( is_singular() && get_option( 'thread_comments' ) )
		wp_enqueue_script( 'comment-reply' );

	/* Always have wp_head() just before the closing </head>
	 * tag of your theme, or you will break many plugins, which
	 * generally use this hook to add elements to <head> such
	 * as styles, scripts, and meta tags.
	 */
	wp_head();
?>

<script>
	jQuery(document).ready(function($){
		jQuery('a.content-top-button').click(function(e){
			e.preventDefault();
			jQuery.scrollTo('#top',{duration:500});
		});
		if (jQuery.browser.safari) {
			jQuery('#header').addClass('sf-position');		
		  }	 
	});
</script>

<?php include ("style-admin.php"); ?>

<link rel="stylesheet" href="<?php echo get_template_directory_uri()?>/stylesheets/styles.php?<?php echo time(); ?>&amp;cur=<?php echo $cur_template; ?>">
<?php
	if ($cur_template=='portfolio.php'){
        	$cat_slug = $ns_options_frnt['ns_pf_cat_slug'];
			$cat_id = get_category_by_slug($cat_slug); 
			$id = $cat_id->term_id;
			
			$args = array(
							'type'			=> 'post',
							'child_of'      => $id,
							'parent'        => '',
							'orderby'       => 'name',
							'order'         => 'ASC',
							'hide_empty'    => 0,
							'hierarchical'  => 1,
							'exclude'       => '',
							'include'       => '',
							'number'        => '',
							'taxonomy'      => 'category',
							'pad_counts'    => false
						);
			$portfolio_categories =  get_categories($args); 
			
?>


<script type="text/javascript" charset="utf-8">
    jQuery(document).ready(function(jQuery){
        jQuery("a[rel^='prettyPhoto']").prettyPhoto();
        jQuery("a[rel^='prettyPhotoVid']").prettyPhoto({
        	default_width: 605,
			default_height: 344});
    });
</script>




<script type="text/javascript">
  /*jQuery(document).ready(function($){
	jQuery(".twitter-list").tweet({        
		  join_text: "auto",
          username: "envatowebdesign",		
          count: 2
        });
	})*/
</script>

<script>
	jQuery(document).ready(function($){
		if ($.browser.safari) {
			jQuery('#header').addClass('sf-position');		
		  }	 
	});
</script>

<?php } ?>
<?php if(isset($feature)){?>
<?php add_theme_support( $feature ); ?>
<?php } ?>

<?php if(isset($ns_options_frnt['cs_fullWidth']) && $ns_options_frnt['cs_fullWidth'] == 'enable'){ ?>
	<link rel="stylesheet" href="<?php echo get_template_directory_uri()?>/stylesheets/wide.css">
<?php } ?>

<script src="<?php echo get_template_directory_uri()?>/javascripts/isotop.js" type="text/javascript"></script>
<script src="<?php echo get_template_directory_uri()?>/javascripts/transit.js" type="text/javascript"></script>


<link rel="stylesheet" href="<?php echo get_template_directory_uri()?>/css/ios.css"/>


</head>
<?php  
$class1 = ''; 
if(isset($class)){?>
<?php  $class1 = $class; ?>
<?php } ?>
<?php
	$page_bg = get_post_meta($post->ID, 'boxed_bg', true);
	
?>
<body <?php body_class( $class1 ); ?><?php if(isset($theme_style) && $theme_style == 'dark') { echo 'id="dark"'; }?> style="<?php if((isset($ns_options_frnt['cs_boxed_bg']) && $ns_options_frnt['cs_boxed_bg'] != '') || $page_bg) { echo 'background-repeat: '.($ns_options_frnt['tbi_bgProperties']?$ns_options_frnt['tbi_bgProperties']:'no-repeat').';background-position:'.($ns_options_frnt['tbi_horitontal']?$ns_options_frnt['tbi_horitontal']:'left').' '.($ns_options_frnt['tbi_vertical']?$ns_options_frnt['tbi_vertical']:'top').';background-attachment:'.($ns_options_frnt['tbi_bgattachment']?$ns_options_frnt['tbi_bgattachment']:'fixed').';background-image:url('.($page_bg?$page_bg:$ns_options_frnt['cs_boxed_bg']).');';}?><?php if(isset($ns_options_frnt['ns_bodyBgColor']) && $ns_options_frnt['ns_bodyBgColor'] != '') { echo 'background-color:#'.$ns_options_frnt['ns_bodyBgColor'].'';}?>">
<?php if(isset($ns_options_frnt['cs_fullWidth']) && $ns_options_frnt['cs_fullWidth'] == 'enable'){ ?>
	<div id="full-width">
<?php }else{ ?>
<div class="pageContainer  <?php if(((isset($ns_options_frnt['cs_boxed_bg']) && $ns_options_frnt['cs_boxed_bg'] != '') || $page_bg) || isset($ns_options_frnt['ns_bodyBgColor']) && $ns_options_frnt['ns_bodyBgColor'] != '') { echo 'shadow';}?>">
<?php } ?>
<header class="pages 1<?php echo $cur_template ?>1  <?php echo $cur_template=='contact_us.php'?'contact':'' ?>">
		<div id="header" <?php echo $cur_template=='portfolio.php'?'class="pages"':''?>>
			<div id="logo"><a  href="<?php echo home_url(); ?>"><?php echo $ns_options_frnt['logo_customLogo_field']?'<img src="'.$ns_options_frnt['logo_customLogo_field'].'" />':''?><h2><?php if(isset($ns_options_frnt['logo_salogan_field']) && $ns_options_frnt['logo_salogan_field'] != '') { echo $ns_options_frnt['logo_salogan_field'];}?></h2></a></div>
			<nav id="main-nav">
			
				
					<div id="drop-down-nav">
						<?php ns_theme_nav(); ?>
						
					</div>
				
				
			</nav>
			
		</div><div class="clear"> </div>
	</header>
	<?php if ($cur_template!='video.php'){?>
	<div id="main-container" <?php echo $cur_template=='contact_us.php'?'':'class="intro"' ?>>
		<?php if(isset($ns_options_frnt['cs_fullWidth']) && $ns_options_frnt['cs_fullWidth'] == 'enable'){ ?>
			<div id="breadcrumb-bar-wide">
		<?php } ?>
				<div id="breadcrumb-bar" <?php echo $cur_template=='contact_us.php'?'class="contact"':'' ?>>
					<?php if(isset($ns_options_frnt['cs_bread_crumbs']) && $ns_options_frnt['cs_bread_crumbs']=='active') {
					?>
						<div id="breadcrumb"><?php $breadcrumbs_go = new simple_breadcrumb; ?></div>
					<?php } ?>
					<div class="socials">
					
					<?php if(isset($ns_options_frnt['cs_faceBook']) && $ns_options_frnt['cs_faceBook']=='enable') {?>
						<a class="facebook" href="<?php if(isset($ns_options_frnt['cs_pagefaceBookUrl']) && $ns_options_frnt['cs_faceBook']!='') { echo $ns_options_frnt['cs_pagefaceBookUrl']; }?>" title=""></a>
						
					<?php } ?>
					<?php if(isset($ns_options_frnt['cs_twitter']) && $ns_options_frnt['cs_twitter']=='enable') {?>
						<a class="twitter" href="<?php if(isset($ns_options_frnt['cs_pageTwitterUrl']) && $ns_options_frnt['cs_pageTwitterUrl']!='') { echo $ns_options_frnt['cs_pageTwitterUrl']; }?>" title=""></a>					
					<?php } ?>
					<?php if(isset($ns_options_frnt['cs_phone_info']) && $ns_options_frnt['cs_phone_info']!='') {?>
						<a class="skype" href="skype:<?php echo $ns_options_frnt['cs_phone_info']; ?>?call" title=""></a>
						
					<?php } ?>
					<?php if(isset($ns_options_frnt['cs_youtube']) && $ns_options_frnt['cs_youtube']=='enable') {?>
						<a class="youtube" href="<?php if(isset($ns_options_frnt['cs_pageyouTubeUrl']) && $ns_options_frnt['cs_pageyouTubeUrl']!='') { echo $ns_options_frnt['cs_pageyouTubeUrl']; }?>" title=""></a>				
					<?php } ?>
					</div>
				</div>
			<?php if(isset($ns_options_frnt['cs_fullWidth']) && $ns_options_frnt['cs_fullWidth'] == 'enable'){ ?>
				</div><!-- #breadcrumb-bar-wide -->
			<?php } ?>
				<div class="clear"></div>
				
		<?php if($cur_template!='contact_us.php'){?>
				<?php 
					$title_bg = get_post_custom_values('pagetitle_bg',$post->ID);
					if(!$title_bg[0]){
				?>	
				<?php if(isset($ns_options_frnt['cs_search_box']) && $ns_options_frnt['cs_search_box']=='enable'){ ?>
					<div id="search">
			
					<form role="search" method="get" id="searchform" action="<?php echo home_url(); ?>" >
						<input type="text" style="color:#<?php if($ns_options_frnt['tsc_topAreaTextColor']) echo $ns_options_frnt['tsc_topAreaTextColor']; else echo '000000';?>; opacity:0.5;" placeholder="Looking for something?" value="<?php echo get_search_query(); ?>" name="s">
						<input type="submit" value="">
					</form>
			
					</div>
				<?php }} ?>
				
				
				<h1 id="title" class="dark <?php if($title_bg[0]){ ?>title-bg<?php } ?>" <?php if($title_bg[0]){echo 'style="background: url('.$title_bg[0].') repeat-x top center"';}?>>
					<?php if($title_bg[0]){ ?>
						<span class="title-bg-box">
					<?php }else {?>
						<span>
					<?php }?>
					<?php  
						
						global $theme_layout, $ns_options_frnt, $post;
						$thePostID = $post->ID;
						$cat_id = get_category_by_slug($ns_options_frnt['ns_pf_cat_slug']); 
						$id = $cat_id->term_id;
						if( $cur_template=='index.php'){
							the_title();
						}elseif( $cur_template=='single.php'){
							if ( in_category( $id, $thePostID) || post_is_in_descendant_category( $id, $thePostID ) )
							{
								echo 'Gallery';
							}
							else
							{
								echo 'Blog';
							}
						}
						elseif($cur_template=='search.php'){
							echo 'Search';
						}else{
							if( is_category() ){
								single_cat_title();
							}elseif( is_archive() ){
								single_month_title(' ');
							}else{
								 the_title();
								
							}
						}
					?>
					
						</span>
					
				</h1>
				<div class="clear"></div>
	
	
				
    
    <?php
    	if(isset($ns_options_frnt['cs_feedbackButton']) && $ns_options_frnt['cs_feedbackButton'] != 'disable')
		{
	?>
		<a href="<?php if(isset($ns_options_frnt['cs_fbUrl']) && $ns_options_frnt['cs_fbUrl'] != '' ) { echo $ns_options_frnt['cs_fbUrl']; } ?>" class="feedback-btn"><img src="<?php echo $path_img; ?>/feedback-button.png" alt=""/></a>
	<?php	
        }
	?>
    
    
</div><!-- main-container end --><?php }?><?php }?>