<?php
/**
 * The loop that displays posts.
 *
 * The loop displays the posts and the post content.  See
 * http://codex.wordpress.org/The_Loop to understand it and
 * http://codex.wordpress.org/Template_Tags to understand
 * the tags used in it.
 *
 * This can be overridden in child themes with loop.php or
 * loop-template.php, where 'template' is the loop context
 * requested by a template. For example, loop-index.php would
 * be used if it exists and we ask for the loop with:
 * <code>get_template_part( 'loop', 'index' );</code>
 *
 * @package WordPress
 * @subpackage Twenty_Ten
 * @since Twenty Ten 1.0
 */
?>

<?php /* Display navigation to next/previous pages when applicable */ ?>
<?php /* 
<?php if ( $wp_query->max_num_pages > 1 ) : ?>
	<div id="nav-above" class="navigation">
		<div class="nav-previous"><?php next_posts_link( __( '<span class="meta-nav">&larr;</span> Older posts', 'ns_theme' ) ); ?></div>
		<div class="nav-next"><?php previous_posts_link( __( 'Newer posts <span class="meta-nav">&rarr;</span>', 'ns_theme' ) ); ?></div>
	</div><!-- #nav-above -->
<?php endif; ?>
 */?>
<?php /* If there are no posts to display, such as an empty archive page */ ?>
<?php if ( ! have_posts() ) : ?>
	<div id="post-0" class="post error404 not-found">
		<h1 class="entry-title"><?php _e( 'Not Found', 'ns_theme' ); ?></h1>
		<div class="entry-content">
			<p><?php _e( 'Apologies, but no results were found for the requested archive. Perhaps searching will help find a related post.', 'ns_theme' ); ?></p>
			<?php get_search_form(); ?>
		</div><!-- .entry-content -->
	</div><!-- #post-0 -->
<?php endif; ?>

<?php
	/* Start the Loop.
	 *
	 * In Twenty Ten we use the same loop in multiple contexts.
	 * It is broken into three main parts: when we're displaying
	 * posts that are in the gallery category, when we're displaying
	 * posts in the asides category, and finally all other posts.
	 *
	 * Additionally, we sometimes check for whether we are on an
	 * archive page, a search page, etc., allowing for small differences
	 * in the loop on each template without actually duplicating
	 * the rest of the loop that is shared.
	 *
	 * Without further ado, the loop:
	 */ ?>
<?php while ( have_posts() ) : the_post(); ?>

<?php /* How to display posts of the Gallery format. The gallery category is the old way. */ ?>

	<?php /* <div class="short-post">	
		<h1><a href="<?php the_permalink(); ?>"><?php the_title(); ?></a></h1>
		<!--<p class="post-date">Posted on October 25, 2011 <span class="bywho">by Aaron</span></p>-->
		<p class="post-date"><?php ns_posted_on(); ?><span class="bywho"><?php get_the_author(); ?></span></p>
		<a class="fancybox" href="#"><?php the_post_thumbnail('large');?></a>
		<p class="post-text"><?php the_content();//echo $post->post_content;//the_content(); ?></p>
		<p class="post-comments"><a href=""><?php comments_number( 0, 1, '%' ); ?> Comments, Latest: <span class="last-comment">
		
			<?php 
				$comment_args = array(
									'status' => 'approve',
									'number' => '1',
									'post_id' => $post->ID
								);
				$comments = get_comments($comment_args);
				foreach($comments as $comment) 
				{
					echo '&quot;'.substr($comment->comment_content, 0, 40).'...&quot; by '.$comment->comment_author; 
				}
			?>
		
		</span></a><a class="post-link" href="<?php the_permalink(); ?>">Read More</a></p>
	</div> */?> <!-- /.short-post -->
	
	<div class="blog-item">
		<div class="item-title">
			<?php /* <img src="images/link.jpg" alt="#"> */?>
			<h2 class="blue"><a href="<?php the_permalink(); ?>"><?php the_title(); ?></a></h2>
			<?php /* <div class="blog-info"><span>Date:</span> <span><?php the_time(get_option ('date_format') ) ?></span> <span class="spacer">|</span> <a href="#" title=""><?php the_author(); ?></a> <span class="spacer">|</span> <?php the_category( ', ', '', $post->ID ); ?> <span class="spacer">|</span> <a title="" href="<?php echo $post->guid?>"><?php echo $post->comment_count ? $post->comment_count : 0?>  Comments</a></div> */?>
			<div class="blog-info"><span>Date:</span> <span><?php the_time(get_option ('date_format') ) ?></span> <span class="spacer">|</span> <a href="#" title=""><?php the_author(); ?></a> <span class="spacer">|</span> <?php the_category( ', ', '', $post->ID ); ?> <span class="spacer">|</span> <?php comments_popup_link(); ?></div>
		</div>
		<div class="gall-hr hr"></div>
		<div class="tags"><?php the_tags(); ?></div>
		<article class="blog-entry">
			<?php the_content(false);//echo $post->post_content;//the_content(); ?>
			<a class="all" title="view all" href="<?php the_permalink(); ?>">view all</a>
		</article>
		<div class="clear"></div>
		<div class="blog-hr hr"></div>
	</div>

<?php endwhile; // End the loop. Whew. ?>





<?php /* Display navigation to next/previous pages when applicable */ ?>
<?php /* 
<?php if (  $wp_query->max_num_pages > 1 ) : ?>
				<div id="nav-below" class="navigation">
					<div class="nav-previous"><?php next_posts_link( __( '<span class="meta-nav">&larr;</span> Older posts', 'ns_theme' ) ); ?></div>
					<div class="nav-next"><?php previous_posts_link( __( 'Newer posts <span class="meta-nav">&rarr;</span>', 'ns_theme' ) ); ?></div>
				</div><!-- #nav-below -->
<?php endif; ?>
 */?>